#include <iostream>
#include <vector>
#include <unordered_set>
#include <algorithm>
#include <unordered_map>

using namespace std;

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
	short int n, m;
	cin >> n >> m;
	unordered_set<int>inds;
	vector<vector<pair<short int, bool>>>arr(n);
	vector<short int>ans(n);
	string s; cin >> s;
	for (short int i = 0; i < n; i++) {
		short int k; cin >> k;
		ans[i] = i;
		for (short int j = 0; j < k; j++) {
			short int ind; char c;
			cin >> ind >> c;
			ind--;
			inds.insert(ind);
			arr[i].push_back({ ind, (s[ind] == c) });
		}
	}
	if (inds.size() != m) {
		cout << -1;
		return 0;
	}
	vector<short int>used(m, 0);
	short int it = 1;
	do {
		bool flag = 0;
		short int sw = 0;
		for (short int i = 0; i < ans.size() && !flag && sw != m; i++) {
			for (short int j = 0; j < arr[ans[i]].size() && !flag && sw != m; j++) {
				if (used[arr[ans[i]][j].first] != it)
					if (!arr[ans[i]][j].second)
						flag = 1;
					else {
						used[arr[ans[i]][j].first] = it;
						sw++;
					}
			}
		}
		if (!flag) {
			if (sw == m) {
				for (auto i : ans)
					cout << i + 1 << ' ';
				return 0;
			}
		}
		it++;
	} while (next_permutation(ans.begin(), ans.end()));
	cout << -1;
	return 0;
}