#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()


int n, k, m;
string s;
const int N = 33;
int tab[N][N];

int pos = 0;

bool take(int x, int y) {
	x--, y--;

	if (x == 0 && y == 0) return 0;

	int x1 = x;
	while (x1 < n && tab[x1][y] == 0) {
		int y1 = y;
		while (y1 < n && tab[x1][y1] == 0) {
			tab[x1][y1] = 1;
			y1++;
		}
		x1++;
	}

	return 1;
}



int dp[N][N];
const int K = 6;

bool move() {
	vector<pii> mv;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = n - 1; j >= 0; j--) {
			if (tab[i][j]) {
				dp[i][j] = 0;
			} else {
				dp[i][j] = dp[i + 1][j] + dp[i][j + 1] - dp[i + 1][j + 1] + 1;
				if (dp[i][j] < K) mv.push_back({i, j});
			}
		}
	}

	int pw = 0;
	while ((1 << pw) <= mv.size()) pw++;
	pw--;

	if (pos + pw > m) pw = m - pos;

	int nmr = 0;
	for (int i = pos; i < pos + pw; i++) {
		if (s[i] == '1') {
			nmr ^= (1 << (i - pos));
		}
	}

	cout << mv[nmr].first + 1 << ' ' << mv[nmr].second + 1 << endl;

	pos += pw;
	return take(mv[nmr].first + 1, mv[nmr].second + 1);
}


void play(int p) {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			tab[i][j] = 0;
		}
	}

	if (pos >= m) {
		if (p == 1) {
			int x, y;
			cin >> x >> y;
			cout << 0 << endl;
			exit(0);
		}
	}

	bool f = 1;

	if (p == 0) f = move();

	while (f) {
		int x, y;
		cin >> x >> y;
		if (!take(x, y)) f = 0;
		if (f && !move()) f = 0;
	}
}


void solve1() {
	cin >> n >> k >> m >> s;

	int cnt = 0;
	while (pos < m) {
		play(cnt % 2);
		cnt++;
	}
	cout << "0" << endl;
}




















bool move2() {
	pii p2;
	cin >> p2.first >> p2.second;
	p2.first--, p2.second--;

	int nmr = 0;


	vector<pii> mv;
	for (int i = n - 1; i >= 0; i--) {
		for (int j = n - 1; j >= 0; j--) {
			if (tab[i][j]) {
				dp[i][j] = 0;
			} else {
				dp[i][j] = dp[i + 1][j] + dp[i][j + 1] - dp[i + 1][j + 1] + 1;
				if ((pii){i, j} == p2) nmr = mv.size();
				if (dp[i][j] < K) mv.push_back({i, j});
			}
		}
	}

	int pw = 0;
	while ((1 << pw) <= mv.size()) pw++;
	pw--;

	if (pos + pw > m) pw = m - pos;

	for (int i = pos; i < pos + pw; i++) {
		if ((nmr >> (i - pos)) & 1) {
			s[i] = '1';
		} else {
			s[i] = '0';
		}
	}

	pos += pw;
	return take(mv[nmr].first + 1, mv[nmr].second + 1);
}



void play2(int p) {
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < N; j++) {
			tab[i][j] = 0;
		}
	}


	bool f = 1;

	if (p == 0) f = move2();

	while (f) {
		int x, y;
		cin >> x >> y;
		if (!take(x, y)) f = 0;
		if (f && !move2()) f = 0;
	}
}



void solve2() {
	cin >> n >> k >> m;

	int cnn;
	cin >> cnn;

	s.resize(m);

	int cnt = 0;
	while (pos < m) {
		play2(cnt % 2);
		cnt++;
	}
	cout << s << '\n';
}


signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int t;
	cin >> t;
	if (t == 1) {
		solve1();
	} else {
		solve2();
	}


	return 0;
}