#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define all(a) a.begin(), a.end()
#define f first
#define s second

const int maxn = 20;
int n, cnt;
vector<int> g[maxn];
int pr[maxn], cnt2[maxn];
int p[maxn], c[maxn];
bool used[maxn];
vector<int> a[maxn];
vector<int> kek[maxn];

pair<int, int> check(int pos) {
    if (g[pos].size() == 0) {
        return {c[pos], c[pos]};
    }
    vector<pair<pair<int, int>, int>> p;
    for (auto u: g[pos]) {
        p.pb({check(u), u});
    }
    sort(all(p));
    if (p[0].f.f == -1) {
        return p[0].f;
    }
    for (int i = 1; i < p.size(); ++i) {
        if (p[i - 1].f.s > p[i].f.f) {
            return {-1, -1};
        }
    }
    kek[pos].clear();
    for (int i = 0; i < p.size(); ++i) {
        kek[pos].pb(p[i].s);
    }
    return {p[0].f.f, p.back().f.s};
}

void gen(int pos) {
    if (pos == cnt) {
        int val = 0;
        for (int i = 0; i < cnt; ++i) {
            int p1 = lower_bound(all(a[p[i]]), val) - a[p[i]].begin();
            if (p1 == a[p[i]].size()) {
                return;
            }
            c[p[i]] = val = a[p[i]][p1];
        }
        if (check(0).f == -1) {
            return;
        }
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            if (g[i].size()) {
                for (auto k: kek[i]) {
                    cout << k + 1 << ' ';
                }
                cout << '\n';
            } else {
                cout << c[i] << '\n';
            }
        }
        exit(0);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && g[i].size() == 0) {
            used[i] = 1;
            p[pos] = i;
            gen(pos + 1);
            used[i] = 0;
        }
    }
}

int dfs(int v, int mn) {
    if (g[v].size() == 0) {
        int p1 = lower_bound(all(a[v]), mn) - a[v].begin();
        if (p1 == a[v].size()) {
            return -1;
        }
        return a[v][p1];
    }
    if (g[v].size() == 1) {
        return dfs(g[v][0], mn);
    }
    int mx1 = dfs(g[v][0], mn);
    int val = -1;
    if (mx1 != -1) {
        val = dfs(g[v][1], mx1);
    }
    mx1 = dfs(g[v][1], mn);
    if (mx1 != -1) {
        int v = dfs(g[v][0], mx1);
        if (v != -1 && (val == -1 || val > v)) {
            return v;
        }
    }
    return val;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            cnt2[i] = k;
            while (k--) {
                int v;
                cin >> v;
                v--;
                g[i].pb(v);
                pr[v] = i;
            }
        } else {
            cnt++;
            int m;
            cin >> m;
            while (m--) {
                int val;
                cin >> val;
                a[i].pb(val);
            }
            sort(all(a[i]));
        }
    }
    if (n <= 10) {
        gen(0);
        cout << "No";
    } else {
        if (dfs(0, 0) != -1) {
            cout << "Yes";
        } else {
            cout << "No";
        }
    }
    return 0;
}