#include <bits/stdc++.h>

#define ll long long
#define ld double
#define ft first
#define sd second
#define pb push_back

using namespace std;

ll k, n;
bool a[26][26];
ll dp[5000][5000];
vector <ll> lst[26];
string s;
bool get(ll l, ll r) {
    if (l > r) return 0;
    if (l == r) return 1;
    if (dp[l][r] != -1) return dp[l][r];
    dp[l][r] = 0;
    for (ll i = l + 1; i <= r; ++i) {
        if (a[s[l] - 'a'][s[i] - 'a'] && get(l, i - 1) && get(i, r)) {
            dp[l][r] = 1;
            break;
        }
    }
    return dp[l][r];
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef FREOPEN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> k >> n;
    for (ll i = 0; i < k; ++i) {
        for (ll j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    string cur[n];
    cin >> s;
    for (ll i = 0; i < n; ++i) {
        fill(dp[i], dp[i] + n, -1);
    }
    cur[0] += s[0];
    for (ll i = 1; i < n; ++i) {
        for (ll j = 0; j < i; ++j) {
            if (get(j, i - 1) && (cur[i].empty() || cur[i] > cur[j] + s[i])) {
                cur[i] = cur[j] + s[i];
            }
        }
    }
    string ans;

    for (ll i = 0; i < n; ++i) {
        if (!cur[i].empty() && get(i, n - 1) && (ans.empty() || ans > cur[i]))
            ans = cur[i];
    }
    cout << ans;
    return 0;
}
