#include <bits/stdc++.h>
#define int long long

#define pii pair<int, int>

#define ff first 
#define ss second

#define pb push_back 

#define data data228 

#define all(x) (x).begin(), (x).end()

using namespace std; 
const int maxn = 1e6 + 7; 
int n; 
vector<int> gr[maxn];  
vector<int> leaf[maxn]; 

int L[maxn];
int R[maxn];

struct node {
    int l, r, id; 
};

bool dfs(int u) {
    vector<node> x; 
    for (auto v : gr[u]) {
        dfs(v); 
        x.pb({L[v], R[v], v}); 
    }
    sort(all(x), [&](node a, node b) {
        return a.l < b.l; 
    }); 
    bool ok = true;
    for (int i = 1; i < (int)x.size(); ++i) {
        if (x[i - 1].r >= x[i].l) {
            ok = false;
            break;             
        }
    }
    if (x.size()) {
        L[u] = x[0].l; 
        R[u] = x.back().r; 
    }
    return ok; 
}

vector<int> res[maxn];
vector<int> xx; 

void dfs_calc(int u) {
    vector<node> x; 
    for (auto v : gr[u]) {
        dfs_calc(v); 
        x.pb({L[v], R[v], v}); 
    }
    sort(all(x), [&](node a, node b) {
        return a.l < b.l; 
    }); 
    for (auto v : x) {
        res[u].pb(v.id); 
    }
    if (x.size()) {
        L[u] = x[0].l; 
        R[u] = x.back().r; 
    }
    if (x.empty()) {
        res[u].pb(xx[L[u]]); 
    }
}


void solve() {
    cin >> n; 
    vector<int> vertex; 
    for (int i = 0; i < n; ++i) {
        int type; cin >> type;
        if (type == 2) {
            vertex.pb(i); 
        }
        int k; cin >> k; 
        for (int j = 0; j < k; ++j) {
            int x; cin >> x;
            --x; 
            if (type == 1) {
                gr[i].pb(x);
            } else {
                leaf[i].pb(x); 
                xx.pb(x); 
            }
        }
    }
    sort(all(xx)); 
    for (auto v : vertex) {
        for (auto &u : leaf[v]) {
            u = lower_bound(all(xx), u) - xx.begin(); 
        }
    }
//    for (auto v : xx) cout << v << " "; 
//    return; 
    for (int mask = 0; mask < (1 << (int)xx.size()); ++mask) {
        int sz = xx.size();
        {
        vector<int> used(sz, 0); 
        for (int bt = 0; bt < sz; ++bt) {
            if (!((mask >> bt) & 1)) continue; 
            used[bt] = 1; 
//            cout << bt << '\n'; 
        }        
        bool ok = true; 
        for (auto v : vertex) {
            int pt = 0; 
            for (auto x : leaf[v]) {
                if (used[x]) {
                    L[v] = x;
                    R[v] = x;                     
                }
                pt += used[x]; 
            }
//            cout << v << " " << pt << '\n';         
            if (pt != 1) {
                ok = false; 
                break; 
            }
        }
        if (!ok) continue; 
        }
        bool can = dfs(0);                     
        if (can) {
            cout << "Yes\n"; 
            dfs_calc(0); 
            for (int i = 0; i < n; ++i) {
                for (auto x : res[i]) {
                    cout << x + 1 << " "; 
                }
                cout << '\n'; 
            }
            return;  
        }
    }
    cout << "No\n"; 
    return; 
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin); 
  freopen("TASK.out", "w", stdout); 
#endif 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;     
    for (int i = 0; i < t; ++i) {
        solve(); 
    }
    return 0; 
}
