#include <iostream>
#include <vector>
#include <set>
#include <tuple>
#include <utility>
#include <algorithm>

using namespace std;

//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,mmx,abm")

int bit(int x, int i) {
    return (x >> i) & 1;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int k, n;
    cin >> k >> n;
    vector<vector<bool>> can(k, vector<bool>(k));
    for (int i = 0; i < k; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < k; j++) {
            can[j][i] = (s[j] == '1');
        }
    }
    string s;
    cin >> s;
    vector<vector<bool>> canDelete(n, vector<bool>(n, false));
    for (int i = 1; i < n; i++) {
        canDelete[i][i] = can[s[i] - 'a'][s[i - 1] - 'a'];
    }
    for (int len = 2; len < n; len++) {
        for (int l = 1; l + len <= n; l++) {
            int r = l + len - 1;
            for (int j = r - 1; j >= l - 1; j--) {
                if (can[s[r] - 'a'][s[j] - 'a'] && (j == r - 1 || canDelete[j + 1][r - 1]) && (j == l - 1 || canDelete[l][j])) {
                    canDelete[l][r] = true;
                    break;
                }
            }
        }
    }
    string ans = "{";
    for (int mask = 1; mask < (1 << n); mask++) {
        vector<int> vec = {-1};
        for (int i = 0; i < n; i++) {
            if (bit(mask, i)) {
                vec.push_back(i);
            }
        }
        vec.push_back(n);
        string str;
        for (int i = 1; i < vec.size() - 1; i++) {
            str += s[vec[i]];
        }
        bool good = true;
        for (int i = 1; i < vec.size(); i++) {
            if (vec[i - 1] + 1 != vec[i] && !canDelete[vec[i - 1] + 1][vec[i] - 1]) {
                good = false;
                break;
            }
        }
        if (good) {
            ans = min(ans, str);
        }
    }
    cout << ans;
/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb

3 10
010
000
000
aabbbbcccc
*/
    return 0;
}
