#include <bits/stdc++.h>

int main() {
    int n, m;
    std::cin >> n >> m;
    std::string s;
    std::cin >> s;
    bool have[m];
    memset(have, 0, sizeof have);

    std::vector<int> order(n);
    std::iota(order.begin(), order.end(), 0);
    std::vector<std::vector<std::pair<int, char>>> cards(n);
    for (auto &i : cards) {
        int sz;
        std::cin >> sz;
        i.resize(sz);
        for (auto &j : i) std::cin >> j.first >> j.second, --j.first;
    }

    do {
        char have[m];
        memset(have, 0, sizeof(have));
        for (auto &i : order) {
            for (auto &[p, e] : cards[i]) {
                if (have[p] == 0) have[p] = e;
            }
        }
        bool good = true;
        for(int i = 0; i < m; i++) good &= s[i] == have[i];

        if(good) {
            for(auto &i : order) std::cout << i + 1 << ' ';
            return 0;
        }
    } while (std::next_permutation(order.begin(), order.end()));

    std::cout << -1 << '\n';
}
