#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (auto &u : a) {
        in >> u;
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& a) {
    for (auto &u : a) {
        out << u << ' ';
    }
    return out;
}

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

vi cnt;

void Solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    cnt.resize(n, 0);
    vector <vi> poses(m);
    vi add(m, 0);
    vi can;
    vector <bool> word(m, 0);
    vector <bool> was(m, 0);
    vector<vi> a(n);
    forn(i, n) {
        int k;
        cin >> k;
        forn(j, k) {
            int x;
            char y;
            cin >> x >> y;
            --x;
            word[x] = 1;
            a[i].eb(x);
            if (y != s[x]) {
                ++cnt[i];
                poses[x].eb(i);
            }
        }
        if (!cnt[i]) {
            can.eb(i);
        }
    }
    forn(i, m) {
        if (!word[i]) {
            cout << "-1";
            return;
        }
    }
    vector <int> order;
    while(!can.empty()) {
        int v = can.back();
        can.pop_back();
        order.eb(v + 1);
        for (auto u : a[v]) {
            if (was[u]) {continue;}
            was[u] = 1;
            for (auto x : poses[u]) {
                --cnt[x];
                if (!cnt[x]) {
                    can.eb(x);
                }
            }
        }
    }
    if (sz(order) != n) {
        cout << "-1";
    } else {
        cout << order;
    }
}

signed main() {
    IO();
    Solve();
    return 0;
}