#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

const int N = 1000;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

int cnt = 0;
vii g[N];
vii a[N];
int con[N];
int take[N];
bool used[N];
vii order[N];

pll dfs(int v) {
    order[v].clear();
    pair<pll, int> vectors[9];
    used[v] = 1;
    int c = 0;
    pll res;
    for (int u : g[v]) {
        if (!used[u]) {
            vectors[c] = {dfs(u), u};
            if (vectors[c].first.first == -1) return {-1, -1};
            ++c;
        }
    }
    if (c == 0) {
        res = {take[con[v]], take[con[v]]};
        order[v].push_back(res.first);
    }
    else {
        sort(vectors, vectors + c);
        res.first = vectors[0].first.first;
        res.second = vectors[c - 1].first.second;
        for (int i = 0; i < c; ++i) {
            for (int j = 0; j < c; ++j) {
                if (i == j) continue;
                if (vectors[j].first.first > vectors[i].first.first && vectors[j].first.first < vectors[i].first.second) return {-1, -1};
                if (vectors[j].first.second > vectors[i].first.first && vectors[j].first.second < vectors[i].first.second) return {-1, -1};
            }
        }
        for (int i = 0; i < c; ++i) {
            order[v].push_back(vectors[i].second + 1);
        }
    }
    return res;
}

bool check() {
    fill(used, used + N, false);
    pll a = dfs(0);
    return a.first != -1;
}

int n;

void go(int i) {
    if (i == cnt) {
        if (check()) {
            cout << "Yes" << '\n';
            for (int j = 0; j < n; ++j) {
                for (int jj : order[j]) cout << jj << " ";
                cout << '\n';
            }
            cout << '\n';
            exit(0);
        }
        return;
    }
    for (int p : a[i]) {
        take[i] = p;
        go(i + 1);
    }
}

int main() {
    optimize();

    cin >> n;
    for (int i = 0; i < n; ++i) {
        int p; cin >> p;
        if (p == 1) {
            int k; cin >> k;
            for (int j = 0; j < k; ++j) {
                int pp; cin >> pp;
                g[i].push_back(pp - 1);
            }
        }
        else {
            int m; cin >> m;
            for (int j = 0; j < m; ++j) {
                int p; cin >> p;
                a[cnt].push_back(p);
            }
            con[i] = cnt;
            ++cnt;
        }
    }
    go(0);
    cout << "No" << endl;

    return 0;
}
