#include <bits/stdc++.h>
using namespace std;
//#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;

bool dfs(int v, v2i& g, v2i& report, vi& ptr, vi& str) {
    if (g[v].size()) {
        for (int to : g[v])
            if (dfs(to, g, report, ptr, str))
                return true;
        return false;
    }
    else {
        if (!str.empty() && str.back() > report[v][ptr[v]])
            return true;
        str.push_back(report[v][ptr[v]]);
        return false;
    }
}

void dfsNext(int v, v2i& g, v2i& report, vi& ptr, bool& work) {
    if (g[v].size()) {
        for (int i = 0; i < g[v].size() && work; ++i) {
            dfsNext(g[v][i], g, report, ptr, work);
        }
        if (work) {
            if (next_permutation(g[v].begin(), g[v].end()))
                work = false;
            else
                //reverse
                sort(g[v].begin(), g[v].end());
        }
        return;
    }
    else {
        if (work) {
            if (ptr[v] + 1 < report[v].size()) {
                ++ptr[v];
                work = false;
            }
            else
                ptr[v] = 0;
        }
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    v2i g(n);
    v2i report(n);
    for (int i = 0; i < n; ++i) {
        int t, k;
        cin >> t >> k;
        if (t == 1) {
            for (int j = 0; j < k; ++j) {
                int to;
                cin >> to;
                g[i].push_back(to - 1);
            }
            sort(g[i].begin(), g[i].end());
        }
        else {
            for (int j = 0; j < k; ++j) {
                int num;
                cin >> num;
                report[i].push_back(num);
            }
        }
    }
    vi ptr(n);
    while (true) {
        vi str;
        if (!dfs(0, g, report, ptr, str)) {
            cout << "Yes\n";
            for (int i = 0; i < n; ++i)
                if (g[i].size()) {
                    for (int e : g[i])
                        cout << e + 1 << ' ';
                    cout << '\n';
                }
                else
                    cout << report[i][ptr[i]] << '\n';
            return 0;
        }
        bool work = true;
        dfsNext(0, g, report, ptr, work);
        if (work)
            break;
    }
    cout << "No\n";
}
