#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;

using ll = long long;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}

mt19937 rnd = mt19937(13371); // NOLINT(cert-msc51-cpp,cert-err58-cpp)

void solve() {
    ll k, n;
    cin >> k >> n;
    vector<vector<bool>> a(k, vector<bool>(k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            a[i][j] = x == '1';
        }
    }
    string s;
    cin >> s;
    string s2 = s;

    vector<bool> removable(s.size(), false);
    map<ll, ll> skip;
    for (int i = 1; i < s.size(); ++i) {
        for (ll j = i - 1; !removable[i] and j >= 0;) {
            if (a[s[j] - 'a'][s[i] - 'a']) {
                removable[i] = true;
                skip[i] = j;
            }
            if (!removable[j]) break;
            if (skip.count(j)) {
                j = skip[j];
            } else {
                --j;
            }
        }
    }

    for (int mini = 1; mini < s.size(); ++mini) {
        if (!a[s[mini - 1] - 'a'][s[mini] - 'a']) continue;
        // remove?
        ll mn = mini;

        for (int i = mini + 1; i < s.size(); ++i) {
            if (s[i] < s[mn]) {
                mn = i;
            }
            if (!removable[i]) break;
        }

        s.erase(s.begin() + mini, s.begin() + mn);
        removable.erase(removable.begin() + mini, removable.begin() + mn);
    }
    while (removable[s.size() - 1]) {
        s.pop_back();
        removable.pop_back();
    }


    string s1 = s;
    s = s2;

    removable.clear();
    removable.resize(s.size(), false);
    skip.clear();
    for (int i = 1; i < s.size(); ++i) {
        for (ll j = i - 1; !removable[i] and j >= 0;) {
            if (a[s[j] - 'a'][s[i] - 'a']) {
                removable[i] = true;
                skip[i] = j;
            }
            if (!removable[j]) break;
            if (skip.count(j)) {
                j = skip[j];
            } else {
                --j;
            }
        }
    }

    for (int mini = 1; mini < s.size(); ++mini) {
        if (!a[s[mini - 1] - 'a'][s[mini] - 'a']) continue;
        // remove?
        ll mn = mini;

        for (int i = mini + 1; i < s.size(); ++i) {
            if ((!skip.count(i - 1) or skip[i - 1] >= mini - 1) and s[i] < s[mn]) {
                mn = i;
            }
            if (!removable[i]) break;
        }

        s.erase(s.begin() + mini, s.begin() + mn);
        removable.erase(removable.begin() + mini, removable.begin() + mn);
    }
    while (removable[s.size() - 1]) {
        s.pop_back();
        removable.pop_back();
    }
    for (int i = 0; i < s.size(); ++i) {
        if (removable[i] and skip[i]) {
            ll j = i + 1;
            while (s[j] == s[i]) ++j;
            if (s[j] < s[i]) {
                s.erase(s.begin() + i, s.begin() + i + 1);
                removable.erase(removable.begin() + i, removable.begin() + i + 1);
            }
        }
    }

    if (rnd() % 2) {
        cout << s1 << endl;
    } else {
        cout << s << endl;
    }
}


//3 7
//010
//001
//100
//abacaba

//3 5
//010
//001
//100
//bcacb

//2 5
//00
//11
//aabab

//2 5
//10
//01
//aabba

//3 5
//001
//010
//100
//accaa

//3 5
//011
//010
//100
//aaccb
