#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

const int MAXN = 1e5 + 228;

vector<pair<int, char> > b[MAXN];
string s;
bool used[MAXN];
bool used2[MAXN];
int cntBad[MAXN];
vector<int> canUse;
vector<int> badOfPos[MAXN];

/*bool check(int pos) {
	for (int i = 0; i < b[pos].size(); ++i) {
		if (!used[b[pos][i].first] && s[b[pos][i].first] != b[pos][i].second) return false;
	}
	return true;
}*/

int cnt = 0;
vector<int> ans;

void makeGood(int spos) {
	assert(!used[spos]);
	used[spos] = true;
	++cnt;
	for (int i = 0; i < badOfPos[spos].size(); ++i) {
		cntBad[badOfPos[spos][i]]--;
		if (cntBad[badOfPos[spos][i]] == 0) {
			canUse.push_back(badOfPos[spos][i]);
		}
	}
}

void add(int pos) {
	used2[pos] = true;
	ans.push_back(pos);
	for (int i = 0; i < b[pos].size(); ++i) {
		if (!used[b[pos][i].first]) {
			makeGood(b[pos][i].first);
		}
	}
}

void init(int pos) {
	for (int i = 0; i < b[pos].size(); ++i) {
		if (s[b[pos][i].first] != b[pos][i].second) {
			++cntBad[pos];
			badOfPos[b[pos][i].first].push_back(pos);
		}
	}
	if (cntBad[pos] == 0) canUse.push_back(pos);
}

int main() {
	int n, m;
	cin >> n >> m;
	cin >> s;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int a;
			char c;
			cin >> a >> c;
			--a;
			b[i].push_back(make_pair(a, c));
		}
		init(i);
	}
	while (cnt < m) {
		if (canUse.size() == 0) {
			cout << -1;
			return 0;
		}
		int posToAdd = canUse.back();
		canUse.pop_back();
		add(posToAdd);
	}
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i] + 1 << " ";
	}
	for (int i = 0; i < n; ++i) {
		if (!used2[i]) {
			cout << i + 1 << " ";
		}
	}
}