#include <bits/stdc++.h>
using namespace std;

const int N = 2005;
const int K = 26;

typedef vector<int> vec;

bool cmp(const vec& a, const vec& b) {
    for (size_t i = 0; i < min(a.size(), b.size()); ++i) {
        if (a[i] < b[i]) return 1;
        if (a[i] > b[i]) return 0;
    }
    return a.size() < b.size();
}

vec vmin(const vec& a, const vec& b) {
    return cmp(a, b) ? a : b;
}

void print(const vec& a) {
    for (size_t i = 0; i < a.size(); ++i) cout << (char)('a' + a[i]);
    cout << endl;
}

int n, k;
int A[K][K];
int a[N];
int mx[N];
vec dp[N];
vec t[2 * N];

void upd(int i, const vec& v) {
    dp[i] = v;
    t[i + n] = dp[i];
    i += n;
    for (; i > 1; i >>= 1) t[i >> 1] = vmin(t[i], t[i ^ 1]);
}

vec get(int l, int r) {
    vec ret = dp[l];
    l += n, r += n;
    while (l < r) {
        if (l & 1) ret = vmin(ret, t[l++]);
        if (r & 1) ret = vmin(ret, t[--r]);
        l >>= 1, r >>= 1;
    }
    return ret;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            A[i][j] = c - '0';
        }
    }
    for (int i = 0; i < n; ++i) {
        char c;
        cin >> c;
        a[i] = c - 'a';
    }
    for (int i = 0; i < n; ++i) mx[i] = i;
    for (int i = n - 1; i >= 0; --i) {
        vector<int> st;
        for (int j = i; j >= 0; --j) {
            while (!st.empty() && A[a[j]][st.back()]) st.pop_back();
            st.push_back(a[j]);
            if (st.size() == 1) mx[j] = max(mx[j], i);
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) dp[i].push_back(a[j]);
    }
    for (int i = 0; i < n; ++i) t[i + n] = dp[i];
    for (int i = n - 1; i > 0; --i) t[i] = vmin(t[2 * i], t[2 * i + 1]);
    for (int i = n - 1; i >= 0; --i) {
        if (mx[i] == n - 1) {
            upd(i, vec{a[i]});
        } else {
            vec cur = get(i + 1, mx[i] + 2);
            vec kek = vec{a[i]};
            for (int x : cur) kek.push_back(x);
            upd(i, kek);
        }
    }
    print(dp[0]);
    return 0;
}
