#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <math.h>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define vi vector<int>
#define pii pair<int, int>

signed main() {
    
	int n, m; cin >> n >> m;
	string s; cin >> s;
	
	vector<map<int, char>> p(n);
	vi ok(m, 0);
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		for (int j = 0; j < k; ++j) {
			int t;
			char c;
			cin >> t >> c;
			p[i][--t] = c;
		}
	}

	vi take(n, 0);
	vi ans;
	while (1) {
		int id = -1;
		for (int i = 0; i < n; ++i) {
			if (take[i]) continue;
			bool now = 1;
			for (auto el : p[i]) {
				if (!ok[el.first] && s[el.first] != el.second) {
					now = 0;
					break;
				}
			}
			if (now) {
				id = i;
				break;
			}
		}
		if (id == -1) {
			cout << "-1\n";
			exit(0);
		}
		ans.push_back(id);
		take[id] = 1;
		for (auto el : p[id]) {
			ok[el.first] = 1;
		}
		if (ans.size() == n) break;
	}

	for (int i = 0; i < m; ++i) {
		if (!ok[i]) {
			cout << "-1\n";
			exit(0);
		}
	}
	for (auto u : ans) cout << u + 1 << ' ';
	cout << '\n';
}