#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()

int32_t main() {
    //ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, k;
    cin >> k >> n;
    vector<vector<int>> ok(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            ok[i][j] = s[j] == '1';
        }
    }

    string s;
    cin >> s;
    vector<string> dp(n);
    dp[0] = s[n-1];
    for (int i = 1; i < n; ++i) {
        int j = i-1;
        string x = dp[j];
        dp[i] = s[n-i-1] + x;
        while (x.size() >= 1 && ok[s[n-i-1]-'a'][x[0]-'a'] ) {
            x.erase(x.begin());
            dp[i] = min(dp[i], s[n-i-1] + x);
        }

    }
    cout << dp[n-1];
}

/*
 * 3 5
010
001
100
bcacb
 */