#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define mp make_pair
#define rep(i, n) for (int i = 0; i < n; ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define all(a) a.begin(), a.end()
#define pb push_back
#define ss second
#define ff first

using namespace std;

void run() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<vector<pair<int, char>>> cards(n);
    vector<bool> used(m, 0);
    rep(i, n) {
        int k;
        cin >> k;
        rep(j, k) {
            int pos;
            char clr;
            cin >> pos >> clr;
            pos--;
            used[pos] = 1;
            cards[i].pb({pos, clr});
        }
    }

    bool is_ans = 1;
    rep(i, m) {
        if (!used[i]) is_ans = 0;
    }

    if (!is_ans) {
        cout << -1;
        return;
    }

    queue<int> q;
    vector<set<int>> danger(m);
    vector<int> cnt(n, 0);
    rep(i, n) {
//        set<int> dang;
        bool ok = 1;
        for (auto el : cards[i]) {
            if (el.ss != s[el.ff]) {
                danger[el.ff].insert(i);
                cnt[i]++;
                ok = 0;
            }
        }
        if (ok) q.push(i);
    }

    vector<int> ans;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        ans.pb(v);
        for (auto el : cards[v]) {
            for (auto del : danger[el.ff]) {
                cnt[del]--;
                if (cnt[del] == 0) q.push(del);
            }
            danger[el.ff].clear();
        }
    }
    if (ans.size() != n) {
        cout << -1;
        return;
    }
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}
