#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second

void Solve(){
	int n, m;
	cin >> n >> m;

	string s; cin >> s;

	vector<vector<pair<int, char>>> v(n);
	vector<vector<int>> bads(m);
	vector<int> cntbads(n);
	int cnt = 0;

	for(int i = 0; i < n; i++){
		int k; cin >> k;
		v[i].resize(k);

		for(auto &p : v[i]){
			cin >> p.fi >> p.se;
			if(s[p.fi - 1] != p.se){
				cntbads[i]++;
				bads[p.fi - 1].push_back(i);
			}
		}
	}

	set<pair<int, int>> st;

	for(int i = 0; i < n; i++)
		st.insert({cntbads[i], i});

	vector<int> ans;
	vector<int> kek(n);
	vector<int> was(m);

	while(cnt < m){
		auto p = *st.begin();

		int b = p.fi;
		int i = p.se;

		if(b){
			cout << "-1\n";
			return;
		}

		st.erase(st.begin());

		ans.push_back(i + 1);
		kek[i] = 1;

		for(auto p : v[i]){
			char c = p.se;
			int i = p.fi - 1;

			if(s[i] == c && !was[i]){
				cnt++;
				was[i] = 1;

				for(int j : bads[i]){
					st.erase({cntbads[j], j});
					cntbads[j]--;
					st.insert({cntbads[j], j});
				}
			}
		}
	}

	for(int i = 0; i < n; i++)
		if(!kek[i])
			ans.push_back(i);

	for(int x : ans)
		cout << x << ' ';
}

signed main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);

	// freopen("input.txt", "r", stdin);

	int test = 1;
	// cin >> test;

	for(int i = 1; i <= test; i++){
		Solve();
	}
}