#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second

using ll = long long;

const int MAXN = 131072 * 4;

const int MAXC = 20;

const ll P = 29;

const ll MOD = 1e9 + 9;

int my_next[MAXN << 1][MAXC];

ll my_hesh[MAXN << 1][MAXC];

ll p[MAXN << 1];

void solve() {
    p[0] = 1;
    for (int i = 1; i < MAXN; ++i)
        p[i] = (p[i - 1] * P) % MOD;
    int k, n;
    cin >> k >> n;
    vector<vector<int>> may(k, vector<int> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char x;
            cin >> x;
            may[i][j] = x - '0';
        }
    }
    string s;
    cin >> s;
    vector<pair<int, char>> v;
    vector<int> jump(n);
    for (int i = n - 1; i >= 0; --i) {
        while (v.size() && may[s[i] - 'a'][v.back().y - 'a'])
            v.pop_back();
        if (v.size()) {
            jump[i] = v.back().x;
        } else {
            jump[i] = MAXN;
        }
        v.push_back({i, s[i]});
    }
    for (int i = 0; i < MAXC; ++i) {
        my_next[MAXN][i] = MAXN;
        my_hesh[MAXN][i] = 0;
    }
    deque<int> now;
    now.push_back(MAXN);
    for (int i = n - 1; i >= 0; --i) {
        int lb = 0, rb = now.size();
        while (rb - lb > 1) {
            int mid = (lb + rb) >> 1;
            if (jump[i] >= now[mid])
                lb = mid;
            else
                rb = mid;
        }
        my_next[i][0] = now[lb];
        my_hesh[i][0] = (s[i] - 'a' + 1);
        for (int j = 1; j < MAXC; ++j) {
            my_next[i][j] = my_next[my_next[i][j - 1]][j - 1];
            my_hesh[i][j] = (my_hesh[i][j - 1] * p[1 << (j - 1)] + my_hesh[my_next[i][j - 1]][j - 1]) % MOD;
        }
        while (true) {
            int A = i;
            int B = now.front();
            for (int j = MAXC - 1; j >= 0; --j)
                if (my_hesh[A][j] == my_hesh[B][j]) {
                    A = my_next[A][j];
                    B = my_next[B][j];
                }
            if (A == MAXN) {
                now.pop_front();
            } else if (B == MAXN) {
                break;
            } else if (s[A] < s[B]) {
                now.pop_front();
            } else {
                break;
            }
        }
        now.push_front(i);
    }
    int id = 0;
    while (id != MAXN) {
        cout << s[id];
        id = my_next[id][0];
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1; // cin >> t;
    while (t--)
        solve();
    return 0;
}
