#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    string s;
    vector <pair <string, int>> words(n, {string(m, ' '), -1});
    cin >> s;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        words[i].second = i;
        for (int j = 0; j < k; ++j) {
            int a;
            char c;
            cin >> a >> c;
            if (c == s[a - 1] || c == ' ') {
                (words[i].first)[a - 1] = '0';
            }
            else {
                (words[i].first)[a - 1] = '1';
            }
        }
    }
    sort(words.begin(), words.end());
    bool good = true;
    for (int j = 0; j < m && good; ++j) {
        bool found = false;
        for (int i = 0; i < n; ++i) {
            if ((words[i].first)[j] == s[j]) {
                found = true;
                break;
            }
            if ((words[i].first)[j] != s[j] and (words[i].first)[j] != ' ') {
                good = false;
                break;
            }
        }
        if (!found) good = false;
    }
    if (good) {
        for (int i = 0; i < n; ++i) {
            cout << words[i].second + 1 << ' ';
        }
    }
    else cout << -1;
}
