#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

const int INF = 1e9;
const int MOD = 228228227;

void get_answer(vector <pair <int, int>> &deletions, vector <int> &s, vector <bool> &deleted, vector <int> &answer, vector <int> &prevs, vector <int> &nexts, int n) {
    vector <int> new_s;
    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;
        new_s.push_back(s[i]);
    }

    if (new_s < answer) {
        answer = new_s;
    }

    for (auto [i, j]: deletions) {
        for (int k = 0; k < n; k++) {
            if (deleted[k]) continue;
            if (s[k] == j && prevs[k] != -1 && s[prevs[k]] == i) {
                deleted[k] = true;

                if (nexts[k] < n) prevs[nexts[k]] = prevs[k];
                nexts[prevs[k]] = nexts[k];

                get_answer(deletions, s, deleted, answer, prevs, nexts, n);

                if (nexts[k] < n) prevs[nexts[k]] = k;
                nexts[prevs[k]] = k;

                deleted[k] = false;
            }
        }
    }
}

inline void solve() {
    int k, n;
    cin >> k >> n;

    map <int, map <int, bool>> deletions;

    char x;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> x;

            if (x == '1') {
                deletions[i][j] = true;
            }
        }
    }

    string str_s;
    cin >> str_s;

    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        s[i] = str_s[i] - 'a';
    }

    vector <int> answer = s;
    vector <bool> deleted(n);
    vector <int> my_fucker(n, INF), fucker_cnt(n);

    for (int i = 0; i < n; i++) {
        my_fucker.assign(n, -1);
        fucker_cnt.assign(n, 0);

        int least_fucker = -1;
        int prev = -1;
        for (int j = 0; j < n; j++) {
            if (deleted[j]) continue;
            if (!deletions[prev][s[j]]) {
                prev = s[j];
                continue;
            }

            for (int l = j + 1; l < n; l++) {
                if (deleted[l]) continue;
                if (deletions[s[j]][s[l]]) {
                    fucker_cnt[j]++;
                } else {
                    break;
                }
            }

            prev = s[j];
        }

        prev = -1;
        for (int j = 0; j < n; j++) {
            if (deleted[j]) continue;
            if (prev == -1 || !deletions[s[prev]][s[j]]) {
                prev = j;
                continue;
            }

            if (least_fucker == -1 || (least_fucker == prev && s[least_fucker] < s[j])) {
                least_fucker = j;
            }

            prev = j;
        }

        // cout << "deleted " << least_fucker << '\n';
        if (least_fucker == -1) break;
        deleted[least_fucker] = true;
    }

    for (int i = 0; i < n; i++) {
        if (deleted[i]) continue;
        cout << (char)('a' + s[i]);
    }

    cout << '\n';
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
