#include <bits/stdc++.h>

#define eb emplace_back
#define x first
#define y second

using namespace std;

const int MAXN = 500;

int n;
vector<int> g[MAXN];
int tp[MAXN];

void read(){
    cin >> n;
    for (int i = 0; i < n; i++){
        cin >> tp[i];
        int k;
        cin >> k;
        for (int j = 0; j < k; j++){
            int x;
            cin >> x;
            if (tp[i] == 1) x--;
            g[i].eb(x);
        }
    }
}
typedef pair<int, int> pt;

bool intr(pt a, pt b){
    if (b.x < a.x && a.x < b.y) return false;
    if (b.x < a.y && a.y < b.y) return false;
    return true;
}

vector<pt> res[MAXN];
int ok = 1;
void dfass(int v){
    if (tp[v] == 2){
        for (int i : g[v]){
            res[v].eb(i, i);
        }
        return;
    }
    for (int i : g[v]){
        dfass(i);
        if (res[i].empty()) ok = 0;
    }
    if (g[v].size() == 1){
        for (auto j : res[g[v][0]]) res[v].eb(j);
        return;
    }
    for (auto j : res[g[v][0]]){
        for (auto k : res[g[v][1]]){
            if (!intr(j, k) || !intr(k, j)) continue;
            res[v].eb(min(j.x, k.x), max(j.y, k.y));
        }
    }
}

const int INF = 1e9;

int msk = 0;
int go(int v, int ch){
    //cerr << msk << ' ' << v << ' ' << ch << '\n';
    if (tp[v] == 2){
        int N = g[v].size();
        for (int i = ch; i < ch + N; i++){
            if ((msk >> i) & 1){
                res[v].eb(g[v][i - ch], g[v][i - ch]);
                return ch + N;
            }
        }
        res[v].eb(-INF, INF);
        return ch + N;
    }
    for (int i : g[v]){
        ch = go(i, ch);
    }
    vector<pt> cc;
    for (int i : g[v]){
        if (!res[i].empty())
        cc.eb(res[i][0]);
    }
    sort(begin(cc), end(cc));
    int N = cc.size();
    for (int i = 1; i < N; i++){
        if (cc[i-1].y > cc[i].x) return ch;
    }
    res[v].eb(cc[0].x, cc[N-1].y);
    return ch;
}

vector<int> ans[MAXN];
void dfans(int v, int l, int r){
    //cerr << v << ' ' << l << ' ' << r << '\n';
    if (tp[v] == 2){
        for (int i : g[v]){
            if (i == l && i == r){
                ans[v].eb(i);
                return;
            }
        }
        assert(false);
        return;
    }
    if (g[v].size() == 1){
        for (auto j : res[g[v][0]]) {
            if (j.x == l && j.y == r){
                dfans(g[v][0], l, r);
                ans[v].eb(g[v][0] + 1);
                return;
            }
        }
        assert(false);
        return;
    }
    for (auto j : res[g[v][0]]){
        for (auto k : res[g[v][1]]){
            if (!intr(j, k) || !intr(k, j)) continue;
            int l2 = min(j.x, k.x);
            int r2 = max(j.y, k.y);
            if (l2 == l && r2 == r){
                if (j.x < k.x) ans[v] = {g[v][0] + 1, g[v][1] + 1};
                else ans[v] = {g[v][1] + 1, g[v][0] + 1};
                dfans(g[v][0], j.x, j.y);
                dfans(g[v][1], k.x, k.y);
                return;
            }
        }
    }
}


void solve(){
    read();
    dfass(0);
/*
    for (int i = 0; i < n; i++){
        cout << i << '\n';
        for (auto j : res[i]){
            cout << j.x << ' ' << j.y << '\n';
        }
        cout << "=\n";
    }
*/
    if (res[0].empty() || !ok){
        cout << "No\n";
    } else {
        cout << "Yes\n";
        dfans(0, res[0][0].x, res[0][0].y);
        for (int i = 0; i < n; i++){
            for (int j : ans[i]) cout << j << ' ';
            cout << '\n';
        }
    }
}

void solve2(){
    read();
    for (msk = 1; msk < (1 << 20); msk++){
        go(0, 0);
        int ok = 1;
        for(int i= 0; i < n; i++){
            if (res[i].empty()) ok = 0;
        }
        if (ok){
            cout << "Yes\n";
            return;
        }
    }
    cout << "No\n";
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve2();

    return 0;
}

/*
3
1 2 2 3
2 1 1
2 1 2

5
1 2 2 3
2 1 2
1 2 4 5
2 1 1
2 1 3

6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

*/
