#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define nl '\n'
#define elif else if
#define forn(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define maxq(ma, a) ma = max(ma, a)
#define minq(mi, a) mi = min(mi, a)
#define pb push_back
#define sz(a) ((int)a.size())

inline void IO() {
#ifdef Dmitry07
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 10;

vi g[MAXN], li[MAXN];
int pr[MAXN], n;

vi dfs(int v, int mask) {
    if (g[v].empty()) {
        return {pr[v]};
    }
    if (sz(g[v]) == 1) {
        return dfs(g[v][0], mask);
    }
    vi a = dfs(g[v][0], mask), b = dfs(g[v][1], mask);
    if (a.empty() || b.empty()) {
        return {};
    }
    if (mask & (1 << v)) {
        swap(a, b);
    }
    if (a.back() > b[0]) {
        return {};
    }
    for (auto cc : b) {
        a.pb(cc);
    }
    return a;
}

void rec(int dep) {
    if (dep == n) {
        int maxMask = 1 << n;
        forn (mask, maxMask) {
            auto v = dfs(0, mask);
            if (sz(v)) {
                cout << "Yes" << nl;
                forn (i, n) {
                    if (li[i].empty()) {
                        if (mask & (1 << i)) {
                            swap(g[i][0], g[i][1]);
                        }
                        cout << g[i][0] + 1 << ' ' << g[i][1] + 1 << nl;
                    } else {
                        cout << pr[i] << nl;
                    }
                }
                exit(0);
            }
        }
        return;
    }
    if (sz(li[dep]) == 0) {
        rec(dep + 1);
    }
    forn (i, sz(li[dep])) {
        pr[dep] = li[dep][i];
        rec(dep + 1);
    }
}

inline void Solve() {
    cin >> n;
    forn (i, n) {
        int ty, k;
        cin >> ty >> k;
        if (ty == 1) {
            forn (j, k) {
                int to;
                cin >> to;
                to--;
                g[i].pb(to);
            }
        } else {
            li[i].resize(k);
            forn (j, k) {
                cin >> li[i][j];
            }
        }
    }
    rec(0);
    cout << "No";
}

signed main() {
    IO();
    int t = 1;
    while (t--) {
        Solve();
    }
    return 0;
}