#include <iostream>
using namespace std;

int dp[500000], k, n;
bool matrix[26][26];
string word;
char c;

bool can_delete(char a, char b) {
    return matrix[a - 'a'][b - 'a'];
}

int main() {
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            cin >> c;
            matrix[i][j] = c == '1';
        }
    }
    cin >> word;
    dp[n - 1] = n;
    int next;
    for (int i = n - 2; i >= 0; i--) {
        next = i + 1;
        dp[i] = next;
        char letter = word[next];
        int best = next;

        while (next < n and can_delete(word[i], word[next])) {
            next = dp[next];
            if (next < n and word[next] <= letter) {
                best = next;
                letter = word[next];
            }
        }
        if (next >= n) dp[i] = next;
        else dp[i] = best;
    }
    string answer = "";
    int pos = 0;
    while (pos < n) {
        answer += word[pos];
        pos = dp[pos];
    }
    cout << answer << endl;
}