#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = long long;
const ull MOD = 1566566543;
const ull BASE = 239;
#define SZ(x) (int)((x).size())
#define ALL(x) (x).begin(), (x).end()
const int MAXK = 26;
const int MAXN = 1e4 + 7;
int matrix[MAXK][MAXK];
int rgt[MAXN];
int k, n;
vector<ull> dp[MAXN];
string dp1[MAXN];
string s;
ull bases[MAXN];

ull add(ull a, ull b) {
    return (a + MOD + b) % MOD;
}

ull mul(ull a, ull b) {
    return (a * b) % MOD;
}

void build() {
    bases[0] = 1;
    for (int i = 1; i <= n; i++)
        bases[i] = mul(bases[i - 1], BASE);
}

ull get(int l, int r, const vector<ull> &hashes) {
    return add(hashes[r], -mul(bases[r - l], hashes[l]));
}

bool ls(const vector<ull> &hashes1, const vector<ull> &hashes2, const string& s1, const string& s2) {
    int l = 0, r = min(SZ(s1), SZ(s2)) + 1;
//    cout << "-----------\n";
//    cout << s1 << ' ' << s2 << '\n';
    if (s1[0] != s2[0])
        return s1[0] < s2[0];
    while (r - l > 1) {
        int m = (l + r) / 2;
//        cout << m << ' ' << SZ(s1) << ' ' << SZ(s2) << '\n';
//        cout << s1.substr(0, m) << ' ' << s2.substr(0, m) << ' ' << (get(0,m, hashes1) == get(0, m, hashes2)) << endl;
//        cout << get(0, m, hashes1) << ' ' << get(0, m, hashes2) << '\n';
        if (get(0,m, hashes1) == get(0, m, hashes2))
            l = m;
        else
            r = m;
    }
    if (l == min(SZ(s1), SZ(s2)))
        return SZ(s1) < SZ(s2);
    return s1[l] < s2[l];
}

int main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0), cout.tie(0);
    cin >> k >> n;
    build();
    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++) {
            char x;
            cin >> x;
            matrix[i][j] = (x == '1');
        }
    cin >> s;
    dp[n] = vector<ull>(1, 0);
    dp1[n] = "";
    for (int i = n - 1; i >= 0; i--) {
        char c1 = s[i] - 'a';
        rgt[i] = i;
        int where = i + 1;
        for (int j = i + 1; j < n; j++) {
            char c2 = s[j] - 'a';
            if (!matrix[c1][c2] && j > rgt[i])
                break;
            rgt[i] = max(rgt[i], rgt[j]);
//            cout << i << ' ' << j << '\n';
            assert(ls(dp[j + 1], dp[where], dp1[j + 1], dp1[where]) == (dp1[j + 1] == dp1[where]));
            if (ls(dp[j + 1], dp[where], dp1[j + 1], dp1[where]))
                where = j + 1;
        }
        dp[i] = dp[where];
        ull now = s[i];
        for (auto& x : dp[i]) {
            now = mul(now, BASE);
            x = mul(x, now);
        }
        dp[i].insert(dp[i].begin() + 1, s[i]);
        dp1[i] = s[i] + dp1[where];
    }
//    for (int i = 0; i <= n; i++)
//        cout << i << ": " << dp1[i] << '\n';
    cout << dp1[0] << '\n';
    return 0;
}
