#include <bits/stdc++.h>

using namespace std;

inline void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
#ifdef _DEBUG
    freopen("../log.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
//    freopen("\\\\.\\pipe\\game.in", "r", stdin);
//    freopen("\\\\.\\pipe\\game.out", "w", stdout);
#endif
}

struct cord {
    int x, y;

    bool operator<(const cord &a) const {
        return x * y > a.x * a.y;
    }
};

int main() {
    input();
    int t;
    cin >> t;
    if (t == 1) {
        int n, k, m;
        cin >> n >> k >> m;
        string s;
        cin >> s;
        vector<set<cord>> moves(2);
        bool first = true;
        int cnt = 1;
        for (int i1 = 0; i1 < n; i1++)
            for (int j = 0; j < n; j++)
                if (i1 != 0 || j != 0)
                    moves[(i1 + j) & 1].insert({i1, j});
        for (int i = 0; i < m;) {
            cord it;
            if (first) {
                if (s[i] == '0' && moves[0].size()) {
                    it = *moves[0].begin(), ++i;
                } else if (s[i] == '1' && moves[1].size()) {
                    it = *moves[1].begin(), ++i;
                } else {
                    ++cnt;
                    first = !(cnt & 1);
                    it = {0, 0};
                }
                cout << it.x + 1 << " " << it.y + 1 << endl;
                for (int c = 0; c < 2; c++) {
                    auto j = moves[c].begin();
                    while (j != moves[c].end()) {
                        auto next1 = next(j);
                        if (j->x >= it.x && j->y >= it.y)
                            moves[c].erase(j);
                        j = next1;
                    }
                }
                if (it.x == 0 && it.y == 0){
                    if (i != m) {
                        for (int i1 = 0; i1 < n; i1++)
                            for (int j = 0; j < n; j++)
                                if (i1 != 0 || j != 0)
                                    moves[(i1 + j) & 1].insert({i1, j});
                    }
                }
                first = !first;
            } else {
                int x, y;
                cin >> x >> y;
                if (x == 1 && y == 1) {
                    cnt++;
                    first = !(cnt & 1);
                }
                it = {x - 1, y - 1};
                for (int c = 0; c < 2; c++) {
                    auto j = moves[c].begin();
                    while (j != moves[c].end()) {
                        auto next1 = next(j);
                        if (j->x >= it.x && j->y >= it.y)
                            moves[c].erase(j);
                        j = next1;
                    }
                }
                if (x == 1 && y == 1) {
                    for (int i1 = 0; i1 < n; i1++)
                        for (int j = 0; j < n; j++)
                            if (i1 != 0 || j != 0)
                                moves[(i1 + j) & 1].insert({i1, j});
                }
                first = !first;
            }
        }
        if (!moves[0].empty() || !moves[1].empty()){
            int x, y;
            cin >> x >> y;
            cord it = {x - 1, y - 1};
            for (int c = 0; c < 2; c++) {
                auto j = moves[c].begin();
                while (j != moves[c].end()) {
                    auto next1 = next(j);
                    if (j->x >= it.x && j->y >= it.y)
                        moves[c].erase(j);
                    j = next1;
                }
            }
            if (!moves[0].empty() || !moves[1].empty())
                cout << "1 1" << endl;
        }
        cout << 0 << endl;
    } else {
        int n, k, m, c;
        string ans = "";
        cin >> n >> k >> m >> c;
        for (int i = 0; i < c; i++) {
            int x, y;
            cin >> x >> y;
            bool first = !(i & 1);
            --x, --y;
            while (!(x == 0 && y == 0)) {
                if (first)
                    ans += char('0' + ((x + y) & 1));
                first = !first;
                cin >> x >> y;
                --x, --y;
            }
        }
        cout << ans << endl;
    }
    return 0;
}
