#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

bool can[27][27];
int k, n;

int to[500009];
int dp[500009];

string s;

inline bool check(char c, int pos, int x) {
    c -= 'a';
    int mxlef = pos;
    for (int i = pos - 1; i >= x; i--) {
        if (can[s[i] - 'a'][c]) {
            if (mxlef >= i) {
                to[pos] = i;
                return 1;
            }
        }

        mxlef = min(mxlef, to[i]);
    }

    return 0;
}

inline int les(int i, int j) {
    if (i == -1) return j;
    if (j == -1) return i;

    int x = i, y = j;
    while (i != n && j != n) {
        if (s[i] < s[j]) return x;
        if (s[i] > s[j]) return y;
        i = dp[i];
        j = dp[j];
    }

    if (i == n) return x;
    if (j == n) return y;
}

int lenfor[500009];
int spar[20][500009];

inline void add(int j) {
    for (int i = 0; j + (1 << i) <= n + 1; i++) {
        if (i == 0) {
            spar[i][j] = j;
        }

        else {
            spar[i][j] = les(spar[i - 1][j], spar[i - 1][j + (1 << (i - 1))]);
        }
    }
}

void fill_sp() {
    for (int i = 0; i < 20; i++) {
        for (int j = 0; j + (1 << i) <= n + 1; j++) {
            spar[i][j] = -1;
           // cout << "FILL " << i << ' ' << j << endl;
        }
    }

    for (int i = 2; i <= n + 1; i++) lenfor[i] = lenfor[i >> 1] + 1;
}

inline int getmn(int l, int r) {
    int len = lenfor[r - l + 1];
    //cout << len << ' ' << spar[len][l] << ' ' << spar[len][r - (1 << len) + 1] << ' ' << r - (1 << len) + 1 << endl;
    return les(spar[len][l], spar[len][r - (1 << len) + 1]);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
       // freopen("wa.txt", "w", stdout);
    #endif // localfile

    cin >> k >> n;
    fill_sp();

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k ; j++) {
            char c;
            cin >> c;
            can[i][j] = c - '0';
        }
    }

    cin >> s;
    s += '\n';
    dp[n] = n;
    add(n);

    for (int i = 0; i < n; i++) to[i] = -1;

    for (int i = n - 1; i > -1; i--) {
        int j = i + 1;
        dp[i] = -1;

        while (j < n && (to[j] != -1 || check(s[j], j, i))) {
            j++;
        }
        //cout << i << endl;

        int wh = -1;
        /*for (int t = i + 1; t <= j; t++) {
            //cout << "GO: " << i << ' '<< t << ' ' << wh << endl;// << ' ' << les(t, wh)<< endl;
            if (wh == -1 || les(t, wh)) {
                wh = t;
            }
        }*/

        if (j == n) {
            dp[i] = n;
            add(i);
            continue;
        }

       // cout << i << ' ' << j << endl;
        wh = getmn(i + 1, j);
       // cout << i << ' ' << wh << endl;

        dp[i] = wh;
        add(i);
    }

    string answ = "";
    int i =0;
    while (i != n) {
        answ += s[i];
        i = dp[i];
    }

    cout << answ;

    return 0;
}
