#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

const int MAX_N = 2021;

int p[MAX_N];
vector<int> childs[MAX_N];
vector<int> vals[MAX_N];

vector<pair<pii, ll>> segs[MAX_N];

int factorials[9] = { 1, 1, 2, 6, 24, 120, 720, 5040, 40320 };

bool dfs(int v) {
	if (childs[v].size() == 0) {
		for (int val : vals[v])
			segs[v].push_back(mp(mp(val, val + 1), -1));
		return true;
	}
	else {
		for (int u : childs[v])
			if (!dfs(u))
				return false;
		int k = childs[v].size();
		vector<int> permutation(k);
		for (int i = 0; i < k; i++)
			permutation[i] = i;
		for (int i = 0; i < factorials[k]; i++) {
			for (int u = 0; u < segs[childs[v][permutation[0]]].size(); u++) {
				auto seg = segs[childs[v][permutation[0]]][u];
				int l = seg.ft.ft;
				int r = seg.ft.sd;
				for (int j = 1; j < k; j++) {
					int r1 = MAX_N;
					for (auto seg : segs[childs[v][permutation[j]]])
						if (seg.ft.ft >= r)
							r1 = min(r1, seg.ft.sd);
					r = r1;
					if (r == MAX_N)
						break;
				}
				if (r != MAX_N)
					segs[v].push_back(mp(mp(l, r), (i << 22) + u));
			}
			next_permutation(all(permutation));
		}
		if (segs[v].size() == 0)
			return false;
		sort(all(segs[v]));
		vector<pair<pii, ll>> segs1;
		for (int i = 0; i < segs[v].size(); i++)
			if (i == 0 || segs[v][i].ft.ft != segs[v][i - 1].ft.ft)
				segs1.push_back(segs[v][i]);
		segs[v] = segs1;
 		return true;
	}
}

void solve() {
	int n;
	cin >> n;
	vector<int> allvals;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			childs[i].resize(k);
			for (int j = 0; j < k; j++) {
				cin >> childs[i][j];
				childs[i][j]--;
				p[childs[i][j]] = i;
			}
		}
		else {
			int m;
			cin >> m;
			vals[i].resize(m);
			for (int j = 0; j < m; j++) {
				cin >> vals[i][j];
				allvals.push_back(vals[i][j]);
			}
		}
	}
	sort(all(allvals));
	for (int i = 0; i < n; i++)
		if (childs[i].size() == 0) {
			sort(all(vals[i]));
			for (int j = 0; j < vals[i].size(); j++)
				vals[i][j] = lower_bound(all(allvals), vals[i][j]) - allvals.begin();
		}
	if (dfs(0))
		cout << "Yes";
	else
		cout << "No";
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}
/*
3 7
010
001
100
abacaba
*/

/*
3 5
010
001
100
bcacb
*/

/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92
*/
/*
3
1 2 2 3
2 1 1
2 1 2
*/