#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <ctime>
#include <queue>
#include <deque>
#include <fstream>
#include <iomanip>
#include <bitset>
// #pragma GCC optimize("O2,O3,Ofast")
// #define int long long
using namespace std;
typedef long long ll;
typedef long double ld;
const int inf = 1e9 + 7;
const ll l_inf = (ll)inf * (ll)inf;
const ld eps = 1e-6;


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    set<int> S;
    vector<int> cnt(n, 0);
    vector<vector<int>> f(m);
    vector<vector<int>> pos(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        pos[i].resize(k);
        for (int j = 0; j < k; ++j) {
            char ch;
            cin >> pos[i][j] >> ch;
            --pos[i][j];
            S.insert(pos[i][j]);
            if (ch != s[pos[i][j]]) {
                f[pos[i][j]].push_back(i);
                ++cnt[i];
            }
        }
    }
    //
    vector<int> res;
    queue<int> Q;
    for (int i = 0; i < n; ++i) {
        if (cnt[i] == 0) {
            Q.push(i);
        }
    }
    //
    while (!Q.empty()) {
        int i = Q.front();
        res.push_back(i);
        Q.pop();
        for (int p : pos[i]) {
            for (int j : f[p]) {
                --cnt[j];
                if (cnt[j] == 0) {
                    Q.push(j);
                }
            }
            f[p].clear();
        }
    }
    if (res.size() < n || S.size() < m) {
        cout << "-1\n";
    } else {
        for (int el : res) {
            cout << el + 1 << " ";
        }
        cout << "\n";
    }
    return 0;
}