#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>
#include <bitset>
#include <array>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;

int k, n;
vector<vector<bool>> a;
vector<int> b;

struct segtr {
	int n;
	vector<string> t;
	segtr(int n0 = 0) {
		n=n0;
		t.assign(n*4,"|");
	}
	void upd(int v, int l, int r, int pos, string& x) {
		if (l+1==r) t[v]=x;
		else {
			int m=(l+r)/2;
			if (pos<m) upd(2*v+1,l,m,pos,x);
			else upd(2*v+2,m,r,pos,x);
			t[v]=min(t[2*v+1],t[2*v+2]);
		}
	} void upd(int pos, string &x) {upd(0,0,n,pos,x);}
	string mn(int v, int tl, int tr, int l, int r) {
		if (tl==l&&tr==r) return t[v];
		if (l>=r) return "|";
		int tm=(tl+tr)/2;
		return min(mn(2*v+1,tl,tm,l,min(r,tm)),mn(2*v+2,tm,tr,max(l,tm),r));
	} string mn(int l, int r) {return mn(0,0,n,l,r);}
};

void solve() {
	cin >> k >> n;
	a.assign(k,vector<bool>(k));
	for (int i = 0; i < k; ++i) {
		for (int j = 0; j < k; ++j) {
			char c; cin >> c;
			a[i][j]=(c=='1'?1:0);
		}
	}
	string s; cin >> s;
	vector<string> dp(n+1); dp[n]="";
	string bas="";
	segtr tr(n+1); tr.upd(n,bas);
	for (int i = n - 1; i >= 0; --i) {
		vector<int> last={s[i]-'a'};
		int pos=i+1;
		while(pos<n) {
			bool ok=0;
			for (int t = last.size() - 1; t >= 0; --t) {
				if (a[last[t]][s[pos] - 'a']) {
					ok=1;
					while(last.size()-1>t) last.pop_back();
					break;
				}
			}
			if (ok) last.push_back(s[pos]-'a');
			else break;
			++pos;
		}
		dp[i]=s[i]+tr.mn(i+1,pos+1);
		tr.upd(i,dp[i]);
	}
	cout << dp[0];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}