#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
const int MAX_C = 26;
ll dp[MAX_N][MAX_C];
int to[MAX_N][MAX_C];
int ans[MAX_N][MAX_C];

ll znach(char c)
{
	ll x = (c - 'A') / 2;
	ll y = (c - 'A') % 2;
	if (y == 0)
		return (ll)pow(10LL, x);
	else
		return 5LL * (ll)pow(10LL, x);
}

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--)
	{
		string s;
		cin >> s;
		int n = s.size();

		for (int j = 0; j < MAX_C; j++)
		{
			dp[n][j] = 0;
		}
		for (int i = n - 1; i >= 0; i--)
		{
			for (int j = 0; j < MAX_C; j++)
			{
				dp[i][j] = -INF;
			}

			if (s[i] != '?')
			{
				ll z = znach(s[i]);
				ll j = s[i] - 'A';
				for (int k = 0; k < MAX_C; k++)
				{
					if (dp[i + 1][k] != -INF)
					{
						if (k > j)
						{
							if (dp[i + 1][k] - z > dp[i][k])
							{
								dp[i][k] = dp[i + 1][k] - z;
								to[i][k] = k;
								ans[i][k] = j;
							}
						}
						else
						{
							if (dp[i + 1][k] + z > dp[i][j])
							{
								dp[i][j] = dp[i + 1][k] + z;
								to[i][j] = k;
								ans[i][j] = j;
							}
						}
					}
				}
				//cout << z << " " << dp[i][j] << endl;
			}
			else
			{
				for (int j = 0; j < MAX_C; j++)
				{
					ll z = znach('A' + j);
					for (int k = 0; k < MAX_C; k++)
					{
						if (dp[i + 1][k] != -INF)
						{
							if (k > j)
							{
								if (dp[i + 1][k] - z > dp[i][k])
								{
									dp[i][k] = dp[i + 1][k] - z;
									to[i][k] = k;
									ans[i][k] = j;
								}
							}
							else
							{
								if (dp[i + 1][k] + z > dp[i][j])
								{
									dp[i][j] = dp[i + 1][k] + z;
									to[i][j] = k;
									ans[i][j] = j;
								}
							}
						}
					}
				}
			}
		}

		ll maxi = -INF;
		int cur = -1;
		for (int j = 0; j < MAX_C; j++)
		{
			if (dp[0][j] > maxi)
			{
				maxi = dp[0][j];
				cur = j;
			}
		}
		cout << maxi << endl;

		for (int i = 0; i < n; i++)
		{
			cout << (char)('A' + ans[i][cur]);
			cur = to[i][cur];
		}
		cout << endl;
	}

	return 0;
}