#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
vector<pair<int, int>> g[MAX_N];
int dp[MAX_N];

void f(int v, int mask, int mn, int mx)
{
	dp[v] = min(dp[v], mn + mx);

	for (auto nxt : g[v])
	{
		if (!(mask & (1 << (nxt.first - 1))))
		{
			f(nxt.first, (mask ^ (1 << (nxt.first - 1))), min(mn, nxt.second), max(mx, nxt.second));
		}
	}
}

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	int a, b, t;
	for (int i = 0; i < m; i++)
	{
		cin >> a >> b >> t;
		g[a].push_back({ b, t });
		g[b].push_back({ a, t });
	}

	for (int i = 1; i <= n; i++)
	{
		dp[i] = 2e9;
	}
	f(1, 0, 2e9, -1);

	for (int i = 2; i <= n; i++)
	{
		cout << dp[i] << endl;
	}

	return 0;
}