#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MX = 2e18;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    while (k--) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        vector<bool> used;
        queue<int> q;
        vector<int> right(n), left(n);
        for (int i = l; i <= r; ++i) {
            if(a[i].first + a[i].second > a.back().first)
                right[i] = MX;
            if(a[i].first - a[i].second < a[0].first)
                left[i] = MX;
            for (int j = i + 1; j < n; ++j) {
                if (a[j].first < a[i].first + a[i].second)
                    right[i]++;
                else
                    break;
            }
            for (int j = i - 1; j >= 0; --j) {
                if (a[j].first > a[i].first - a[i].second)
                    left[i]++;
                else
                    break;
            }
        }
        for (int i = l; i <= r; ++i) {
            if (right[i] == 0 || left[i] == 0) {
                q.push(i);
                right[i] = -1;
                left[i] = -1;
            }
        }
        int ans = 0;
        while (!q.empty()) {
            ans++;
            int f = q.front();
            q.pop();
            for (int i = l; i < f; ++i) {
                if (a[i].first + a[i].second > a[f].first) {
                    right[i]--;
                    if (right[i] == 0 || left[i] == 0) {
                        q.push(i);
                        right[i] = -1;
                        left[i] = -1;
                    }
                }
            }

            for (int i = f + 1; i <= r; ++i) {
                if (a[i].first - a[i].second < a[f].first) {
                    left[i]--;
                    if (right[i] == 0 || left[i] == 0) {
                        q.push(i);
                        right[i] = -1;
                        left[i] = -1;
                    }
                }
            }
        }
        cout << ans << "\n";
    }
}
/*
 * 5 6
1 2
2 1
1 5
2 3
2 4
4 2


 4 4
2 1
2 3
2 4
 4 2
 */