#include <bits/stdc++.h>

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pii pair<int, int>
#define ff first
#define ss second

#define left left777
#define right right777
#define dist dist777
#define prev prev777
#define tm tm777

using namespace std;

mt19937 rnd(time(nullptr));

const ll INF = 1e18 + 10;
const int inf = 1e9, N = 3e5 + 10, P = 1e9 + 7, X = 2007;
int dist[N], n, m, ans[N], used[N], t = 0, tin[N], up[N], cmp[N], ans_cmp[N];
vector<pii> g[N], g2[N];
map<pii, int> cnt, bad;

void dfs(int v, int pr, int mn, int mx) {
    if (v != 0) {
        ans[v] = mn + mx;
    }
    for (pii p : g[v]) {
        int u = p.ff, t = p.ss;
        if (u != pr) {
            dfs(u, v, min(t, mn), max(t, mx));
        }
    }
}

void clean() {
    for (int i = 0; i < n; i++) {

    }
}

void solve0() {
    dfs(0, -1, INF, -INF);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << "\n";
    }
    exit(0);
}

void find_br(int v, int pr) {
    tin[v] = up[v] = t;
    t++;
    used[v] = 1;
    for (pii p : g[v]) {
        int u = p.ff;
        if (!used[u]) {
            find_br(u, v);
            up[v] = min(up[v], up[u]);
        } else if (u != pr) {
            up[v] = min(up[v], tin[u]);
        }
    }
    if (pr != -1 && cnt[{v, pr}] == 1 && tin[v] == up[v]) {
        bad[{v, pr}] = bad[{pr, v}] = 1;
    }
}

void solve1() {
    set<pii> st;
    for (int i = 0; i < n; i++) {
        dist[i] = INF;
    }
    dist[0] = -inf;
    st.insert({dist[0], 0});
    while (st.size() > 0) {
        pii p = *st.begin();
        st.erase(p);
        int v = p.ss;
        for (pii p : g[v]) {
            int u = p.ff, w = p.ss, cur = max(w, dist[v]);
            if (dist[u] > cur) {
                st.erase({dist[u], u});
                dist[u] = cur;
                st.insert({dist[u], u});
            }
        }
    }
    for (int i = 1; i < n; i++) {
        cout << dist[i] << '\n';
    }
    cout << "\n";
}

void get_cmp(int v, int c) {
    cmp[v] = c;
    for (pii p : g[v]) {
        int u = p.ff;
        if (cmp[u] == 0 && !bad[{v, u}]) {
            get_cmp(u, c);
        }
    }
}

void solve2() {
    for (int i = 0; i < n; i++) {
        for (pii p : g[i]) {
            int j = p.ff;
            cnt[{i, j}]++;
            //cnt[{j, i}]++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            find_br(i, -1);
        }
    }
    int c = 1;
    for (int i = 0; i < n; i++) {
        if (!cmp[i]) {
            get_cmp(i, c);
        }
    }
    for (int v = 0; v < n; v++) {
        for (pii p : g[v]) {
            int u = p.ff, t = p.ss;
            if (cmp[v] == cmp[u]) {
                ans_cmp[cmp[v]] = min(ans_cmp[cmp[v]], t);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    int f1 = 1, f2 = 1;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        v--;
        u--;
        g[v].push_back({u, t});
        g[u].push_back({v, t});
    }
    for (pii elem : g[0]) {
        if (elem.ss != 0) {
            f1 = 0;
        }
        if (elem.ss != inf) {
            f2 = 0;
        }
    }
    if (m == n - 1) {
        solve0();
    }
    if (f1) {
        solve1();
    }
    /*if (f2) {
        solve2();
    }*/
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    //freopen("input.txt", "r", stdin);

    //cout << setprecision(15) << fixed();
    solve();
    return 0;
}
