#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll Inf = 5e18;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	vector <ll> pw(13);
	pw[0] = 1;
	for (int i = 1; i <= 12; ++i) pw[i] = pw[i - 1] * 10;
	auto get = [&] (int c) {
		int need = c / 2;
		ll res = pw[need];
		if (c % 2 == 1) res *= 5;
		return res;
	};
	int t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;
		int n = s.size();
		vector <vector <ll>> dp(n + 1, vector <ll> (26, -Inf));
		vector <vector <pair <int, int>>> tk(n + 1, vector <pair <int, int>> (26));
		dp[n][0] = 0;
		for (int i = n - 1; i >= 0; --i) {
			for (int pr = 0; pr < 26; ++pr) {
				for (int cr = 0; cr < 26; ++cr) {
					if (s[i] != '?' && s[i] - 'A' != cr) continue;
					ll val = dp[i + 1][pr] + get(cr) * (cr < pr ? -1 : 1);
					ll &cval = dp[i][max(pr, cr)];
					if (val > cval) {
						cval = val;
						tk[i][max(pr, cr)] = make_pair(cr, pr);
					}
				}
			}
		}
		int id = 0;
		for (int i = 0; i < 26; ++i) {
			if (dp[0][i] > dp[0][id]) {
				id = i;
			}
		}
		cout << dp[0][id] << '\n';
		string ans;
		for (int i = 0; i < n; ++i) {
			ans += char('A' + tk[i][id].first);
			id = tk[i][id].second;
		}
		cout << ans << '\n';
	}
}