#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
using namespace std;

vector <int64_t> max_elem_right(string s)
{
	vector <int64_t> st;
	vector <int64_t> ans(s.size(),-1);
	for (int64_t k = s.size() - 1; k > -1; --k)
	{
		if (st.empty())
		{
			st.push_back(k);
		}
		else if ((int)s[st.front()] > (int)s[k])
		{
			ans[k] = st.back();
		}
		else
		{
			while (int(s[st.front()]) <= (int)s[k])
			{
				st.pop_back();
				if (st.empty())
				{
					break;
				}
			}
			st.push_back(k);
		}
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int64_t t, max_indx, res = 0, max_res = -9000000000000000000, count = 0, num = 1;
	vector <int64_t> mean(91,0);
	vector <int64_t> ar, ar_ = {-1,-1,-1};
	for (int64_t k = 65; k <= 90; ++k)
	{
		mean[k] = num;
		if (k % 2 == 1)
		{
			num *= 5;
		}
		else
		{
			num *= 2;
		}
	}
	string s, s_ans, eng = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

	cin >> t;
	for (int64_t k = 0; k < t; ++k)
	{
		cin >> s;
		for (int64_t k = 0; k < s.size(); ++k)
		{
			if (s[k] == '?' && count < 3)
			{
				ar_[count] = k;
				++count;
			}
		}
		if (ar_[0] < 0)
		{
			ar = max_elem_right(s);
			for (int64_t k = 0; k < ar.size(); ++k)
			{
				if (ar[k] < 0)
				{
					res += mean[(int)s[k]];
				}
				else
				{
					res -= mean[(int)s[k]];
				}
			}
			cout << res << '\n' << s << '\n';
			res = 0;
		}
		else if (ar_[1] < 0)
		{
			for (auto k : eng)
			{
				s[ar_[0]] = k;
				ar = max_elem_right(s);
				for (int64_t k = 0; k < ar.size(); ++k)
				{
					if (ar[k] < 0)
					{
						res += mean[(int)s[k]];
					}
					else
					{
						res -= mean[(int)s[k]];
					}
				}
				if (res > max_res)
				{
					max_res = res;
					s_ans = s;
				}
				res = 0;
			}
			cout << max_res << '\n' << s_ans << '\n';
		}
		else if (ar_[2] < 0)
		{
			for (auto k : eng)
			{
				s[ar_[0]] = k;
				for (auto l : eng)
				{
					s[ar_[1]] = l;
					ar = max_elem_right(s);
					for (int64_t k = 0; k < ar.size(); ++k)
					{
						if (ar[k] < 0)
						{
							res += mean[(int)s[k]];
						}
						else
						{
							res -= mean[(int)s[k]];
						}
					}
					if (res > max_res)
					{
						max_res = res;
						s_ans = s;
					}
					res = 0;
				}
			}
			cout << max_res << '\n' << s_ans << '\n';
		}
		else
		{
			for (auto k : eng)
			{
				s[ar_[0]] = k;
				for (auto l : eng)
				{
					s[ar_[1]] = l;
					for (auto i : eng)
					{
						s[ar_[2]] = i;
						ar = max_elem_right(s);
						for (int64_t k = 0; k < ar.size(); ++k)
						{
							if (ar[k] < 0)
							{
								res += mean[(int)s[k]];
							}
							else
							{
								res -= mean[(int)s[k]];
							}
						}
						if (res > max_res)
						{
							max_res = res;
							s_ans = s;
						}
						res = 0;
					}
				}
			}
			cout << max_res << '\n' << s_ans << '\n';
		}
	}

	return 0;
}