#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
using ll = long long;
const int N = 1010;
int f[N][N];
int dp[N][N];
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> h(n + 2), x(n + 2);
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];
	auto can_left = [&](int i, int last) {
		return x[i] - h[i] >= last;
	};
	auto can_right = [&](int i, int last) {
		return x[i] + h[i] <= last;
	};
	for (int i = 1; i <= n; i++) {
		f[i][i - 1] = 1;
		vector<int> s;
		s.pb(i - 1);
		for (int j = i; j <= n; j++) {
			if (!can_left(j, x[s.back()])) {
				s.pb(j);
			}
			while (cap(s) > 1 && can_right(s.back(), x[j + 1]))
				s.pop_back();
			if (cap(s) == 1) f[i][j] = 1;
			dp[i][j] = j - i + 1;
		}
	}
	for (int len = 0; len <= n; len++) {
		for (int i = 1; i + len <= n; i++) {
			int j = i + len;
			if (f[i][j]) dp[i][j] = 0;
			for (int k = i; k <= j; k++)
				dp[i][j] = min(dp[i][j], dp[i][k - 1] + dp[k + 1][j] + 1);
		}
	}
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << r - l + 1 - dp[l][r] << '\n';
	}
	return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
*/