#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()
#define int long long
#define size(a) (int) a.size()
#define fi first
#define se second
#define pii pair<int, int>
#define mp make_pair

const int inf = 2e18;
const int max_n = 5e5 + 3;
int n, m;
set<pii> gr[max_n];
int deep[max_n], par[max_n];
vector<int> ver;
bool used[max_n];

void dfs(int v) {
	used[v] = true;
	bool go = false;
	for(auto to : gr[v]) {
		if (!used[to.fi]) {
			go = true;
			deep[to.fi] = deep[v] + 1;
			dfs(to.fi);
			par[to.fi] = v;
		}
	}
	if (go) {
		ver.emplace_back(v);
	}
}

vector<vector<int>> res;

bool check(int v) {
	vector<int> a, b;
	for(auto to : gr[v]) {
		if (to.fi != par[v]) {
			if (to.se == 1) a.emplace_back(to.fi);
			else b.emplace_back(to.fi);
		}
	}
	for(int i = 0;i < min(size(a), size(b));i++) {
		res.push_back({a[i], v, b[i]});
	}

	int t = abs(size(a) - size(b));
	if (t >= 2 || (t == 1 && par[v] == 0)) return false;
	if (t == 0) return true;

	if (size(a) > size(b)) {
		if (!gr[v].count(mp(par[v], 2))) return false;
		res.push_back({a.back(), v, par[v]});
		gr[par[v]].erase(mp(v, 1));
	}else {
		if (!gr[v].count(mp(par[v], 1))) return false;
		res.push_back({par[v], v, b.back()});
		gr[par[v]].erase(mp(v, 2));

	}
	return true;
}

void solve() {
	cin >> n >> m;
	for(int i = 0;i < m;i++) {
		int v1, v2;
		cin >> v1 >> v2;
		gr[v1].emplace(v2, 2);
		gr[v2].emplace(v1, 1);
	}

	for(int i = 1;i <= n;i++) {
		if (!used[i]) dfs(i);
	}

	sort(all(ver), [&](int v1, int v2) { return deep[v1] > deep[v2]; });

	for(int i : ver) {
		if (!check(i)) {
			//cout << i << endl;
			cout << "No" << endl;
			return;
		}
	}
	cout << "Yes" << endl;
	for(auto i : res) {
		cout << i[0] << " " << i[1] << " " << i[1] << " " << i[2] << endl;
	}
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);

	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	solve();
}