#include <iostream>
#include <vector>
#include <algorithm>
#include "numeric"
#include "set"
#include "map"
#include "queue"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;

vector<vector<pair<int, int>>> g;
vector<int> res;
void dfs(int v, int p, int mn = 1e9 + 1, int mx = 0) {
    res[v] = mn + mx;
    for (auto [i, c] : g[v]) {
        if (i != p) {
            dfs(i, v, min(mn, c), max(mx, c));
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    res.assign(n, -1);
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    //dfs(0, -1);
    priority_queue<pair<int, int>> que;
    que.push({0, 0});
    while (!que.empty()) {
        int v = que.top().second;
        int val = -que.top().first;
        que.pop();
        if (v != -1)
            continue;
        res[v] = val;
        for (auto i : g[v]) {
            que.push({-max(val, i.second), i.first});
        }
    }
    for (int i = 1; i < n; ++i) {
        cout << res[i] << '\n';
    }
}