#include <bits/stdc++.h>

using namespace std;

vector<vector<pair<int, pair<int, int> > > > gr;

int mn = 1e9, mx = 0;

vector<bool> used;
vector<int> res;

void dfs(int x)
{
    cout<< "dfs " <<x << endl;
    res[x] = min(res[x], mn + mx);
    for (auto i : gr[x])
    {
        int to = i.first;
        int num = i.second.second;
        int w = i.second.first;
        if (used[num]) continue;
        used[num] = true;
        int mx1 = mx, mn1 = mn;
        mx = max(mx, w);
        mn = min(mn, w);
        dfs(to);
        mx = mx1;
        mn = mn1;
        used[num] = false;
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    for (int i = 0; i < m; ++i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        --u;
        --v;
        gr[u].push_back({v, make_pair(w, i)});
        gr[v].push_back({u, make_pair(w, i)});
    }
    for (int i = 0; i < n; ++i)
    {
        vector<pair<int, int> > prv, nxt;
        for (int j = 0; j < gr[i].size(); ++j)
        {
            if (gr[i][j].first == i - 1) prv.push_back(gr[i][j].second);
            else nxt.push_back(gr[i][j].second);
        }
        sort(prv.begin(), prv.end());
        sort(nxt.begin(), nxt.end());
        gr[i].clear();
        if (i > 0)
            for (int j = 0; j < min(2, (int)prv.size()); ++j)
                gr[i].push_back({i - 1, prv[j]});
        if (i < n - 1)
            for (int j = 0; j < min(2, (int)nxt.size()); ++j)
                gr[i].push_back({i + 1, nxt[j]});
    }
    used.resize(m);
    res.resize(n, 2e9);
    dfs(0);
    for (int i = 1; i < n; ++i) cout << res[i] << endl;
}
