//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 5e5 + 100, K = 26, INF = 2e18;

int n, q, p[N], pl[N], pr[N];
vector<pair<int, int>> a;
bool used[N], del[N];

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void merge(int f, int s) {
    f = get(f);
    s = get(s);
    p[f] = s;
    pl[s] = min(pl[s], pl[f]);
    pr[s] = max(pr[s], pr[f]);
}

void solve() {
    cin >> n >> q;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    int l, r, ans, ds;
    while (q--) {
        cin >> l >> r;
        l--, r--;
        ans = 0;
        vector<int> ss;
        fill(used, used + n, false);
        fill(del, del + n, false);
        for (int i = 0; i < n; i++) {
            p[i] = i;
            pl[i] = i;
            pr[i] = i;
        }
        for (int i = l; i <= r; i++) {
            ds = 0;
            if (i > 0) ds = max(ds, a[i].first - a[i - 1].first);
            if (i + 1 < n) ds = max(ds, a[i + 1].first - a[i].first);
            if (ds >= a[i].second) {
                ss.push_back(i);
                used[i] = true;
            }
        }
        int cur;
        int pos1, pos2;
        while (!ss.empty()) {
            cur = ss.back();
            ss.pop_back();
            del[cur] = true;
            if (cur + 1 < n && del[cur + 1]) {
                merge(cur, cur + 1);
            }
            if (cur > 0 && del[cur - 1]) {
                merge(cur - 1, cur);
            }
            cur = get(cur);

            pos1 = -1, pos2 = -1;

            if (pr[cur] + 1 < n) {
                pos2 = pr[cur] + 1;
            }
            if (pl[cur] > 0) {
                pos1 = pl[cur] - 1;
            }
            ans++;
            if (pos1 != -1 && pos1 >= l) {
                if (pos2 != -1) {
                    if (a[pos2].first - a[pos1].first >= a[pos1].second && !used[pos1]) {
                        ss.push_back(pos1);
                        used[pos1] = true;
                    }
                } else {
                    if (a[n - 1].first - a[pos1].first >= a[pos1].second && !used[pos1]) {
                        ss.push_back(pos1);
                        used[pos1] = true;
                    }
                }
            }
            if (pos2 != -1 && pos2 <= r) {
                if (pos1 != -1) {
                    if (a[pos2].first - a[pos1].first >= a[pos2].second && !used[pos2]) {
                        ss.push_back(pos2);
                        used[pos2] = true;
                    }
                } else {
                    if (a[pos2].first - a[0].first >= a[pos2].second && !used[pos2]) {
                        ss.push_back(pos2);
                        used[pos2] = true;
                    }
                }
            }
        }
        cout << ans << '\n';
    }
}