#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define FF first
#define SS second
#define ALL(a) a.begin(), a.end()
#define RALL(a) ar.begin(), a.rend()
#define mp make_pair
#define pb push_back
#define pf push_front

using ll = long long;
using ld = long double;

const int INFI = 1e9 + 228;
const ll INFL = 1e18 + 228;
const ld INFLD = 1e18 + 228;
const ld PI = acos(-1);
const int MAXN = 4e5 + 228;
struct Edge {
    int a, b, c;
    Edge(int a, int b, int c): a(a), b(b), c(c) {};
};
vector<int> g[MAXN];
vector<Edge> edges;
void add(int a, int b, int c) {
    g[a].pb(edges.size());
    edges.pb(Edge(a, b, c));
    g[b].pb(edges.size());
    edges.pb(Edge(b, a, 0));
}
int d[MAXN];
bool bfs(int s, int t, int block) {
    for (int i = 0; i <= t; ++i) d[i] = INFI;
    deque<pair<int, int> > q;
    q.pb({s, 0});
    d[s] = 0;
    while (!q.empty()) {
        int v = q.front().FF;
        int ras = q.front().SS;
        q.pop_front();
        for (auto u : g[v]) {
            Edge e = edges[u];
            if (d[e.b] == INFI && e.c >= block) {
                q.pb({e.b, ras + 1});
                d[e.b] = ras + 1;
            }
        }
    }
    return d[t] != INFI;
}
int uk[MAXN];
vector<int> update;
bool dfs(int v, int t, int block) {
    if (v == t) return true;
    while (uk[v] < g[v].size()) {
        Edge e = edges[g[v][uk[v]]];
        if (d[e.b] == d[v] + 1 && e.c >= block && dfs(e.b, t, block)) {
            update.pb(g[v][uk[v]]);
            return true;
        }
        ++uk[v];
    }
    return false;
}
void upd() {
    int minn = INFI;
    for (auto u : update) {
        minn = min(minn, edges[u].c);
    }
    for (auto u : update) {
        edges[u].c -= minn;
        edges[u ^ 1].c += minn;
    }
}
bool used[MAXN];
void run() {
    int n, m;
    cin >> n >> m;
    int s = 0, t = 2 * m + 1;
    vector<pair<int, int> > reb;
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        reb.pb({v, u});
    }
    for (int i = 1; i <= m; ++i) {
        add(s, i, 1);
    }
    for (int i = m + 1; i <= 2 * m; ++i) {
        add(i, t, 1);
    }
    for (int i = 1; i <= m; ++i) {
        for (int j = m + 1; j <= 2 * m; ++j) {
            if (reb[i - 1].SS == reb[j - m - 1].FF) add(i, j, 1);
        }
    }
    for (int delta = (1 << 30); delta > 0; delta /= 2) {
        while (bfs(s, t, delta)) {
            for (int i = 0; i <= t; ++i) uk[i] = 0;
            while (dfs(s, t, delta)) {
                upd();
                update.clear();
            }
        }
    }
    for (auto u : g[s]) {
        if (edges[u].c > 0) {
            cout << "No" << endl;
            return;
        }
    }
    cout << "Yes" << endl;
    for (int i = 1; i <= m; ++i) {
        if (used[i]) continue;
        for (auto u : g[i]) {
            if (edges[u].b == s) continue;
            if (edges[u].c == 0) {
                int w = edges[u].b;
                used[w - m] = true;
                cout << reb[i - 1].FF + 1 << ' ' << reb[i - 1].SS + 1 << ' ' << reb[w - m - 1].FF + 1 << ' ' << reb[w - m - 1].SS + 1 << endl;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    //cin >> t;
    t = 1;
    while (t--) run();
    return 0;
}

