#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N = 510;
int x[N], h[N];

int solve(int l, int r, int xl, int xr) {
	vector<pair<int, int>> v(r - l + 1);
	forn(i, r - l + 1) {
		v[i] = make_pair(x[l + i], h[l + i]);
	}

	int ans = 0;
	while (true) {
		int old = ans;
		forn(i, v.size()) {
			int curl = v[i].first - v[i].second, curr = v[i].first + v[i].second;
			if (xl <= curl && (!i || v[i - 1].first <= curl)) {
				ans++;
				v.erase(v.begin() + i);
				break;
			}
			else if (curr <= xr && (i == (int)v.size() - 1 || curr <= v[i + 1].first)) {
				ans++;
				v.erase(v.begin() + i);
				break;
			}
		}
		if (ans == old) break;
	}
	return ans;
}

int main() {
	fastio;
	int n, q;
	cin >> n >> q;
	forn(i, n) {
		cin >> x[i] >> h[i];
	}

	while (q--) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		cout << solve(l, r, x[max(0, l - 1)], x[min(n - 1, r + 1)]) << '\n';
	}
	return 0;
}