#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cstring>
#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
using namespace std;

const int N = 3000;

vi g[N], back[N];
int n, m;
int p[N], used[N];
int t = 0;
int m1, m2;
vector<pii> e1, e2;

void dfs(int v, int pr, int deep) {
	used[v] = 1;
	p[v] = pr;
	for (int to : g[v]) {
			if (!used[to])
				dfs(to, v, deep + 1);
			if (to != pr) {
				if (deep & 1)
					m1++, e1.push_back({ v, to });
				else
					m2++, e2.push_back({ v, to });
			}
		}
	for (int to : back[v]) {
			if (!used[to])
				dfs(to, v, deep + 1);
			if (to != pr) {
				if (deep & 1)
					m2++, e2.push_back({ to, v });
				else
					m1++, e1.push_back({ to, v });
			}
		}
}


vi g2[N * 2], used2;
int mt[N * 2];

bool kyn(int v) {
	used2[v] = 1;
	for (int to : g2[v])
		if (mt[to] == -1 || (!used[mt[to]] && kyn(mt[to]))) {
				mt[to] = v;
				return true;
			}
	return false;
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		back[v].push_back(u);
	}
	vi root;
	for (int i = 0; i < n; ++i)
		if (!used[i])
			dfs(i, -1, 0), root.push_back(i);
	if (m1 != m2) {
		cout << "NO\n";
		return 0;
	}
	for (int i = 0; i < e1.size(); ++i)
		for (int j = 0; j < e2.size(); ++j) {
			if (e1[i].X == e2[j].Y || e1[i].Y == e2[j].X) {
				g2[i].push_back(j);
			}
		}
	memset(mt, -1, sizeof(mt));
	for (int i = 0; i < m1; ++i) {
		used2.assign(m1, 0);
		kyn(i);
	}
	vector<pair<pii, pii>> res;
	for (int i = 0; i < m1; ++i)
		if (mt[i] == -1) {
			cout << "NO\n";
			return 0;
		}
		else {
			res.push_back({ e2[i], e1[mt[i]] });
		}
	cout << "YES\n";
	for (auto x : res)
		cout << x.X.X + 1 << " " << x.X.Y + 1 << " "  << x.Y.X + 1 << " " << x.Y.Y + 1 << "\n";
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2
*/