#include <bits/stdc++.h>
using namespace std;

#define fi first
#define se second
#define int long long
#define all(x) x.begin(), x.end()

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    unordered_map<char, int> mp;
    for (char c = 'A'; c <= 'Z'; c++) {
        if (c == 'A') {
            mp[c] = 1;
        } else if (c == 'B') {
            mp[c] = 5;
        } else {
            mp[c] = mp[c - 2] * 10;
        }
    }

    int T;
    cin >> T;
    while (T --> 0) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<int> > pref(26, vector<int> (n));
        for (int i = 0; i < n; i++) {
            for (int c = 0; c < 26; c++) {
                if (i != 0) {
                    if (s[i] != '?' && s[i] - 'A' < c) {
                        pref[c][i] = pref[c][i - 1] + mp[s[i]];
                    } else {
                        pref[c][i] = pref[c][i - 1];
                    }
                } else {
                    if (s[i] != '?' && s[i] - 'A' < c) {
                        pref[c][i] = mp[s[i]];
                    }
                }
            }
        }
        vector<int> dp(n, -LLONG_MAX);
        int lastc = -1;
        for (int i = n - 1; i >= 0; i--) {
            if (lastc == -1) {
                if (s[i] != '?') {
                    lastc = s[i] - 'A';
                    dp[i] = mp[s[i]] - pref[lastc][i];
                } else {
                    int maxc = 0;
                    for (int c = 0; c < 26; c++) {
                        if (mp[c + 'A'] - pref[c][i] > dp[i]) {
                            dp[i] = mp[c + 'A'] - pref[c][i];
                            maxc = c;
                        }
                    }
                    lastc = maxc;
                    s[i] = (char)(lastc + 'A');
                }
            } else {
                if (s[i] != '?') {
                    if (s[i] - 'A' >= lastc) {
                        dp[i] = dp[i + 1] + mp[s[i]] - pref[s[i] - 'A'][i] + pref[lastc][i];
                        lastc = s[i] - 'A';
                    } else {
                        dp[i] = dp[i + 1];
                    }
                } else {
                    int maxc = 0;
                    for (int c = lastc; c < 26; c++) {
                        if (dp[i + 1] + mp[c + 'A'] - pref[c][i] + pref[lastc][i] > dp[i]) {
                            dp[i] = dp[i + 1] + mp[c + 'A'] - pref[c][i] + pref[lastc][i];
                            maxc = c;
                        }
                    }
                    lastc = maxc;
                    s[i] = (char)(lastc + 'A');
                }
            }
        }
        cout << dp[0] << '\n';
        cout << s << '\n';
    }

    return 0;
}
/*
1
BBBC

4
BBBC
????
A?B?C?D
YYYYY?
 */