#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> v2p;
typedef vector<vector<pair<int, pair<int, int>>>> graph;
const int inf = 2e9, big = 1e9;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    graph g(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        g[v].emplace_back(u, make_pair(t, i));
        g[u].emplace_back(v, make_pair(t, i));
    }
    set<pair<int, int>> q;
    vi dist(n, inf);
    dist[0] = big;
    q.insert({dist[0], 0});
    vi used(m);
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (size_t i = 0; i < g[v].size(); ++i) {
            int to = g[v][i].first, t = g[v][i].second.first;
            int id = g[v][i].second.second;
            if (!used[id] && dist[to] > min(dist[v], t)) {
                q.erase({dist[to], to});
                dist[to] = min(dist[v], t);
                q.insert({dist[to], to});
                used[id] = 1;
            }
        }
    }
    for (int i = 1; i < n; ++i)
        cout << dist[i] + big << '\n';
}
