#include <bits/stdc++.h>
using namespace std;
#define ll long long
const int N = 3e5 + 113;
vector<pair<int, int>> edges[N];
int n, m;
int ans[N];
void dfs1(int v, int a, int mins, int maxs)
{
    ans[v] = mins + maxs;
    for(auto i : edges[v])
    {
        if(i.first != a)
            dfs1(i.first, v, min(mins, i.second), max(maxs, i.second));
    }
}
void solve1()
{
    dfs1(1, -1, 1e9, -1e9);
    for(int i = 2; i <= n; i++)
        cout<<ans[i]<<" ";
}
vector<pair<pair<int, int>, int>> lst;
const int M = 21;
bool dp[M][1<<M];
void solve34()
{
    int sz = (1<<m);
    dp[1][0] = 1;
    for(int mask = 1; mask < sz; mask++)
    {
        for(int j = 0; j < m; j++)
        {
            if ((mask & (1 << j)) == 0)
                continue;
            if(dp[lst[j].first.first][mask ^ (1<<j)])
                dp[lst[j].first.second][mask] = 1;
            if(dp[lst[j].first.second][mask ^ (1<<j)])
                dp[lst[j].first.first][mask] = 1;
        }
    }
    for(int i = 2; i <= n; i++)
    {
        int minans = 2e9;
        for(int mask = 0; mask < sz; mask++)
        {
            if(!dp[i][mask])
                continue;
            int mins = 1e9, maxs = -1e9;
            for(int j = 0; j < m; j++)
            {
                if(mask & (1<<j))
                    mins = min(mins, lst[j].second), maxs = max(maxs, lst[j].second);
            }
            minans = min(minans, mins + maxs);
        }
        cout<<minans<<" ";
    }
}
void solve2()
{
    vector<int> d(n + 1);
    for(int i = 1; i <= n; i++)
        d[i] = 1e9;
    d[1] = 0;
    set<pair<int, int>> st;
    for(int i = 1; i <= n; i++)
        st.insert({d[i], i});
    while(st.size())
    {
        int v = (*st.begin()).second;
        st.erase(st.begin());
        for(auto i : edges[v])
        {
            if(d[i.first] > max(d[v], i.second))
                st.erase(st.find({d[i.first], i.first})), d[i.first] = max(d[v], i.second), st.insert({d[i.first], i.first});
        }
    }
    for(int i = 2; i <= n; i++)
        cout<<d[i]<<" ";
}
void solve6()
{
    vector<vector<int>> bestnext(n + 1);
    for(int i = 1; i <= n; i++)
    {
        for(auto j : edges[i])
        {
            if(j.first == i + 1)
                bestnext[i].push_back(j.second);
        }
        sort(bestnext[i].begin(), bestnext[i].end());
        reverse(bestnext[i].begin(), bestnext[i].end());
    }
    for(int i = 1; i <= n; i++)
        ans[i] = 2e9;
    ans[1] = 0;
    int maxs = -1e9, mins = 1e9;
    for(int i = 1; i < n; i++)
    {
        maxs = max(maxs, bestnext[i].back());
        mins = min(mins, bestnext[i].back());
        bestnext[i].pop_back();
        ans[i + 1] = min(ans[i + 1], maxs + mins);
        int cmaxs = maxs, cmins = mins;
        for(int j = i; j > 1; j--)
        {
            if(bestnext[j].empty())
                break;
            cmaxs = max(cmaxs, bestnext[j].back());
            cmins = min(cmins, bestnext[j].back());
            ans[j] = min(ans[j], cmaxs + cmins);
        }
    }
    for(int i = 2; i <= n; i++)
        cout<<ans[i]<<" ";
}
void solve3()
{
    for(int i = 1; i <= n; i++)
    {
        for(auto &j : edges[i])
            j.second = 1e9 - j.second;
    }
    vector<int> d(n + 1);
    for(int i = 1; i <= n; i++)
        d[i] = 1e9;
    d[1] = 0;
    set<pair<int, int>> st;
    for(int i = 1; i <= n; i++)
        st.insert({d[i], i});
    while(st.size())
    {
        int v = (*st.begin()).second;
        st.erase(st.begin());
        for(auto i : edges[v])
        {
            if(d[i.first] > max(d[v], i.second))
                st.erase(st.find({d[i.first], i.first})), d[i.first] = max(d[v], i.second), st.insert({d[i.first], i.first});
        }
    }
    for(int i = 2; i <= n; i++)
        cout<<-(d[i] - 2e9)<<" ";
}
signed main()
{
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    bool kek = 1;
    bool f = 1;
    for(int i = 0; i < m; i++)
    {
        int u, v, t;
        cin>>u>>v>>t;
        if(abs(u - v) != 1)
            kek = 0;
        edges[u].push_back({v, t});
        edges[v].push_back({u, t});
        lst.push_back({{u, v}, t});
    }
    if(kek)
    {
        solve6();
        return 0;
    }
    if(m == n - 1)
    {
        solve1();
        return 0;
    }
    bool g2 = 1;
    for(auto i : edges[1])
    {
        if(i.second != 0)
            g2 = 0;
        if(i.second != 1e9)
            f = 0;
    }
    if(g2)
    {
        solve2();
        return 0;
    }
    if(f)
    {
        solve3();
        return 0;
    }
    if(n <= 20)
    {
        solve34();
        return 0;
    }
}
