#pragma GCC target("avx2")
#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 3e5 + 228;
vector<pair<int, int> > g[maxn];
int ans[maxn];
int link[maxn];
int sizex[maxn];

int find(int a){
    return (link[a] == a ? a : link[a] = find(link[a]));
}

void unite(int a, int b){
    a = find(a);
    b = find(b);
    if(sizex[a] > sizex[b])
        swap(a, b);
    link[a] = b;
    sizex[b] += a;
}

bool same(int a, int b){
    return find(a) == find(b);
}

bool cmp(pair<int, pair<int, int> > a, pair<int, pair<int, int> > b){
    return a.second.second < b.second.second;
}

void dfs(int v, int p = -1, int mn = 1e9, int mx = 0){
    ans[v] = mn + mx;
//    cout << v << " " << mn << " " << mx << endl;
    for(pair<int, int> i:g[v]){
        if(i.first == p)
            continue;
        dfs(i.first, v, min(mn, i.second), max(mx, i.second));
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, int> > >  edges;
    for(int i=0; i<maxn; i++){
        link[i] = i;
        sizex[i] = 1;
        ans[i] = 2e9;
    }
    for(int i=0; i<m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        edges.push_back(make_pair(a, make_pair(b, c)));
//        g[a].push_back(make_pair(b, c));
//        g[b].push_back(make_pair(a, c));
    }
    do{
        int cur = 0;
        int mn = 1e9;
        int mx = 0;
        for(pair<int, pair<int, int> > i:edges){
            assert(i.first != i.second.first);
            mx = max(mx, i.second.second);
            mn = min(mn, i.second.second);
            if(i.first == cur){
                ans[i.second.first] = min(ans[i.second.first], mx + mn);
                cur = i.second.first;
                continue;
            }
            if(i.second.first == cur){
                ans[i.first] = min(ans[i.first], mx + mn);
                cur = i.first;
            } else{
                break;
            }
        }
    } while(next_permutation(edges.begin(), edges.end()));
    for(int i=1; i<n; i++)
        cout << ans[i] << endl;
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
==========
4 4
1 2 2
3 2 0
2 4 3
4 3 1
 */