#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 3e5;
const int inf = 1e15;
vector<pair<int, pair<int, int>>> g[maxn];
int ans[maxn];
bool used[maxn];

void dfs2(int v, int mn, int mx, int p) {
    ans[v] = min(ans[v], mn + mx);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if (to == p)continue;
        int t = g[v][i].second.first;
        dfs2(to, min(mn, t), max(mx, t), v);
    }
}

int k = -1;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    for (int i = 0; i < maxn; ++i) {
        ans[i] = inf;
    }
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int t;
        cin >> t;
        g[a].push_back({b, {t, i}});
        g[b].push_back({a, {t, i}});
    }
    if (n - 1 == m) {
        dfs2(0, inf, -inf, -1);
        for (int i = 1; i < n; ++i) {
            cout << ans[i] << "\n";
        }
    } else {
        int need[n];
        for (int i = 0; i < n; ++i) {
            need[i] = inf;
            for (int j = 0; j < g[i].size(); ++j) {
                if (g[i][j].first != i + 1)continue;
                int to = g[i][j].second.first;
                need[i] = min(need[i], to);
            }
        }
        int mx = -inf;
        int mn = inf;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(need[i], mx);
            mn = min(need[i], mn);
            ans[i] = mx + mn;
        }
        for (int i = n - 2; i >= 0; --i) {
            ans[i] = min(ans[i], ans[i + 1]);
        }
    }
}
