//#pragma GCC optimize("O3")

#include <bits/stdc++.h>
using namespace std;

#define int long long

#define sz(x) static_cast<int>(x.size())
const int N = 2e3 + 10;

int n, m;
vector <pair <int, int>> g[N];

int dist[N][2];
int ans[N];

void solve1() {
    fill(ans, ans + N, 1e18);

    for (int i = 0; i < n; i++) {
        //cout << sz(g[i]) << endl;
        for (auto [j, ww] : g[i]) {
            //cout << i << " " << j << " " << ww << endl;

            fill(&dist[0][0], &dist[N - 1][1] + 1, 1e18);

            set <tuple <int, int, int>> s;
            s.insert({ 0, 0, 0 });

            while (!s.empty()) {
                auto [l, u, flag] = *s.begin();
                s.erase(s.begin());

                for (auto [v, w] : g[u]) {
                    if (w < ww) continue;
                    if (flag && (u == i && v == j && w == ww)) continue;
                    int to = flag || (u == i && v == j && w == ww);

                    int d = min(w, dist[u][flag]);
                    if (dist[v][to] > d) {
                        s.erase({ dist[v][to], v, to });
                        dist[v][to] = d;
                        s.insert({ dist[v][to], v, to });
                    }
                }
            }

            cout << ww << endl;
            for (int i = 0; i < n; i++) {
                cout << dist[i][1] << " ";
                ans[i] = min(ans[i], dist[i][1] + ww);
            }
            cout << endl;
        }
    }

    for (int i = 1; i < n; i++) {
        cout << ans[i] << "\n";
    }
}

void dfs(int u, int p, int mx, int mn) {
    ans[u] = mn + mx;

    for (auto [v, w] : g[u]) {
        if (v != p) {
            dfs(v, u, max(mx, w), min(mn, w));
        }
    }
}

void solve2() {
    dfs(0, -1, 0, 1e18);

    for (int i = 1; i < n; i++) {
        cout << ans[i] << "\n";
    }
}

signed main() {
#ifdef CHOPPAWONTMISS
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;

        g[u].push_back({ v, w });
        g[v].push_back({ u, w });
    }

    solve2();

    return 0;
}