#include <bits/stdc++.h>

using namespace std;
const int INF = 1e9;

struct edge {
    int x, y, w, i;

    edge() {}

    edge(int x, int y, int w, int i) : x(x - 1), y(y - 1), w(w), i(i) {}
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <vector <edge>> g(n);
    vector <int> all;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        all.push_back(w);
        g[x - 1].emplace_back(x, y, w, i);
        g[y - 1].emplace_back(y, x, w, i);
    }
    all.push_back(INF);
    vector <vector <int>> a(n, vector <int> (m + 1, INF));
    set <pair <int, pair <int, int>>> s;
    s.insert(make_pair(0, make_pair(0, m)));
    a[0][m] = 0;
    vector <vector <bool>> used(n, vector <bool> (m + 1));
    while (!s.empty()) {
        auto now = *s.begin();
        used[now.second.first][now.second.second] = true;
        s.erase(s.begin());
        int v = now.second.first, minn = now.second.second;
        for (auto i : g[v]) {
            int new_minn = minn;
            if (i.w < all[minn]) new_minn = i.i;
            if (a[i.y][new_minn] > max(now.first, i.w) && !used[i.y][new_minn]) {
                s.erase(make_pair(a[i.y][new_minn], make_pair(i.y, new_minn)));
                a[i.y][new_minn] = max(now.first, i.w);
                s.insert(make_pair(a[i.y][new_minn], make_pair(i.y, new_minn)));
            }
        }
    }
    for (int i = 1; i < n; ++i) {
        int res = 2 * INF;
        for (int j = 0; j <= m; ++j) {
            res = min(res, all[j] + a[i][j]);
        }
        cout << res << "\n";
    }
}

