#include <iostream>
#include <vector>
#include <algorithm>
#include <array>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 3e5 + 228;
const int K = 19;
const int INF = 1e9 + 228;

vector<pair<int, int>> G[N];

int ans[N];

void dfs(int v, int p = 0, int val1 = 0, int val2 = 1e9 + 228) {
	ans[v] = val1 + val2;
	for (auto i : G[v]) {
		if (i.first != p)
			dfs(i.first, v, max(val1, i.second), min(val2, i.second));
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, t;
		cin >> a >> b >> t;
		G[a - 1].emplace_back(b - 1, t);
		G[b - 1].emplace_back(a - 1, t);
	}

	dfs(0);
	for (int i = 1; i < n; ++i)
		cout << ans[i] << '\n';
}