#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MAXN = 3e5;
vector<int> et;
vector<vector<int> > gd;

void dfs(int v, int p){
    et.push_back(v);
    for(auto to: gd[v]){
        if(to == p) continue;
        dfs(to, v);
        et.push_back(v);
    }
}

vector<int> pr;

int get(int v){
    if(pr[v] == v) return v;
    else return pr[v] = get(pr[v]);
}

void merge(int u, int v){
    u = get(u);
    v = get(v);
    if(rand() % 2) pr[u] = v;
    else pr[v] = u;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    set<pair<int, int> > edges;
    gd.resize(n);
    pr.resize(n);
    iota(pr.begin(), pr.end(), 0);
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--, v--;
        if(get(u) != get(v)){
            gd[u].push_back(v);
            gd[v].push_back(u);
            merge(u, v);
        }
        edges.insert({u, v});
    }
    for(int i = 1; i < n; i++){
        if(get(i) != get(i - 1)){
            gd[i].push_back(i - 1);
            gd[i - 1].push_back(i);
            merge(i, i - 1);
        }
    }
    dfs(0, -1);
    //euler tour
    int cnt = 0;
    vector<int> kek;
    for(int i = 1; i < et.size(); i++){
        //u -> v
        //if not => reverse v, u
        int u = et[i - 1], v = et[i];
        if(edges.find({u, v}) == edges.end()){
            kek.push_back(cnt);
            cnt = 0;
        } else cnt++;
    }
    kek.push_back(cnt);
    et.pop_back();
    kek[0] += kek.back();
    bool ok = true;
    for(int i = 0; i < kek.size() - 1; i++){
        if(kek[i] % 2) ok = false;
    }
    if(!ok) return cout << "No\n", 0;
    cout << "Yes\n";
    int it = kek[0] - kek.back() + 1;
    for(int tt = 1; tt < kek.size(); tt++){
        int j = tt % (kek.size() - 1);
        for(int lol = 0, i = it; lol < kek[j]; lol += 2, i += 2){
            cout << et[i % et.size()] + 1 << ' ' << et[(i + 1) % et.size()] + 1 << ' ' << et[(i + 1) % et.size()] + 1 << ' ' << et[(i + 2) % et.size()] + 1 << endl;
        }
        it += kek[j] + 1;
    }
}