#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define fast cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const int N = 1e5;
const int MOD = 1e9 + 7;
const int INF = 1.7e18;

vector<vector<int> > gr, cnt1, cnt2, ans;
vector<int> used;
bool flag = 0;
set<pair<int, int> > exist;

void dfs(int v, int p) {
    vector<int> in, out;
    used[v] = 1;
    for (int u : gr[v]) {
        if (u == p) continue;
        if (used[u] == 1) continue;
        dfs(u, v);
        int exist1 = 0, exist2 = 0;
        if (exist.find({v, u}) != exist.end()) exist1 = 1;
        if (exist.find({u, v}) != exist.end()) exist2 = 1;
        if (cnt1[u].size() > exist1 || cnt2[u].size() > exist2) {
            cout << "No\n";
            exit(0);
        }
//        if (u == 2) {
//            cout << exist1 << ' ' << exist2 << '\n';
//        }
        if (cnt1[u].size() == 1) {
            int t = cnt1[u][0];
            ans.push_back({v, u, u, t});
            exist1 = 0;
        }
        if (cnt2[u].size() == 1) {
            int t = cnt2[u][0];
            ans.push_back({t, u, u, v});
            exist2 = 0;
        }
        if (exist1 == 1) out.push_back(u);
        if (exist2 == 1) in.push_back(u);
    }
    int sz = min(in.size(), out.size());
    for (int i = 0; i < sz; i++) {
        ans.push_back({in[i], v, v, out[i]});
    }
    for (int i = sz; i < in.size(); i++) {
        cnt2[v].push_back(in[i]);
    }
    for (int i = sz; i < out.size(); i++) {
        cnt1[v].push_back(out[i]);
    }
}

signed main() {
#ifdef parasha
    freopen("Untitled2.cpp", "r", stdin);
#endif // parasha
    fast;
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    cnt1.resize(n);
    cnt2.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
        exist.insert({v, u});
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            dfs(i, -1);
            if (!cnt1[i].empty() || !cnt2[i].empty()) {
                cout << "No\n";
                exit(0);
            }
        }
    }
    cout << "Yes\n";
    for (int i = 0; i < ans.size(); i++) {
        for (int j : ans[i]) cout << j + 1 << ' ';
        cout << '\n';
    }

}
