#include<bits/stdc++.h>
#define fi first
#define se second
#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb emplace_back
#define mpa make_pair
using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<int> x(m), y(m), c(m);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        cin >> x[i] >> y[i] >> c[i];
        --x[i]; --y[i];
        g[x[i]].pb(i);
        g[y[i]].pb(i);
    }

    vector<int> used(n);
    vector<int> maxup(n, 1e9);
    vector<int> dep(n);
    vector<int> bridge(m);
    function<void(int, int, int)> dfs = [&](int v, int d, int came) {
        dep[v] = maxup[v] = d;
        used[v] = 1;
        for (auto &i : g[v]) {
            int to = (v ^ x[i] ^ y[i]);
            if (!used[to]) {
                //cout << v + 1 << " -> " << to + 1 << endl;
                dfs(to, d + 1, i);
                if (maxup[to] > dep[v]) {
                    bridge[i] = 1;
                }
            }
        }
        for (auto &i : g[v]) {
            int to = (v ^ x[i] ^ y[i]);
            if (used[to] && i != came) {
                if (dep[to] < dep[v]) {
                    maxup[v] = min(maxup[v], dep[to]);
                } else {
                    maxup[v] = min(maxup[v], maxup[to]);
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i, 0, -1);
        }
    }
    for (int i = 0; i < m; ++i) {
        if (bridge[i]) {
            //cout << x[i] + 1 << " " << y[i] + 1 << endl;
        }
    }
    for (int i = 0; i < n; ++i) {
        //cout << i << " : " << maxup[i] << " " << dep[i] << endl;
    }
    vector<int> p(n);
    vector<int> mn(n);
    function<int(int)> gp = [&](int v) {
        if (p[v] == v) return v;
        return p[v] = gp(p[v]);
    };
    function<void(int, int)> unite = [&](int v, int u) {
        v = gp(v);
        u = gp(u);
        if (v == u) return;
        p[u] = v;
        mn[v] = min(mn[v], mn[u]);
    };
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        mn[i] = 1e9 + 5;
    }
    for (int i = 0; i < m; ++i) {
        if (!bridge[i]) {
            unite(x[i], y[i]);
            mn[gp(x[i])] = min(mn[gp(x[i])], c[i]);
        }
    }
    vector<int> used2(n);
    vector<vector<int>> g3(n);
    for (int i = 0; i < n; ++i) {
        for (auto &j : g[i]) {
            if (gp(x[j]) != gp(y[j])) {
                g3[gp(i)].pb(j);
            }
        }
    }
    function<void(int, int)> dfs2 = [&](int v, int w) {
        used2[v] = 1;
        w = min(w, mn[v]);
        mn[gp(v)] = w;
        for (auto &i : g3[v]) {
            if (bridge[i]) {
                int to = (v ^ gp(x[i]) ^ gp(y[i]));
                if (!used2[to]) {
                    dfs2(to, min(w, c[i]));
                }
            }
        }
    };
    for (int i = 0; i < n; ++i) {
        if (!used2[gp(i)]) {
            dfs2(gp(i), 1e9 + 5);
        }
    }
    const int inf = 1e9;
    for (int i = 1; i < n; ++i) {
        cout << mn[gp(i)] + inf << " ";
    }
}
/*
5 7
1 2 5
2 3 1
2 3 2
2 3 3
1 4 1
1 5 1
1 5 2


14 18
1 2 1
1 2 2
1 2 3
2 3 1
3 4 4
3 6 6
4 5 5
5 6 6
6 7 7
7 8 8
7 9 9
1 10 10
10 11 11
10 13 13
10 14 14
10 12 12
11 12 12
13 14 14
*/
