#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
using namespace std;
#define int long long
const int MAX = 400000;
const int INF = 1e18;
int t;
string s;
vector<pair<int, int>> tree;
int ri[MAX], le[MAX], si[MAX], pred[MAX];
bool cut[MAX];
int n, q, x, y;
vector<int> read, may;
int root(int v) {
	if (pred[v] == v) {
		return v;
	}
	pred[v] = root(pred[v]);
	return pred[v];
}
signed main() {
	cin >> n >> q;
	for (int i = 0; i < n; i++) {
		cin >> x >> y;
		tree.push_back({ x, y });
	}
	for (int i = 0; i < n; i++) {
		pred[i] = i;
		int l = 0, r = n; 
		while (r - l > 1) {
			int res = (r + l) / 2;
			if (tree[i].first + tree[i].second <= tree[res].first) {
				r = res;
			}
			else {
				l = res;
			}
		}
		ri[i] = r - i - 1;
		if (r == n) {
			ri[i] = INF;
		}
		l = -1;
		r = n;
		while (r - l > 1) {
			int res = (r + l) / 2;
			if (tree[i].first - tree[i].second >= tree[res].first) {
				l = res;
			}
			else {
				r = res;
			}
		}
		le[i] = i - l - 1;
		if (l == -1) {
			le[i] = INF;
		}
	}
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		int ans = 0;
		read.clear();
		may.clear();
		for (int j = l; j <= r; j++) {
			if (le[j] == 0 || ri[j] == 0) {
				read.push_back(j);
			}
		}
		while (read.size() > 0 || may.size() > 0) {
			while (may.size() > 0) {
				int act = may.back();
				may.pop_back();
				if (act < l || act > r || cut[act]) {
					continue;
				}
				if ((act >= 1 && si[root(act - 1)] >= le[act]) || si[root(act + 1)] >= ri[act]) {
					read.push_back(act);
				}
			}
			if (read.size() > 0) {
				int act = read.back();
				read.pop_back();
				if (cut[act]) {
					continue;
				}
				cut[act] = true;
				if (act > 0) {
					may.push_back(act - si[root(act - 1)] - 1);
				}
				may.push_back(act + si[root(act + 1)] + 1);
				si[act]++;
				if (act - 1 >= 0 && cut[act - 1]) {
					si[root(act - 1)] += si[i];
					pred[root(i)] = root(act - 1);
				}
				if (cut[act + 1]) {
					si[root(act + 1)] += si[i];
					pred[root(i)] = root(act + 1);
				}
				ans++;
			}
		}
		for (int j = l; j <= r; j++) {
			cut[j] = 0;
			pred[j] = j;
			si[j] = 0;
		}
		cout << ans << endl;
	}
	return 0;
}