#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;

vector<lpair> v;
lvec used;

ll solve(ll l, ll r) {
    ll ans = 0;
    bool change = true;
    while (change) {
        change = false;
        ll prev = l - 1;
        ll nxt = l + 1;
        while (used[nxt]) nxt++;
        for (ll i = l; i < r; i++) {
            if (used[i]) continue;
            auto[x, h] = v[i];
            if (v[prev].first <= x - h || x + h <= v[nxt].first) {
                used[i] = true;
                ans++;
                change = true;
                break;
            }
            prev = i;
            do nxt++;
            while (used[nxt]);
        }
    }
    return ans;
}

int main() {
   // freopen("A.in", "r", stdin);
    ll n, q;
    cin >> n >> q;
    v.resize(n);
    for (auto &p : v) cin >> p.first >> p.second;
    v.push_back(v.back());
    v.insert(v.begin(), *v.begin());
    while (q--) {
        used.assign(n + 2, 0);
        ll l, r;
        cin >> l >> r;
        cout << solve(l, r + 1) << "\n";
    }
    return 0;
}
