#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <cmath>

using namespace std;

int gett(int a, vector <int> &p) {
    if (p[a] != a) {
        p[a] = gett(p[a], p);
    }
    return p[a];
}

void unite(vector <int> &p, int a, int b) {
    a = gett(a, p);
    b = gett(b, p);
    p[a] = p[b];
}

signed main() {
    int n, q;
    cin >> n >> q;
    vector <pair<int, int>> der;
    int lx;
    int rx;
    for (int i = 0; i < n; i++) {
        int fire, sece;
        cin >> fire >> sece;
        der.push_back({fire, sece});
    }
    for (int tt = 0; tt < q; tt++) {
        int l, r;
        cin >> l >> r;
        if (n == 1) {
            cout << 0 << "\n";
        }
        else {
            int ch = 1;
            vector <int> pl(n);
            vector <int> pr(n);
            for (int i = 0; i < n; i++) {
                pl[i] = i;
            }
            for (int i = 0; i < n; i++) {
                pr[i] = i;
            }
            int ans = 0;
            while (ch) {
                int nww = 0;
                for (int idd = l - 1; idd <= r - 1; idd++) {
                    if (pr[idd] == idd and pl[idd] == idd) {
                        if (idd > 0) {
                            int left = gett(pl[idd - 1], pl);
                            if (der[idd].first - der[left].first >= der[idd].second) {
                                ans++;
                                nww++;
                                unite(pl, idd, idd - 1);
                                if (idd < n - 1) {
                                    unite(pr, idd, idd + 1);
                                }
                            }
                        }
                        if (pr[idd] == idd and pl[idd] == idd and idd < n - 1) {
                            int left = gett(pr[idd + 1], pr);
                            if (-der[idd].first + der[left].first >= der[idd].second) {
                                ans++;
                                nww++;
                                if (idd > 0) {
                                    unite(pl, idd, idd - 1);
                                }
                                unite(pr, idd, idd + 1);
                            }
                        }
                    }
                }
                if (nww == 0) {
                    ch = 0;
                }
            }
            cout << ans << "\n";
        }
    }
}
