#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double


using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = (int)2e18 + 109;
const int NMAX = 3010;

string s;
int bad[NMAX][26][26];
int dp[NMAX][26], p[NMAX][26];

int w[26];
vector<int> var[NMAX];

string ans;

void solve_solve_solve() {
    for (int i = 0; i < NMAX; i++) {
        fill(dp[i], dp[i] + 26, -INF);
    }

    memset(p, -1, sizeof(p));
    memset(bad, 0, sizeof(bad));

    w[0] = 1, w[1] = 5;
    for (int i = 1; i < 13; i++) {
        w[2 * i] = w[2 * (i - 1)] * 10;
        w[2 * i + 1] = w[2 * (i - 1) + 1] * 10;
    }

    /*
    cout << "w = \n";
    for (int i = 0; i < 26; i++) {
        cout << "OK " << i << " " << w[i] << "\n";
    }
    cout << "END\n\n";
    */


    cin >> s;
    int n = sz(s);

    for (int i = 0; i < n; i++) {
        if (s[i] == '?') {
            for (int j = 0; j < 26; j++) {
                var[i].pub(j);
            }
        } else {
            var[i] = {s[i] - 'A'};
        }
    }

    for (int i : var[0]) {
        dp[0][i] = w[i];

        for (int j = i; j < 26; j++) {
            bad[0][i][j] = w[i];
        }
    }

    for (int i = 1; i < n; i++) {
        for (int j : var[i]) {
            for (int k : var[i - 1]) {
                int t = dp[i - 1][k] + w[j];

                if (j - 1 >= 0) {
                    t -= 2 * bad[i - 1][k][j - 1];
                }

                if (t > dp[i][j]) {
                    dp[i][j] = t;
                    p[i][j] = k;
                    //bad[i] = bad[i - 1];

                    copy(bad[i - 1][k], bad[i - 1][k] + 26, bad[i][j]);

                    for (int x = 0; x < j; x++) {
                        bad[i][j][x] = 0;
                    }
                    for (int x = j; x < 26; x++) {
                        bad[i][j][x] += w[j];
                    }
                }
            }
        }
    }

    int M = -INF, ind;
    for (int i = 0; i < 26; i++) {
        if (dp[n - 1][i] > M) {
            M = dp[n - 1][i], ind = i;
        }
    }

    //cout << "M = " << M << "\n";
   /*
    cout << "dp = \n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++) {
            cout << dp[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "END\n\n";

    */
   /*
    cout << "bad = \n";
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++) {
            cout << bad[i][j] << " ";
        }
        cout << "\n";
    }
    cout << "END\n\n";
    */

    ans = "";

    int x = n - 1, y = ind;
    while (true) {
        ans += char(y + 'A');
        y = p[x][y];

        x--;

        if (y == -1) {
            break;
        }
    }

    reverse(all(ans));

    cout << M << "\n" << ans << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    int Q = 1;
    cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
