#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define x first
#define y second

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define int long long
#define double long double


using namespace std;
using namespace __gnu_pbds;

typedef pair<int, int> pii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ord_set;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int INF = (int)2e16 + 109;
const int NMAX = 500010;

int a[NMAX], h[NMAX];
vector<pii> v, t;

pair<vector<int>, vector<int> > dep[NMAX];

struct dot {
    int x, y, ind;
};

struct cmp {
    bool operator()(dot a, dot b) const {
        return (min(a.x, a.y) == min(b.x, b.y)) ? a.ind < b.ind : min(a.x, a.y) < min(b.x, b.y);
    }
};

set<dot, cmp> s;
vector<int> used;

void solve_solve_solve() {
    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> h[i];
    }

    v.resize(n, {0, 0});
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (a[i] - a[j] < h[i]) {
                v[i].x++;
                dep[j].y.pub(i);
            } else {
                break;
            }
        }

        for (int j = i + 1; j < n; j++) {
            if (a[j] - a[i] < h[i]) {
                v[i].y++;
                dep[j].x.pub(i);
            } else {
                break;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (a[i] - h[i] < a[0]) {
            v[i].x = INF;
        }
        if (a[i] + h[i] > a[n - 1]) {
            v[i].y = INF;
        }
    }

    /*
    cout << "v = \n";
    for (int i = 0; i < n; i++) {
        cout << v[i].x << " " << v[i].y << "\n";
    }
    cout << "END\n";
    */

    while (q--) {
        t = v;

        int l, r;
        cin >> l >> r;

        l--, r--;

        //cout << "START " << l << " " << r << "\n";

        s.clear();
        for (int i = l; i <= r; i++) {
            s.insert({v[i].x, v[i].y, i});
        }

        int ans = 0;

        used.assign(n, 0);
        while (!s.empty()) {

            /*
            cout << "s = " << ans << "\n";
            for (auto it : s) {
                cout << it.x << " " << it.y << " " << it.ind << "\n";
            }
            cout << "END\n";
            */

            dot x = *s.begin();
            s.erase(s.begin());

            if (min(x.x, x.y) != 0) {
                break;
            }

            used[x.ind] = 1;

            ans++;

            int ind = x.ind;

            for (int i : dep[ind].x) {
                if (!(l <= i && i <= r) || used[i]) {
                    continue;
                }

                s.erase({t[i].x, t[i].y, i});
                t[i].y--;
                s.insert({t[i].x, t[i].y, i});
            }
            for (int i : dep[ind].y) {
                if (!(l <= i && i <= r) || used[i]) {
                    continue;
                }

                s.erase({t[i].x, t[i].y, i});
                t[i].x--;
                s.insert({t[i].x, t[i].y, i});
            }
        }

        cout << ans << "\n";
    }
}


signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0), cout.tie(0);

    int Q = 1;
    //cin >> Q;

    while (Q--) {
        solve_solve_solve();
    }

    return 0;
}
