#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
typedef long long ll;
typedef long double ld;

const int N = 5e5 + 10;

int x[N], h[N];
int lef[N], rig[N];
char used[N];

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, queries;
	cin >> n >> queries;
	for (int i = 1; i <= n; ++i)
		cin >> x[i] >> h[i];
	x[0] = x[1];
	x[n + 1] = x[n];

	for (int query = 0; query < queries; ++query) {
		int l, r;
		cin >> l >> r;
		++r;
		
		queue<int> bfs;
		for (int i = l; i < r; ++i) {
			lef[i] = i - 1, rig[i] = i + 1;
			if (x[lef[i]] <= x[i] - h[i] ||
				x[rig[i]] >= x[i] + h[i])
				bfs.push(i);
		}
		int cnt = 0;
		fill(used + l, used + r, 0);
		while (sz(bfs)) {
			int i = bfs.front();
			// cout << "at " << i << endl;
			bfs.pop();
			if (used[i])
				continue;
			used[i] = 1;
			if (x[lef[i]] <= x[i] - h[i] ||
				x[rig[i]] >= x[i] + h[i]) {
				// cout << "gone" << endl;
				++cnt;
				if (l <= lef[i] && lef[i] < r) {
					rig[lef[i]] = rig[i];
					bfs.push(lef[i]);
				}
				if (l <= rig[i] && rig[i] < r) {
					lef[rig[i]] = lef[i];
					bfs.push(rig[i]);
				}
			}
		}
		cout << cnt << "\n";
	}
	return 0;
}