#include <bits/stdc++.h>

///#define int ll

using namespace std;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define _ << " " <<

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int MXN = 5e5+111;

int x[MXN];
int h[MXN];
int lt[MXN];
int rt[MXN];

int n, q;

struct segment {
    vector<int> a;
    int l, r;
    segment() {};
    segment(vector<int> a1, int l1, int r1) {
        a = a1; l = l1; r = r1;
    }
};

segment mrg(segment seg_a, segment seg_b) {
    /*cout << "seg_a:" << endl;
    cout << "seg_a.a: ";
    for (auto to: seg_a.a) {
        cout << to << " ";
    } cout << endl;
    cout << "seg_a lr =" << seg_a.l _ seg_a.r << endl;
    cout << endl;

    cout << "seg_b:" << endl;
    cout << "seg_b.a: ";
    for (auto to: seg_b.a) {
        cout << to << " ";
    } cout << endl;
    cout << "seg_b lr =" << seg_b.l _ seg_b.r << endl;
    cout << endl;//*/

    vector<int> a = seg_a.a;
    int la = seg_a.l;
    int ra = seg_a.r;

    vector<int> b = seg_b.a;
    int lb = seg_b.l;
    int rb = seg_b.r;

    bool fl = true;
    while (fl) {
        fl = false;
        if (!a.empty() && rt[a.back()] <= rb && ((b.empty()) || (b.front() > rt[a.back()]))) {
            fl = true;
            a.pop_back();
        }
        if (!b.empty() && lt[b.front()] >= la && ((a.empty()) || (a.back() < lt[b.front()]))) {
            fl = true;
            b.pop_back();
        }
    }
    for (auto to: b) {
        a.push_back(to);
    }
    la = min(la, lb);
    ra = max(ra, rb);
    seg_a = segment(a, la, ra);
    /*cout << "seg_a:" << endl;
    cout << "seg_a.a: ";
    for (auto to: seg_a.a) {
        cout << to << " ";
    } cout << endl;
    cout << "seg_a lr =" << seg_a.l _ seg_a.r << endl;
    cout << endl;//*/
    return seg_a;
}

void solve() {
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int i = 1; i <= n; ++i) {
        int l = i;
        int r = n+1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if ((x[m] - x[i]) < h[i]) l = m;
            else r = m;
        }
        rt[i] = l;
    }
    for (int i = 1; i <= n; ++i) {
        int l = 0;
        int r = i;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if ((x[i] - x[m]) < h[i]) r = m;
            else l = m;
        }
        lt[i] = r;
    }
    for (int i = 1; i <= n; ++i) {
        if (x[i] - h[i] < x[1]) lt[i] = 0;
        if (x[i] + h[i] > x[n]) rt[i] = n+1;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        //cout << "l=" << l _ "r=" << r << endl;
        vector<segment> v;
        for (int i = l; i <= r; ++i) {
            if (rt[i] == i || lt[i] == i) v.push_back(segment({}, i, i));
            else v.push_back(segment({i}, i, i));
        }
        while (v.size() > 1) {
            vector<segment> lv;
            for (int i = 0; i < v.size(); i += 2) {
                if (i+1 < v.size()) lv.push_back(mrg(v[i], v[i+1]));
                else lv.push_back(v[i]);
            }
            swap(v, lv);
        }
        cout << (r - l + 1) - ((int)v[0].a.size()) << "\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}

