#include<bits\stdc++.h>
using namespace std;

const int MAXN = 5e3;
const int INF = 1e6;
int x[MAXN];
int h[MAXN];
int tin[MAXN];
int in[MAXN];
vector<int> g[3 * MAXN];
vector<int> p[3 * MAXN];
bool used[3 * MAXN];
vector<int> top;

void dfs(int u) {
    used[u] = true;
    for (auto v : p[u]) {
        if (!used[v]) {
            dfs(v);
        }
    }
    top.push_back(u);
}

deque<int> que;

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            p[i].push_back(i + n);
            g[i + n].push_back(i);
            tin[i]++;
            //tin[i + n]++;
            int j = i - 1;
            while (j >= 0 && x[i] - h[i] < x[j]) {
                p[i + n].push_back(j);
                g[j].push_back(i + n);
                tin[i + n]++;
                //tin[j]++;
                j--;
            }
        }
        if (i < n - 1) {
            p[i].push_back(i + 2 * n);
            g[i + 2 * n].push_back(i);
            tin[i]++;
            //tin[i + 2 * n]++;
            int j = i + 1;
            while (j < n && x[i] + h[i] > x[j]) {
                p[i + 2 * n].push_back(j);
                g[j].push_back(i + 2 * n);
                tin[i + 2 * n]++;
                //tin[j]++;
                j++;
            }
        }
    }
    /*for (int i = 0; i < 3 * n; ++i) {
        cout << tin[i] << " ";
    }
    cout << "\n";
    for (int i = 0; i < 3 * n; ++i) {
        cout << i << ":\n";
        for (auto it : g[i]) {
            cout << it << " ";
        }
        cout << "\n";
    }*/
    for (int tst = 0; tst < q; ++tst) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        for (int i = 0; i < n; ++i) {
            in[i] = tin[i];
            in[i + n] = tin[i + n];
            in[i + 2 * n] = tin[i + 2 * n];
            used[i] = !(l <= i && i <= r);
            used[i + n] = !(l <= i && i <= r);
            used[i + 2 * n] = !(l <= i && i <= r);
            if (in[i] == 0) que.push_back(i);
            if (in[i + n] == 0) que.push_back(i + n);
            if (in[i + 2 * n] == 0) que.push_back(i + 2 * n);
        }
        int ans = 0;
        while (!que.empty()) {
            int u = que.front(); que.pop_front();
            //cout << u << "\n";
            for (auto v : g[u]) {
                if (!used[v]) {
                    if (v < n) {
                        que.push_back(v);
                        used[v] = true;
                        ans++;
                    } else {
                        in[v]--;
                        if (in[v] == 0) {
                            que.push_back(v);
                            used[v] = true;
                        }
                    }
                }
            }
        }
        cout << ans << "\n";
        //cout << endl;
    }
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3

5 3
1 5
3 1
4 2
5 3
6 1
1 5
5 5
1 1
*/

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
