#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <deque>
#include <map>
#include <string>
#include <cassert>


#define x first
#define y second


//typedef pair<int, int> pii;


using namespace std;


#pragma warning(disable:4996)


const int maxn = 5e5;


int h[maxn];
int x[maxn];
int prv[maxn];
int nxt[maxn];
bool used[maxn];


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, q;
	cin >> n >> q;
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		for (int i = 0; i < n; i++)
			used[i] = 1;
		for (int i = l; i <= r; i++)
			used[i] = 0;
		if (l == 0)
			prv[l] = 0;
		else
			prv[l] = l - 1;
		if (r == n - 1)
			nxt[r] = n - 1;
		else
			nxt[r] = r + 1;
		for (int i = l + 1; i <= r; ++i)
			prv[i] = i - 1;
		for (int i = r - 1; i >= l; i--)
			nxt[i] = i + 1;
		int ans = 0;
		deque<int> d;
		for (int i = l; i <= r; i++)
			d.push_back(i);
		while (!d.empty()) {
			int v = d.front();
			d.pop_front();
			if (used[v])
				continue;
			//cout << v << ' ' << prv[v] << ' ' << nxt[v] << '\n';
			if (x[v] - h[v] >= x[prv[v]] || x[v] + h[v] <= x[nxt[v]]) {
				used[v] = 1;
				ans++;
				int pr = prv[v];
				int nx = nxt[v];
				prv[nx] = pr;
				nxt[pr] = nx;
				if (!used[nx])
					d.push_back(nx);
				if (!used[pr])
					d.push_back(pr);
			}
		}
		cout << ans << '\n';
	}
}