#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cassert>


#define x first
#define y second
#define int long long


using namespace std;


#pragma warning(disable:4996)



const int maxn = 3e5 + 10;


vector<pair<int, int>> g[maxn];
vector<pair<int, int>> g2[maxn];
int fup[maxn];
int tin[maxn];
int w[maxn];
int a[maxn];
int b[maxn];
int mn[maxn];
int color[maxn];
int tmm = 1;
set<int> mst;
map<pair<int, int>, int> crat;


void dfs(int v, int p) {
	tin[v] = fup[v] = tmm++;
	for (auto e : g[v]) {
		if (e.x == p)
			continue;
		if (tin[e.x]) {
			fup[v] = min(fup[v], tin[e.x]);
			continue;
		}
		dfs(e.x, v);
		if (fup[e.x] > tin[v] && crat[{e.x, v}] == 1) {
			mst.insert(e.y);
		}
		fup[v] = min(fup[v], fup[e.x]);
	}
}


void dfsc(int v, int c) {
	color[v] = c;
	for (auto e : g[v]) {
		if (mst.find(e.y) != mst.end() || color[e.x])
			continue;
		dfsc(e.x, c);
	}
}


void dfs2(int v, int p) {
	for (auto e : g2[v]) {
		if (e.x == p)
			continue;
		mn[e.x] = min(mn[e.x], e.y);
		mn[e.x] = min(mn[e.x], mn[v]);
		dfs2(e.x, v);
	}
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	assert(freopen("input.txt", "r", stdin));
#endif
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < maxn; i++) {
		mn[i] = 2e9;
	}
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v >> w[i];
		u--;
		v--;
		a[i] = u;
		b[i] = v;
		g[u].push_back({ v, i });
		g[v].push_back({ u, i });
		crat[{u, v}]++;
		crat[{v, u}]++;
	}
	dfs(0, -1);
	int c = 1;
	for (int i = 0; i < n; i++) {
		if (color[i] == 0)
			dfsc(i, c++);
	}
	for (int i = 0; i < m; i++) {
		if (mst.find(i) == mst.end()) {
			mn[color[a[i]]] = min(mn[color[a[i]]], w[i]);
		}
		else {
			g2[color[a[i]]].push_back({ color[b[i]], w[i] });
			g2[color[b[i]]].push_back({ color[a[i]], w[i] });
		}
	}
	dfs2(color[0], -1);
	for (int i = 1; i < n; i++) {
		cout << (int)1e9 + mn[color[i]] << '\n';
	}
}
