#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int inf = 1e9;
const int N = 3e5 + 5;

int n, m;
vector<pii> g[N];
int wei[N], mn[N], mx[N];

void dfs(int v, int p = 0) {
    for (auto &e : g[v]) {
        int u = e.fi, i = e.se;
        if (u == p) continue;
        mn[u] = min(mn[v], wei[i]);
        mx[u] = max(mx[v], wei[i]);
        dfs(u, v);
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        g[v].eb(u, i);
        g[u].eb(v, i);
        wei[i] = w;
    }
    mn[1] = inf;
    mx[1] = -inf;
    dfs(1);
    for (int i = 2; i <= n; ++i) {
        cout << mn[i] + mx[i] << "\n";
    }
    return 0;
}
