#include <bits/stdc++.h>
#define f first
#define s second
#define _ << ' ' <<
#define all(x) x.begin(), x.end()
#define mp make_pair
//define int long long
#define time() clock() / (ld)CLOKS_PER_SEC

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma target (avx)

const int MAXN = 21, INF = 1e9, K = 1000;

struct Edge {
    int to, w;

    Edge (int to = 0, int w = 0): to(to), w(w) {}

    bool friend operator< (Edge e1, Edge e2) {
        return e1.w < e2.w;
    }
};

vector<Edge> g[MAXN];

int used[MAXN][MAXN];

int ans[MAXN];

int cnt = 0;

void dfs(int v, int mn, int mx) {
    cnt++;
    if (cnt % K == 0) {
        if (time() > 2.7) {
            for (int i = 1; i < n; i++) cout << ans[i] << ' ';
            exit(0);
        }
    }
    ans[v] = min(ans[v], mn + mx);
    Edge e;
    int to, w;
    for (auto e : g[v]) {
        to = e.to, w = e.w;
        if (used[v][to]) continue;
        used[v][to] = 1;
        used[to][v] = 1;
        dfs(to, min(mn, w), max(mx, w));
        used[v][to] = 0;
        used[to][v] = 0;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int v, to, w;
    for (int i = 0; i < m; i++) {
        cin >> v >> to >> w;
        v--;
        to--;
        g[v].push_back(Edge(to, w));
        g[to].push_back(Edge(v, w));
    }
    for (int i = 0; i < n; i++) {
        sort(all(g[i]));
    }
    fill(ans, ans + n, INF * 2);
    dfs(0, INF, 0);
    for (int i = 1; i < n; i++) cout << ans[i] << ' ';
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
    }
}
