#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9;

vector<int> ans; //min, max;
vector<bool> used;
void dfs(int v, vector<vector<pair<pair<int, int>, int>>>& matr, int min_now = INF, int max_now = -INF) {
    ans[v] = min(ans[v], max_now + min_now);

    for (auto rebr : matr[v]) {
        if (!used[rebr.second]) {
            used[rebr.second] = true;
            dfs(rebr.first.first, matr, min(min_now, rebr.first.second), max(max_now, rebr.first.second));
            used[rebr.second] = false;
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<pair<pair<int, int>, int>>> matr(n);
    for (int i = 0; i < m; i++) {
        int x, y, t;
        cin >> x >> y >> t;
        x--;
        y--;
        matr[x].push_back({{y, t}, i});
        matr[y].push_back({{x, t}, i});
    }

    ans.resize(n, INF);
    used.resize(m, false);
    dfs(0, matr);
    for (int i = 1; i < n; i++)
        cout << ans[i] << endl;

    return 0;
}
