#include<bits/stdc++.h>

#define ll long long
#define pb push_back

using namespace std;



template<class T>
ostream & operator <<(ostream &in, vector<T> &arr)
{
    for (T &i: arr)
    {
        in << i << " ";
    }
    return in;
}

template<class T>
istream & operator >>(istream &in, vector<T> &arr)
{
    for (T &i: arr)
    {
        in >> i;
    }
    return in;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3


*/

int main()
{
    ll n, q;
    cin >> n >> q;
    vector<vector<ll> > m(n, vector<ll>(2, 0));
    cin >> m;

    vector<vector<ll>> ot(n, vector<ll>(2, -1));
    vector<vector<ll> > gr(n + 1);
    for (int i = 0; i < n; ++i)
    {
        for (int j = i; j >= 0; --j)
        {
            if (m[i][0] - m[j][0] >= m[i][1] )
            {
                ot[i][0] = j + 1;
                break;
            }
        }

        for (int j = i; j < n; ++j)
        {
            if (m[j][0] - m[i][0] >= m[i][1] )
            {
                ot[i][1] = j - 1;
                break;
            }
        }
    }
    vector<ll> free(n, 0);
    for (int i = 0; i < n; ++i)
    {
        if (ot[i][0] == i or ot[i][1] == i)
        {
            free[i] = 1;
        }
        else
        {
            if (ot[i][0] != -1)
            gr[ ot[i][0] ].pb(i);
            if (ot[i][1] != -1)
            gr[ ot[i][1] ].pb(i);
        }
    }

    for (int i = 0; i < q; ++i)
    {
        deque<ll> b;
        ll x, y;
        cin >> x >> y;
        x -= 1;
        y -= 1;
        ll ans = 0;
        vector<ll> used(n + 1, 1);
        for (int j = x; j <= y; ++j)
        {
            used[j] = 0;

            if (free[j])
            {
                used[j] = 1;
                b.pb(j);
            }
        }

        while (b.size() != 0)
        {
            ll v = b[0];
            b.pop_front();
            for (auto u: gr[v])
            {
                if (used[u] == 0)
                {
                    used[u] = 1;
                    b.pb(u);
                }
            }
        }



        for (int j = x; j <= y; ++j)
        {
            ans += used[j];
        }
        cout << ans << endl;
    }

}

