#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;

const ll cst = (ll)3e5 + 50;
const ll inf = (ll)1e18 + 228;

ll cost[26];

void solve() {
	string s;
	cin >> s;
	vector<ll> vc(26, 0);
	vector<ll> vc2(26, 0);
	for (ll i = s.size() - 1; i >= 0; i--) {
		if (s[i] != '?') vc2[s[i] - 'A']++;
	}
	ll answ = 0;
	for (ll i = 0; i < s.size(); i++) {
		if (s[i] != '?') {
			vc[s[i] - 'A']++;
			vc2[s[i] - 'A']--;
			answ += cost[s[i] - 'A'];
			for (ll c = 25; c > s[i] - 'A'; c--) {
				if (vc2[c]) {
					answ -=2 * cost[s[i] - 'A'];
					vc[s[i] - 'A']--;
					break;
				}
			}
		}
		else {
			ll bgst = 0;
			for (ll c = 25; c >= 0; c--) {
				if (vc2[c]) {
					bgst = c;
					break;
				}
			}
			char opt = bgst + 'A';
			ll opts = cost[bgst];
			ll corr = 0;
			for (ll c = bgst + 1; c < 26; c++) {
				corr += vc[c - 1] * cost[c - 1];
				ll cs = cost[c] -2 * corr;
				if (cs >= opts) {
					opts = cs;
					opt = c + 'A';
				}
			}
			s[i] = opt;
			answ += opts;
			for (ll i = 0; i < opt - 'A'; i++) vc[i] = 0;
		}
	}
	cout << answ << endl;
	cout << s;
}

ll n;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cost[0] = 1;
	for (ll i = 1; i < 26; i++) {
		if (i % 2) cost[i] = 5 * cost[i - 1];
		else cost[i] = 2 * cost[i - 1];
	}
	cin >> n;
	while (n--) {
		solve();
		cout << endl;
	}
	return 0;
}