#include <bits/stdc++.h>

using namespace std;

struct edge {
	int to, w, ind;
	edge(){};
	edge(int to, int w, int ind): to(to), w(w), ind(ind) {};
};

vector<vector<edge>> g;
vector<vector<edge>> gcomp;
vector<int> now;
map<int, int> nowind;
vector<int> used;
vector<int> bridges;
map<int, bool> banned;
vector<int> color;
int clr = 0;
vector<int> ansforcomp;

int dfs(int v, int t) {
	if (used[v] == 1) {
		return nowind[v];
	}
	if (used[v] == 2) {
		//cout << "something bugged\n";
		return 1e9;
	}
	used[v] = 1;
	nowind[v] = now.size();
	now.push_back(v);
	int ans = 1e9;
	for (edge x: g[v]) {
		if (x.ind != t) {
			int ansnow = dfs(x.to, x.ind);
			ans = min(ansnow, ans);
		}
	}
	if (ans == nowind[v]) {
		ans = 1e9;
	}
	if (ans == 1e9 && t != -1) {
		bridges.push_back(t);
	}
	used[v] = 2;
	nowind[v] = 1e9;
	now.pop_back();
	return ans;
}

void dfs_comps(int v, int t) {
	color[v] = clr;
	for (edge x: g[v]) {
		if (x.ind != t && color[x.to] == -1 && !banned[x.ind]) {
			dfs_comps(x.to, x.ind);
		}
	}
}

void dfs_comp_ans(int v, int t, int ans) {
	ansforcomp[v] = ans;
	for (edge x: gcomp[v]) {
		if (x.ind != t) {
			dfs_comp_ans(x.to, x.ind, min(ans, min(ansforcomp[x.to], x.w)));
		}
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	g.resize(n);
	used.resize(n);
	color.assign(n, -1);
	vector<vector<int>> reb;
	for (int i = 0; i < m; ++i) {
		int a, b, w;
		cin >> a >> b >> w;
		--a; 
		--b;
		g[a].push_back(edge(b, w, i));
		g[b].push_back(edge(a, w, i));
		reb.push_back({a, b, w});
	}
	dfs(0, -1);
	for (int i = 0; i < bridges.size(); ++i) {
		banned[bridges[i]] = true;
		//cout << bridges[i] << ' ';
	}
	for (int i = 0; i < n; ++i) {
		if (color[i] == -1) {
			dfs_comps(i, -1);
			++clr;
		}
	}
	gcomp.resize(clr);
	ansforcomp.resize(clr, 1e9);
	for (int i = 0; i < m; ++i) {
		vector<int> now = reb[i];
		if (color[now[0]] == color[now[1]]) {
			ansforcomp[color[now[0]]] = min(ansforcomp[color[now[0]]], now[2]);
		}
		else {
			gcomp[color[now[0]]].push_back(edge(color[now[1]], now[2], i));
			gcomp[color[now[1]]].push_back(edge(color[now[0]], now[2], i));
		}
	}
	dfs_comp_ans(0, -1, ansforcomp[0]);
	for (int i = 1; i < n; ++i) {
		cout << ansforcomp[color[i]] + (int)(1e9) << '\n';
	}
}