#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <map>
#include <numeric>
#include <queue>

using namespace std;

using ll = long long;
template <typename T>
using v = vector<T>;
template <typename A, typename B>
using pa = pair<A, B>;

v<v<pa<ll, ll>>> graph;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ll n, m;
	cin >> n >> m;
	graph = v<v<pa<ll, ll>>>(n);
	for (ll i = 0; i < m; ++i) {
		ll ui, vi, ti;
		cin >> ui >> vi >> ti;
		--ui;
		--vi;
		graph[ui].push_back({ vi, ti });
		graph[vi].push_back({ ui, ti });
	}
	ll cma = -1;
	ll cmi = -1;
	v<ll> res(n);
	for (ll i = 0; i < n; ++i) {
		res[i] = cma + cmi;
		ll edg = 1e18;
		for (auto [overt, t] : graph[i]) {
			if (overt == i + 1) {
				edg = min(edg, t);
			}
		}
		if (cma == -1) {
			cma = cmi = edg;
		}
		else {
			cma = max(cma, edg);
			cmi = min(cmi, edg);
		}
	}
	for (ll i = 1; i < n; ++i) {
		cout << res[i] << '\n';
	}
}