#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
using namespace std;

int main()
{
	int ttt; cin >> ttt;

	int m = 'Z' - 'A' + 1;
	vector<long long> val(m); val[0] = 1; val[1] = 5;
	for (int i = 2; i < m; ++i)
		val[i] = val[i - 2] * 10;

	while (ttt--)
	{
		string s; cin >> s;
		int n = s.size();
		vector<vector<long long>> dp(n + 1, vector<long long>(m, -(long long)(1e18) * 2));
		vector<vector<int>> p(n + 1, vector<int>(m));

		dp[0] = vector<long long>(m, 0);

		for (int i = 1; i <= n; ++i)
			for (int j = 0; j < m; ++j)
			{
				auto add = [&](int c)
				{
					if (c >= j)
					{
						if (dp[i][j] < dp[i - 1][c] + val[c])
						{
							dp[i][j] = dp[i - 1][c] + val[c];
							p[i][j] = c;
						}
					}
					else
					{
						if (dp[i][j] < dp[i - 1][j] - val[c])
						{
							dp[i][j] = dp[i - 1][j] - val[c];
							p[i][j] = c;
						}
					}
				};

				if (s[i - 1] != '?')
				{
					add(s[i - 1] - 'A');
					continue;
				}

				for (int c = j; c < m; ++c)
					add(c);
			}

		for (int i = n, j = 0; i > 0; --i)
		{
			s[i - 1] = p[i][j] + 'A';
			j = max(j, p[i][j]);
		}
		cout << dp[n][0] << '\n' << s << '\n';
	}

	return 0;
}
