#include <iostream>
#include <vector>
#include <map>
#include <set>

//#define int long long

using namespace std;

signed main(){
    int n, q;
    cin >> n >> q;
    vector<int> x(n + 1);
    vector<int> h(n + 1);
    for (int i = 0; i < n; ++i){
        cin >> x[i] >> h[i];
    }
    h[n] = 1e9;
    x[n] = x[n - 1];
    vector<int> can_r(n, -1);
    vector<int> can_l(n, -1);
    vector<int> cut(n);
    for (int i = 1; i < n - 1; ++i){
        int left = x[i] - h[i];
        int right = x[i];
        int j = i - 1;
        while (j > 0 && left < x[j]){
            if (x[j] + h[j] > right){
                left = min(left, x[j] - h[j]);
            }
            j--;
        }
        if (j > 0){
            can_l[i] = i - j;
        }
    }
    for (int i = n - 1; i > 0; --i){
        int right= x[i] + h[i];
        int left = x[i];
        int j = i + 1;
        while (j < n && right > x[j]){
            if (x[j] - h[j] < left){
                right = max(right, x[j] + h[j]);
            }
            j++;
        }
        if (j < n){
            can_r[i] = j - i;
        }
    }
    /*for (int i = 0; i < n; ++i){
        cout << can_l[i] << "  " << can_r[i] << endl;
    }*/
    while (q--){
        int left, right;
        cin >> left >> right;
        left--;
        vector<int> left_x;
        vector<int> right_x;
        if (left != 0){
            left_x.push_back(x[left - 1]);
            right_x.push_back(1e9);
        }
        int ans = 0;
        for (int i = left; i <= right; ++i){
            cout << i << " " << x[i] << " " << h[i] << endl;
            while (left_x.size() > 0 && x[i] >= right_x.back()){
                left_x.pop_back();
                right_x.pop_back();
                ans++;
            }
            if (left != 0 && x[i] - h[i] >= left_x.back()){
                ans++;
            } else if (i < right && x[i] + h[i] <= x[i + 1]){
                ans++;
            } else {
                left_x.push_back(x[i]);
                right_x.push_back(x[i] + h[i]);
            }
        }
        cout << ans << endl;
    }
    return 0;
}
/*
7 100
1 1
2 1
3 2
4 4
5 2
6 1
8 1


8 100
1 8
2 1
3 2
4 4
5 2
7 1
8 2
9 1

*/
