#include <iostream>
#include <string>
#include <map>
#include <vector>
#include <algorithm>

using namespace std;

map < char, long long > kek;

const long long inf = 1e18;

long long calc(string& s) {
	int n = s.size();
	char c = 'A';
	long long res = 0;
	for (int i = n - 1; i >= 0; i--) {
		if (s[i] >= c) res += kek[s[i]];
		else res -= kek[s[i]];
		c = max(c, s[i]);
	}
	return res;
}

void uwu(string &s) {
	int n = s.size();
	long long ans = -inf;
	string res;
	for (char t1 = 'A'; t1 <= 'Z'; t1++) {
		for (char t2 = 'A'; t2 <= 'Z'; t2++) {
			for (char t3 = 'A'; t3 <= 'Z'; t3++) {
				string news = s;
				int cnt = 0;
				for (int i = 0; i < n; i++) {
					if (s[i] != '?') continue;
					if (cnt == 0) news[i] = t1;
					else if (cnt == 1) news[i] = t2;
					else news[i] = t3;
					cnt++;
				}

				long long t = calc(news);
				if (t > ans) {
					ans = t;
					res = news;
				}
			}
		}
	}
	cout << ans << "\n" << res << "\n";
}

void solve(string &s) {
	int n = s.size();
	vector < vector < long long > > dp(n, vector < long long >(26, -inf));
	vector < vector < char > > par(n, vector < char >(26, '#'));
	vector < vector < int > > pa(n, vector < int >(26, -1));
	if (s.back() == '?')
		for (int i = 0; i < 26; i++) {
			dp[n - 1][i] = kek['A' + i];
			par[n - 1][i] = 'A' + i;
		}
	else
		for(int i = s[n - 1] - 'A'; i < 26; i++)
			dp[n - 1][i] = kek[s[n - 1]];
	for (int i = n - 2; i >= 0; i--) {
		if (s[i] == '?') {
			for (int j = 0; j < 26; j++) {
				if (dp[i + 1][j] != -inf) {
					dp[i][j] = kek['A' + j] + dp[i + 1][j];
					par[i][j] = 'A' + j;
					pa[i][j] = j;
				}
			}
		}
		else {
			for (int j = 0; j <= s[i] - 'A'; j++) {
				if (dp[i + 1][j] != -inf) {
				//	dp[i][s[i] - 'A'] = max(dp[i][s[i] - 'A'], kek[s[i]] + dp[i + 1][j]);
					if (kek[s[i]] + dp[i + 1][j] > dp[i][s[i] - 'A']) {
						dp[i][s[i] - 'A'] = kek[s[i]] + dp[i + 1][j];
						pa[i][s[i] - 'A'] = j;
					}
				}
			}
			for (int j = s[i] - 'A' + 1; j < 26; j++) {
				if (dp[i + 1][j] != -inf) {
				//	dp[i][j] = max(dp[i][j], dp[i + 1][j] - kek[s[i]]);
					if (dp[i + 1][j] - kek[s[i]] > dp[i][j]) {
						dp[i][j] = dp[i + 1][j] - kek[s[i]];
						pa[i][j] = j;
					}
				}
			}
		}
	}

	long long ans = 0;
	for (int i = 0; i < 26; i++) {
		if (dp[0][i] > dp[0][ans]) ans = i;
	}
	string res = "";
	pair < int, int > w = { 0, ans };
	while (w.second != -1) {
		if (s[w.first] == '?')
			res += par[w.first][w.second];
		else
			res += s[w.first];
		w.second = pa[w.first][w.second];
		w.first++;
	}

	cout << dp[0][ans] << "\n" << res << "\n";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	kek['A'] = 1;
	for (int i = 1; i < 26; i++) {
		kek['A' + i] = kek['A' + i - 1];
		if (i % 2 == 1) kek['A' + i] *= 5;
		else kek['A' + i] *= 2;
	}

	int q;
	cin >> q;

	string h;
	for (int i = 0; i < q; i++) {
		cin >> h;
		uwu(h);
	}
}