#include <iostream>
#include <algorithm>
#include <vector>

#define all(x) (x).begin(), (x).end()
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second

using namespace std;

typedef long long ll;
typedef vector <int> vi;
typedef pair <int, int> pii;
typedef vector <pii> vii;
typedef vector <long long> vll;

const long long INFll = 2e18;
const int N = 6e5;

void solve() {
    int n, q; cin >> n >> q;
    vi x(n), h(n);
    for (int i = 0; i < n; i++)
        cin >> x[i] >> h[i];

    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r; l--;

        vi del(n, 0);
        int ans = 0;
        while (true) {
            bool done = false;
            for (int j = l; j < r; j++) {
                if (del[j]) continue;
                if (x[j] - h[j] >= x[0]) {
                    bool found = false;
                    for (int k = j - 1; k >= l - 1 && k > -1; k--) {
                        if (!del[k]) {
                            found = true;
                            if (x[k] <= x[j] - h[j]) {
                                ans++;
                                del[j] = 1;
                                done = true;
                            }
                            break;
                        }
                    }
                    if (!found) {
                        ans++;
                        del[j] = 1;
                        done = true;
                    }
                    if (done) break;
                }
                if (x[j] + h[j] <= x[n - 1]) {
                    bool found = false;
                    for (int k = j + 1; k <= r && k < n; k++) {
                        if (!del[k]) {
                            found = true;
                            if (x[k] >= x[j] + h[j]) {
                                ans++;
                                del[j] = 1;
                                done = true;
                            }
                            break;
                        }
                    }
                    if (!found) {
                        ans++;
                        del[j] = 1;
                        done = true;
                    }
                    if (done) break;
                }
            }
            if (!done) break;
        }

        cout << ans << "\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}
