#pragma comment(linker, "/STACK:10000000000")
#pragma GCC optimize("03")
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAX_MEM = 8e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new (size_t n) {
    assert((mpos += n) <= MAX_MEM);
    return (void *) (mem + mpos - n);
}
inline void operator delete (void *) noexcept {}

//#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << "\n";
#define sqr(x) (x) * (x)

template<class t, class u> bool amax(t &a, u b) {if (a < b) {a = b; return true;} return false;}
template<class t, class u> bool amin(t &a, u b) {if (a > b) {a = b; return true;} return false;}
template<class t> using vc = vector<t>;
template<class t> using vvc = vector<vector<t>>;

using pi = pair<int, int>;
using vi = vc<int>;
using vpi = vc<pi>;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(386493230);

const int maxn = 5e5 + 10;

int x[maxn];
int h[maxn];
int used[maxn];
int lt[maxn], rt[maxn];
int n, q;

int solve(int l, int r) {
    queue<int> dq;
    used[l - 1] = 1;
    used[r + 1] = 1;
    for (int i = l; i <= r; i++) {
        used[i] = 0;
        lt[i] = i - 1;
        rt[i] = i + 1;
        if (x[i] - h[i] > x[i - 1]) {
            used[i] = 1;
            dq.push(i);
        } else if (x[i] + h[i] < x[i + 1]) {
            used[i] = 1;
            dq.push(i);
        }
    }
    int ans = 0;
    while (!dq.empty()) {
        auto v = dq.front();
        dq.pop();
        int id_left = lt[v], id_right = rt[v];
        int left = x[id_left], right = x[id_right];
        lt[id_right] = id_left;
        rt[id_left] = id_right;
        if (!used[id_left]) {
            if (left + h[id_left] < right) {
                dq.push(id_left);
                used[id_left] = 1;
            }
        }
        if (!used[id_right]) {
            if (right - h[id_right] > left) {
                dq.push(id_right);
                used[id_right] = 1;
            }
        }
        ans++;
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
        h[i]--;
    }
    x[0] = x[1];
    x[n + 1] = x[n];
    for (int i = 0; i < q; i++) {
        int l, r;
        cin >> l >> r;
        cout << solve(l, r) << '\n';
    }

    return 0;
}