#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<map>
using namespace std;

const long long INF = 4e18;

int main() {
	int t;
	cin >> t;
	map<char, long long> cost;
	long long cur = 1;
	for (int i = 0; i < 26; ++i) {
		cost[i + 'A'] = cur;
		if (i % 2 == 0)
			cur *= 5;
		else
			cur *= 2;
	}
	while (t--) {
		string s;
		cin >> s;
		long long sum = 0;
		map<char, long long> vis_sym;
		int last = 0;
		for (char cur_sym = 'Z'; cur_sym >= 'A'; --cur_sym) {
			vis_sym.clear();
			long long cur_max = -INF;
			long long cur_sum = 0;
			int next_pos = 0;
			for (int pos = 0; pos < s.size(); ++pos) {
				if (s[pos] == '?') {
					for (int less_sym = 'A'; less_sym < cur_sym; ++less_sym) {
						cur_sum -= 2 * vis_sym[less_sym] * cost[less_sym];
						vis_sym[less_sym] = 0;
					}
					vis_sym[cur_sym] += 1;
					cur_sum += cost[cur_sym];
				}
				else {
					for (int less_sym = 'A'; less_sym < s[pos]; ++less_sym) {
						cur_sum -= 2 * vis_sym[less_sym] * cost[less_sym];
						vis_sym[less_sym] = 0;
					}
					vis_sym[s[pos]] += 1;
					cur_sum += cost[s[pos]];
				}
				if (cur_max < cur_sum) {
					cur_max = cur_sum;
					next_pos = pos;
				}
			}
			for (int pos = last; pos <= next_pos; ++pos) {
				if (s[pos] == '?') {
					s[pos] = cur_sym;
				}
			}
			last = next_pos;
		}
		vis_sym.clear();
		long long cur_sum = 0;
		for (int pos = 0; pos < s.size(); ++pos) {
			for (int less_sym = 'A'; less_sym < s[pos]; ++less_sym) {
				cur_sum -= 2 * vis_sym[less_sym] * cost[less_sym];
				vis_sym[less_sym] = 0;
			}
			vis_sym[s[pos]] += 1;
			cur_sum += cost[s[pos]];
		}
		cout << cur_sum << '\n';
		cout << s << '\n';
	}
}

