#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename...B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif



int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int t, n;
	cin >> t >> n;
	if (t == 1) {
		int l = 1, r = n;
		while (true) {
			int mid = (l + r) / 2;
			cout << mid << endl;
			int res;
			cin >> res;
			if (!res) {
				exit(0);
			}
			if (res == 1) {
				l = mid;
			} else {
				r = mid;
			}
		}
	} else {
		int k;
		cin >> k;
		vec<int> anss(k);
		for (auto &x : anss) {
			cin >> x;
		}
		reverse(all(anss));
		int l = 1, r = n;
		while (true) {
			int mid = (l + r) / 2;
			int res = anss.back();
			anss.pop_back();
			if (!res) {
				cout << mid << endl;
				exit(0);
			}
			if (res == 1) {
				l = mid;
			} else {
				r = mid;
			}
		}
	}
}
