#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <array>
#include <set>
#include <map>
int main(int argc, char*argv[])
{
	int t, n; scanf("%d%d", &t, &n);
	std::string s; std::cin >> s;
	int m = n;
	if(t == 1) m = (n == 10 ? 30 : n + 17);
	if(t == 2) n = (m == 30 ? 10 : m - 17);
	std::vector<int> val(m);
	for(int i = 0; i < n; i++)
	{
		int cval = -1;
		if(i == 0) cval = n;
		else if(__builtin_popcount(i) == 1) cval = n + __builtin_ctz(i) + 1;
		else cval = i;
		val[i] = cval;
	}
	for(int i = n; i < m; i++)
		val[i] = 1 << (i - n);
	if(t == 1)
	{
		int x = 0;
		for(int i = 0; i < n; i++)
		{
			if(s[i] == '1') x ^= val[i];
		}
		//flipping any bit in s now changes at least 2 bits in the output
		//printf("x=%d\n", x);
		for(int i = 0; i < m - n; i++)
		{
			if(x >> i & 1) s += '1';
			else s += '0';
		}
		printf("%s\n", s.data());
	}
	if(t == 2)
	{
		//if the xor is valid, return s
		//if a single bit is wrong, return the first n characters
		//otherwise find the index with value equal to xor
		int x = 0;
		for(int i = 0; i < m; i++)
		{
			if(s[i] == '1') x ^= val[i];
		}
		//printf("x=%d\n", x);
		if(x == 0 || __builtin_popcount(x) == 1)
		{
			s = s.substr(0, n);
			printf("%s\n", s.data());
			return 0;
		}
		for(int i = 0; i < m; i++)
		{
			if(val[i] == x)
			{
				s[i] ^= 1;
				break;
			}
		}
		s = s.substr(0, n);
		printf("%s\n", s.data());
	}
}
