// ConsoleApplication1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n = 500;
	vector<vector<int>> graph(n, vector<int>(n, 1e9));
	for (int i = 0; i < n; i++) {
		graph[i][i] = 0;
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			int k = rand();
			graph[i][j] = graph[j][i] = k;
		}
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				graph[i][j] = min(graph[i][k], graph[k][j]);
			}
		}
	}
}