#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

vector<vector<bool>>cr;
int k, n;

string correct(string s) {
	int i = s.size() - 1;
	while (i >= 0 && s[i] == s.back())
		i--;
	if (i >= 0) {
		if (cr[s[i] - 'a'][s.back() - 'a']) {
			while (s.back() != s[i])
				s.pop_back();
			return s;
		}
	}
	if (cr[s.back() - 'a'][s.back() - 'a']) {
		string ans = "";
		for (int j = 0; j <= i + 1; j++)
			ans.push_back(s[j]);
		return ans;
	}
	return s;
}

int main() {
	cin >> k >> n;
	cr.resize(k, vector<bool>(k));
	for (int i = 0; i < k; i++)
		for (int j = 0; j < k; j++) {
			char x; cin >> x;
			cr[i][j] = (x == '1');
		}
	string s, t;
	t.push_back('z' + 1);
	cin >> s;
	vector<vector<string>>l1(n), l2(n);
	string start;
	start.push_back(s[0]);
	l1[0].push_back(start);
	for (int i = 1; i < n; i++) {
		for (int j = 0; j <= i; j++) {
			for (auto e : l1[j]) {
				l2[j + 1].push_back(e + s[i]);
				if (cr[e.back() - 'a'][s[i] - 'a'])
					l2[j].push_back(e);
			}
		}
		l1 = l2;
		l2.assign(n, vector<string>(0));
	}
	for (int i = 0; i < n; i++)
		for (auto& el : l1[i])
			t = min(t, el);
	cout << correct(t);
	return 0;
}