#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ld long double

int n;
vector<vector<int>> g;
vector<int> change;
vector<vector<int>> pos_change;
vector<vector<int>> cert;

pair<int, int> dfs(int v) {
    if (g[v].empty()) {
        cert[v].push_back(change[v]);
        return {change[v], change[v]};
    }
    vector<pair<pair<int, int>, int>> vi;
    for (int u : g[v]) {
        auto z = dfs(u);
        vi.emplace_back(z, u);
    }
    sort(all(vi));
    for (int i = 1; i < (int) vi.size(); ++i) {
        if (vi[i].first.first <= vi[i - 1].first.second)return {-1, -1};
    }
    int mn = 1e9;
    int mx = -1e9;
    for (auto z : vi) {
        cert[v].push_back(z.second);
        mn = min(mn, z.first.first);
        mx = max(mx, z.first.second);
    }
    return {mn, mx};
}

void rec(int id) {
    if (id == n) {
        cert.clear();
        cert.resize(n);
        auto z = dfs(0);
        if (z.first != -1) {
            cout << "Yes\n";
            for (int i = 0; i < n; ++i) {
                for (int x : cert[i])cout << x + 1 << " ";
                cout << '\n';
            }
            exit(0);
        }
    } else {
        //MAYBE CONSULT 0 CHANGES
        if (!g[id].empty())rec(id + 1);
        for (int j = 0; j < pos_change[id].size(); ++j) {
            change[id] = pos_change[id][j];
            rec(id + 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    g.resize(n);
    change.resize(n, -1);
    pos_change.resize(n);

    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int pod;
                cin >> pod;
                --pod;
                g[i].push_back(pod);
            }
        } else {
            int m;
            cin >> m;
            for (int j = 0; j < m; ++j) {
                int cj;
                cin >> cj;
                pos_change[i].push_back(cj - 1);
            }
        }
    }
    rec(0);
    cout << "No";
}
