#include <bits/stdc++.h>

using namespace std;

bool arr[26][26];
string str;

bool a(int l, int r) {
    stack<char> st;
    for (int i = r - 1; i >= l; --i) {
        while (st.size() > 0 && arr[str[i] - 'a'][st.top() - 'a']) {
            st.pop();
        }
        st.push(str[i]);
    }
    return st.size() == 1;
}

string b(int l, int r) {
    stack<char> st;
    for (int i = r - 1; i >= l; --i) {
        while (st.size() > 0 && arr[str[i] - 'a'][st.top() - 'a']) {
            st.pop();
        }
        st.push(str[i]);
    }
    string res = "";
    while (st.size() > 0) {
        res += st.top();
        st.pop();
    }
    return res;
}

int n, k;

void solve_stupid() {
    if (k == 1) {
        if (arr[0][0]) {
            cout << "a";
        } else {
            cout << str;
        }
    } else {
        if (arr[1][1]) {
            string t = "";
            for (auto x:str) {
                if (t.size() == 0 || !(t.back() == 'b' && x == 'b')) {
                    t += x;
                }
            }
            str = t;
        }
        if (arr[1][0]&&arr[1][1]) {
            string t = "";
            for (auto x:str) {
                if (t.size() == 0 || !(t.back() == 'b' && x == 'a')) {
                    t += x;
                }
            }
            str = t;
        }
        if(arr[1][0]){
            int l_b = str.size();
            for (int i = 0; i < str.size(); ++i) {
                if(str[i]=='b'){
                    l_b = i+1;
                }
            }
            str = str.substr(0,l_b);
        }
        if (arr[0][1]) {
            string t = "";
            for (auto x:str) {
                if (t.size() == 0 || !(t.back() == 'b' && x == 'a')) {
                    t += x;
                }
            }
            str = t;
        }
        bool f = false;
        for (int i = 0; i < str.size(); ++i) {
            if (str[i] == 'b') {
                f = 1;
                break;
            }
        }
        if (!f && arr[0][0]) {
            str = "a";
        }
        cout << str;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            arr[i][j] = s[j] == '1';
        }
    }
    cin >> str;
    if (k <= 2) {
        solve_stupid();
        return 0;
    }
    string dp[n];
    for (int i = n - 1; i >= 0; --i) {
        int to = i + 1;
        int l = i + 1;
        int r = n + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (a(i, mid)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        to = l;
        if (to == n) {
            dp[i] = str[i];
        } else {
            dp[i] = "#";
            for (int j = i + 1; j <= to; ++j) {
                if (dp[i] == "#" || str[i] + dp[j] < dp[i]) {
                    dp[i] = str[i] + dp[j];
                }
            }
        }
        //cout << to << " " << dp[i] << "\n";
    }
    cout << dp[0];
    return 0;
};