#include <bits/stdc++.h>
using namespace std;

#define size(a) (int)(a.size())
const int max_n = 2e5 + 3;

int n, m;

int bad_cnt[max_n];
vector<int> all[max_n];
vector<int> id_bad[max_n];
bool used[max_n];

bool solve() {
	string s;
	cin >> n >> m >> s;
	for(int i = 0;i < n;i++) {
		int k;
		cin >> k;
		for(int j = 0;j < k;j++) {
			int id;
			char c;
			cin >> id >> c;
			--id;
			if (c != s[id]) {
				bad_cnt[i]++;
				id_bad[id].emplace_back(i);
			}
			all[i].emplace_back(id);
		}
	}

	auto comp = [](int v1, int v2) {
		return make_pair(bad_cnt[v1], v1) < make_pair(bad_cnt[v2], v2);
	};	
	set<int, decltype(comp)> a(comp);
	for(int i = 0;i < n;i++)
		a.emplace(i);

	vector<int> res;
	while(size(a)) {
		int v = *a.begin();
		res.emplace_back(v);
		a.erase(a.begin());
		if (bad_cnt[v] != 0) return false;
		for(int id : all[v]) {
			if (used[id]) continue;
			used[id] = true;
			for(int i : id_bad[id]) {
				a.erase(i);
				--bad_cnt[i];
				a.emplace(i);
			}
		}
	}
	for(int i = 0;i < m;i++)
		if (!used[i]) return false;
	for(int i : res)
		cout << i + 1 << " ";
	return true;
}

signed main() {
	cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
	#ifdef local
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif

	if (!solve()) cout << -1 << endl;
}