#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "map"

using namespace std;
#define all(x) (x).begin(), (x).end()
vector<vector<int>> a;
int popsegfunk(char c, string s) {
    string ms = {c};
    int num = 0;
    for (auto i : s) {
        while (!ms.empty() and !a[ms.back()-'a'][i-'a'])
            ms.pop_back();
        if (ms.empty())
            return num;
        ms.push_back(i);
        num++;
    }
    return num;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int k, n;
    cin >> k >> n;
    a.assign(k, vector<int>(k));
    for (auto &i : a)
        for (auto &j : i) {
            char c;
            cin >> c;
            j = c == '1';
        }
    string s;
    cin >> s;
    vector<vector<int>> popseg(n, vector<int>(n, 0));
    for (int i = 1; i < n; ++i) {
        string s2 = s.substr(i);
        //cerr << s2 << endl;
        int ind = popsegfunk(s[i-1], s2);
        for (int j = i; j < i + ind; ++j) {
            popseg[i][j] = 1;
        }
    }
    vector<string> suffans(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        suffans[i] = s[i] + suffans[i + 1];
        for (int j = i; j < n; ++j) {
            if (popseg[i][j]) {
                suffans[i] = min(suffans[i], suffans[j + 1]);
                suffans[i] = min(suffans[i], s[i] + suffans[j + 1]);
            }
        }
    }
    cout << suffans[0];
}
