#include <iostream>
#include "vector"
#include "algorithm"
#include "numeric"
#include "climits"
#include "map"

using namespace std;
#define all(x) (x).begin(), (x).end()
vector<vector<int>> g;
struct seg {
    int l, r;
};
vector<vector<seg>> elemrab;
bool cmp(seg a, seg b) {
    return make_pair(a.l, a.r) < make_pair(b.l, b.r);
}
vector<seg> obed(vector<vector<seg>> elems) {
    int n = elems.size();
    vector<int> perm(n);
    for (int i = 0; i < n; ++i) {
        perm[i] = i;
    }
    vector<seg> segg;
    int cnt = 0;
    do {
        vector<int> ind(n, 0);
        for (int ind000 = 0; ind000 < elems[perm[0]].size(); ++ind000) {
            ind[0] = ind000;
            bool ok = true;
            for (int i = 0; i < n - 1; ++i) {
                while (ind[i + 1] != elems[perm[i + 1]].size() and
                       elems[perm[i]][ind[i]].r > elems[perm[i + 1]][ind[i + 1]].l) {
                    ind[i + 1]++;
                }
                if (ind[i + 1] == elems[perm[i + 1]].size()){
                    ok = false;
                    break;
                }
            }
            if (!ok)
                break;
            segg.push_back({elems[perm[0]][ind[0]].l, elems[perm.back()][ind.back()].r});
        }
        cnt++;
    } while (next_permutation(all(perm)));
    //cout << cnt;
    sort(all(segg), cmp);
    if (segg.empty())
        return segg;
    vector<seg> segg2 = {segg[0]};
    for (int i = 0; i + 1 < segg.size(); ++i) {
        while (!segg2.empty() and segg2.back().r >= segg[i].r) {
            segg2.pop_back();
        }
        segg2.push_back(segg[i]);
    }
    return segg2;
}
vector<seg> dfs(int v, int p) {
    if (g[v].size() == 1 and p != -1) {
        return elemrab[v];
    }
    vector<vector<seg>> vvs(g[v].size() - (p != -1));
    int ind = 0;
    for (auto u : g[v]) {
        if (u == p)
            continue;
        vvs[ind] = dfs(u, v);
        ind++;
    }
    return elemrab[v] = obed(vvs);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    elemrab.assign(n, {});
    g.assign(n, {});
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int q;
                cin >> q;
                q--;
                g[q].push_back(i);
                g[i].push_back(q);
            }
        } else {
            int q;
            cin >> q;
            while (q--) {
                int v;
                cin >> v;
                elemrab[i].push_back({v, v});
            }
        }
    }
    if (!dfs(0, -1).empty()) {
        cout << "Yes\n";
    } else {
        cout << "No\n";
    }
     //for (int i = 0; i < n; ++i) {
     //    cout << i << ": ";
     //    for (auto lr : elemrab[i])
     //       cout << lr.l << ' ' << lr.r << ". ";
     //   cout << '\n';
     //}
}
