#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <list>
#include <stack>
#include <cassert>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)

#define all(a) a.begin(), a.end()

typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

void solve();
int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
    return 0;
}

const int MAXN = 5e5 + 10;


bool tb[27][27];
int sto[MAXN];
int canto[MAXN];
string s;
int y[MAXN];
vector<int> wh[27];


void solve() {
    int k, n; cin >> k >> n;
    range(i, k) {
        range(j, k) {
            char c; cin >> c;
            tb[i][j] = (c == '1');
        }
    }
    cin >> s;
    range(i, n) {
        y[i] = s[i] - 'a';
    }

    rrange(i, n) {
        auto &ct = canto[i];
        ct = i + 1;
        while (ct < n && tb[y[i]][y[ct]]) {
            ct = canto[ct];
        }
    }
    range(i, n) {
        wh[y[i]].pb(i);
    }
    vector<int> ans;
    int now = 0;
    while (now != n) {
        ans.push_back(now);
        if (canto[now] == n) {
            now = n;
            break;
        }
        int best = now + 1;
        for (auto i = now + 1; i <= canto[now]; ++i) {
            if (y[i] < y[best] || (y[i] == y[best] && canto[i] > canto[best])) {
                best = i;
            }
        }
        now = best;
//        for (int c = 0; c <= y[now + 1]; ++c) {
//            auto it = upper_bound(all(wh[c]), canto[now]);
//            if (it == wh[c].begin()) continue;
//            --it;
//            int pos = *it;
//            if (pos > now){
//                now = pos;
//                break;
//            }
//        }
    }
    for (auto i : ans) {
        cout << s[i];
    }
    cout << endl;
}
