#include <bits/stdc++.h>
using namespace std;

bool can[256][256];

#define size(x) (int)x.size()
#define all(x) (x).begin(), (x).end()

bool cmp(string a, string b) {
    for(int i = 0; i < min(size(a), size(b)); i++) {
        if (a[i] < b[i]) return 1;
        if (a[i] > b[i]) return 0;
    }
    return size(a) < size(b);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int k, n;
    cin >> k >> n;

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;
            can[i][j] = (c == '1');
        }
    }
    string INF;
    INF += char(240);
    string s;
    cin >> s;
    for (char &c : s) c -= 'a';
    string res;
    for(int j = size(s) - 1; j >= 0; j--) {
        char c = s[j];
        if (res.empty()) {
            res += c;
        } else {
            string cu = res;
            for(int i = size(res) - 1; i >= 0; i--) {
                if (!can[c][res[i]]) {
                    break;
                }
                string suf;
                for(int v = 0; v < i; v++) {
                    suf += res[v];
                }
                if (cmp(suf, cu)) {
                    cu = suf;
                }
            }
            res = cu + c;
        }
    }
    reverse(all(res));
    for(char c : res) {
        cout << char(c + 'a');
    }
}

