#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;

//#define int ll
//#define map gp_hash_table
#define loop(i, n) for (int i = 0; i < n; ++i)
#define loop1(i, n) for (int i = 1; i <= n; ++i)
#define all(x) begin(x), end(x)
#define pi pair <int, int> 
#define ti tuple <int, int, int>
#define mkp make_pair
#define mkt make_tuple
#define F first
#define S second

const int N = 507;

vector <int> g[N];
vector <pi> srt[N];
bool is_cons[N];
vector <int> cons;
int mx[N], mn[N];

bool check(int v) {
	if (is_cons[v])
		return true;
	loop(i, g[v].size()) {
		int u = g[v][i];
		if (!check(g[v][i]))
			return false;
		srt[v][i] = { mn[u], u } ;
	}
	sort(all(srt[v]));
	for (int i = 1; i < srt[v].size(); ++i)
		if (mn[srt[v][i].S] < mx[srt[v][i - 1].S])
			return false;
	mn[v] = srt[v][0].F;
	mx[v] = mx[srt[v].back().S];
	return true;
}

bool recurs(int v) {
	if (v == cons.size())
		return check(1);
	for (int x : cons) {
		mn[cons[v]] = mx[cons[v]] = x;
		if (recurs(v + 1))
			return true;
	}
	return false;
}

void solve() {
	int n; cin >> n;
	loop1(i, n) {
		int type; cin >> type;
		int k; cin >> k;
		g[i].resize(k);

		loop(j, k)
			cin >> g[i][j];
		if (type == 2) {
			is_cons[i] = 1;
			cons.push_back(i);
		}
	}
	if (!recurs(0)) {
		cout << "No"; return;
	}
	cout << "Yes\n";
	loop1(i, n) {
		if (is_cons[i])
			cout << mn[i];
		else
			for (pi p : srt[i])
				cout << p.S << " ";
		cout << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

