#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string> 
#include <cassert>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, Left, Right) for (int i = (Left); i <= Right; ++i)
#define FOR_DOWN(i, Right, Left) for(int i = (Right); i >= (Left); --i)
#define pii pair <int, int>


int typ, n, m, k;


bool lock[40][40];

int count_lock(int x, int y)
{
	int x1, y1;
	FOR(i, x, n + 1)
		if (lock[i][y])
		{
			x1 = i;
			break;
		}
	FOR(i, y, n + 1)
		if (lock[x][i])
		{
			y1 = i;
			break;
		}
	int count = 0;
	FOR(i, x, x1 - 1)
		FOR(j, y, y1 - 1)
			count += lock[i][j];
	count = (x1 - x) * (y1 - y) - count;
	return count;
}

void locking(int x, int y)
{
	FOR(i, x, n)
		FOR(j, y, n)
			lock[i][j] = 1;
	return;
}

string s;

int cnt_lock = 0;

int main()
{
#ifdef _DEBUG
	//freopen("Text.txt", "r", stdin);
#endif // _DEBUG

	cin >> typ;
	cin >> n >> k >> m;

	FOR(i, 1, n)
	{
		lock[i][n + 1] = 1;
		lock[n + 1][i] = 1;
	}

	int h = 0;
	if (typ == 1) {
		cin >> s;
		while (cnt_lock + 8 < n * n) {
			bool tr = 0;
			FOR_DOWN(i, n, 1)
			{
				FOR_DOWN(j, n, 1)
				{
					if (count_lock(i, j) % 2 == s[h] % 2)
					{
						cout << i << " " << j << endl;
						locking(i, j);
						i = n + 1;
						j = n + 1;
						h++;
						tr = 1;
						break;
					}
				}
				if (tr)
					break;
			}
			
			int x, y;
			cin >> x >> y;
			locking(x, y);
			if (h == s.size())
			{
				if (cnt_lock != m * m)
					cout << "1 1" << endl;
				cout << 0 << endl;
				return 0;
			}
		}
		cout << 1 << " " << 1 << endl;
	}
	else
	{
		int h;
		s = "";
		cin >> h;
		int x = 0, y = 0;
		int num = 0, val;
		FOR(hh, 1, h)
		{
			while (x * y != 1)
			{
				num++;
				cin >> x >> y;
				if (num % 2 == 1)
				{
					if (x * y == 1)
						break;
					val = count_lock(x, y) % 2;
					s += char(val + '0');
				}
			}
			FOR(i, 1, n)
				FOR(j, 1, n)
					lock[i][j] = 0;
		}
		cout << s << endl;
	}
	

}