#include <iostream>
#include <unordered_set>
#include <vector>
using namespace std;
vector<int> d;
vector<int> vals;
void build(int v, int l, int r) {
	if (l == r) {
		d[v] = l;
		return;
	}
	build(2 * v + 1, l, (l + r) / 2);
	build(2 * v + 2, (l + r) / 2 + 1, r);
	d[v] = l;
}
void add(int v, int l, int r, int pos, int val) {
	if (l == r && l == pos){
		vals[pos]+=val;
		return;

	}
	if (l > pos || r < pos)
		return;
	add(2 * v + 1, l, (l + r) / 2, pos, val);
	add(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
	if (vals[d[2 * v + 1]] < vals[d[2 * v + 2]]) {
		d[v] = d[2 * v + 1];
	}
	else {
		d[v] = d[2 * v + 2];
	}
}
int ask(int v, int l, int r, int askl, int askr) {
	if (l > askr || r < askl) {
		return askl;
	}
	if (l >= askl && r <= askr) {
		return d[v];
	}
	int aa = ask(2 * v + 1, l, (l + r) / 2, askl, askr);
	int bb = ask(2 * v + 2, (l + r) / 2 + 1, r, askl, askr);
	if (vals[aa] < vals[bb])
		return aa;
	return bb;
}
int main() {
	
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	d.resize(4 * n);
	build(0, 0, n-1);
	vals.resize(n+1);
	vector<pair<unordered_set<int>, unordered_set<int> > > a(m);
	vector<bool> actpos(m, 1);
	vector<unordered_set<int> > posof(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		for (int j = 0; j < k; j++) {
			int pos;
			char t;
			cin >> pos >> t;
			pos--;
			if (s[pos] == t) {
				posof[i].insert(pos);
				a[pos].first.insert(i);
			}
			else {
				a[pos].second.insert(i);
				add(0, 0, n-1, i, 1);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		if (a[i].first.size() == 0) {
			cout << -1;
			return 0;
		}
	}
	vector<int> sequence;
	for (int i=0;i<n;i++) {
		int okfor = ask(0, 0, n-1, 0, n);
		if (vals[okfor] != 0) {
			cout << -1;
			return 0;
		}
		else {
			sequence.push_back(okfor);
			add(0, 0, n-1, okfor, 1e9);
			for (auto h : posof[okfor]) {
				if (actpos[h]) {
					actpos[h] = false;
					for (auto hh : a[h].second) {
						add(0, 0, n-1, hh, -1);
					}
				}
			}
		}
	}
	for (auto h : sequence) {
		cout << h + 1 << ' ';
	}
}