#include <bits/stdc++.h>
#define all(x) (x).begin(), (x).end()

using namespace std;

const int K = 26, N = 510;
bool eat[K][K];
bool dp[N][N];
vector <int> ind[K];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int k, n;
    cin >> k >> n;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            char c;
            cin >> c;
            eat[i][j] = (c == '1');
        }
    }
    string s;
    cin >> s;
    for (int i = 0; i < n; i++)
        ind[s[i] - 'a'].push_back(i);

    for (int ln = 0; ln < n; ln++) {
        for (int st = 0; st + ln < n; st++) {
            int last = st + ln;
            if (ln == 0) {
                dp[st][last] = true;
                continue;
            }

            for (int mid = st + 1; mid <= last; mid++) {
                if (eat[s[st] - 'a'][s[mid] - 'a'] && dp[st][mid - 1] && dp[mid][last]) {
                    dp[st][last] = true;
                    break;
                }
            }
        }
    }

    string ans = s.substr(0, 1);

    vector <int> pos = {0};

    while (true) {
        vector <int> new_pos;
        for (int st : pos) {
            if (dp[st][n - 1]) {
                cout << ans << endl;
                return 0;
            }
        }

        for (int tar = 0; tar < k; tar++) {
            bool ok = false;

            for (int po : pos) {
                for (int i : ind[tar]) {
                    if (i > po && dp[po][i - 1]) {
                        ok = true;
                        new_pos.push_back(i);
                    }
                }
            }

            if (ok) {
                ans.push_back('a' + tar);
                pos = new_pos;
                break;
            }
        }
    }
    return 0;
}
