#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()

int32_t main() {
    //ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n, k;
    cin >> k >> n;
    vector<vector<int>> ok(k, vector<int>(k));
    for (int i = 0; i < k; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < k; ++j) {
            ok[i][j] = s[j] == '1';
        }
    }


    string s;
    cin >> s;

    vector<vector<int>> del(n, vector<int>(n, 0));
    for (int l = 1; l < n; ++l) {
        for (int r = 0; r < l; ++r) {
            del[l][r] = 1;
        }
        for (int r = l; r < n; ++r) {
            string g = s.substr(l-1, r-l+2);
            //cout << l << ' ' << r << ' ' << g << endl;
            int x = 1;
            while (x) {
                x = 0;
                for (int i = (int)g.size()-1; i >= 1; --i) {
                    if (ok[ g[i-1]-'a' ][ g[i]-'a' ]) {
                        g.erase(g.begin() + i);
                        x = 1;
                        break;
                    }
                }
            }
            if (g.size() == 1) {
                del[l][r] = 1;
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            //cout << del[i][j] << ' ';
        }
        //cout << endl;
    }


    vector<string> dp(n, string(1, 'z' + 1));

    dp[n-1] = s[n-1];
    for (int i = n-2; i >= 0; --i) {
        if (del[i+1][n-1]) {
            dp[i] = s[i];
            continue;
        }

        for (int j = i+1; j < n; ++j) {
            if (del[i+1][j-1]) {
                dp[i] = min(dp[i], s[i] + dp[j]);
            }
        }
    }
    cout << dp[0];
}

/*
 * 3 5
010
001
100
bcacb

 3 7
010
001
100
abacaba
 */