#include <bits/stdc++.h>

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto &i : v) {
        is >> i;
    }
    return is;
}

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (auto &i : v) {
        os << i << ' ';
    }
    return os;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    string b;
    cin >> b;
    for (int i = 0; i < m; ++i) {
        a[i] = b[i] - 'a' + 1;
    }
    vector<vector<int>> c(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        int am;
        cin >> am;
        for (int j = 0; j < am; ++j) {
            int pl;
            char let;
            cin >> pl >> let;
            c[i][pl - 1] = (let - 'a' + 1);
        }
    }
    bool taken, is_fine;
    vector<int> mask(m);
    vector<int> ans(n);
    vector<int> is_taken(n);
    for (int i = 0; i < n; ++i) {
        taken = false;
        for (int j = 0; j < n; ++j) {
            if (is_taken[j]) {
                continue;
            }
            is_fine = true;
            for (int k = 0; k < m; ++k) {
                if (c[j][k] == 0 || mask[k] == 1 || c[j][k] == a[k]) {
                    continue;
                } else {
                    is_fine = false;
                }
            }
            if (is_fine) {
                ans[i] = j + 1;
                is_taken[j] = 1;
                for (int k = 0; k < m; ++k) {
                    if (c[j][k] != 0) {
                        mask[k] = 1;
                    }
                }
                taken = true;
                break;
            }
        }
        if (!taken) {
            cout << -1 << '\n';
            return;
        }
    }

    for (int i = 0; i < m; ++i) {
        if (!mask[i]) {
            cout << -1 << '\n';
            return;
        }
    }

    cout << ans << '\n';
}

int main() {

    solve();

    return 0;
}
