#include <bits/stdc++.h>

#define ll long long
//#define int ll
#define pii pair<int, int>
#define mp make_pair
#define rep(i, n) for (int i = 0; i < n; ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define all(a) a.begin(), a.end()
#define pb push_back
#define ss second
#define ff first

using namespace std;

const int inf = 1e9;

vector<vector<int>> g;

bool get_bit(int mask, int pos) {
    return (mask & (1 << pos)) != 0;
}

vector<pii> dp;
bool ok = 1;
vector<vector<int>> order;

void dfs(int v) {
    vector<pair<pii, int>> mbo;
    for (int to : g[v]) {
        dfs(to);
        mbo.pb({dp[to], to});
        dp[v].ff = min(dp[to].ff, dp[v].ff);
        dp[v].ss = max(dp[to].ss, dp[v].ss);
    }
    sort(all(mbo));
    for (auto el : mbo) {
        order[v].pb(el.ss);
    }
    for (int i = 1; i < (int)mbo.size(); ++i) {
        if (mbo[i].ff.ff < mbo[i - 1].ff.ss)
            ok = 0;
    }
}

void run() {
    int n;
    cin >> n;
    g.resize(n);
    vector<pii> a;
    vector<int> leaf;
    rep(i, n) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            rep(j, k) {
                int el;
                cin >> el;
                el--;
                g[i].pb(el);
            }
        } else {
            int m;
            cin >> m;
            rep(j, m) {
                int el;
                cin >> el;
                a.pb({el, i});
            }
            leaf.pb(i);
        }
    }
    int cnt = a.size();
    rep(mask, (1 << cnt)) {
        dp.clear();
        dp.resize(n, mp(inf, -inf));
        vector<int> cur(n, 0);
        rep(i, cnt) {
            if (get_bit(mask, i)) {
                cur[a[i].ss]++;
                dp[a[i].ss].ff = dp[a[i].ss].ss = a[i].ff;
            }
        }
        bool oki = 1;
        for (auto l : leaf) {
            if (cur[l] != 1) oki = 0;
        }
        if (!oki) continue;

        order.clear();
        order.resize(n);
        ok = 1;
        dfs(0);
        if (ok) {
            cout << "Yes\n";
            rep(i, n) {
                if (order[i].empty()) {
                    cout << dp[i].ff << '\n';
                } else {
                    for (auto el : order[i]) {
                        cout << el + 1 << ' ';
                    }
                    cout << '\n';
                }
            }
            return;
        }
    }
    cout << "No";
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
    return 0;
}
