#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

const int INF = 1e9;

int n;
vec<vec<int>> g;
vec<vec<int>> vals;
vec<int> par;
vec<int> mn;
vec<int> mx;
bool ok;

inline void resize_all() {
	g.resize(n);
	vals.resize(n);
	par.resize(n);
	mn.resize(n);
	mx.resize(n);
}

void dfs(int v) {
	if (!len(g[v]) || !ok) {
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
		if (!ok) {
			return;
		}
	}
	sort(all(g[v]), [&](int a, int b) {
		return mn[a] < mn[b];
	});
	for (int i = 1; i < len(g[v]); i++) {
		if (mx[g[v][i - 1]] > mn[g[v][i]]) {
			ok = false;
			break;
		}
	}
	mn[v] = mn[g[v][0]];
	mx[v] = mx[g[v].back()];
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	cin >> n;
	resize_all();
	for (int i = 0; i < n; i++) {
		int type, sz;
		cin >> type >> sz;
		vec<int> cur(sz);
		for (auto &x : cur) {
			cin >> x;
			x--;
		}
		if (type == 1) {
			g[i] = cur;
		} else {
			sort(all(cur));
			vals[i] = cur;
		}
	}
	vec<int> ord;
	for (int i = 0; i < n; i++) {
		if (!len(g[i])) {
			ord.push_back(i);
		}
	}
	do {
		fill(all(mn), INF);
		fill(all(mx), -INF);
		int prev = -1;
		ok = 1;
		for (auto i : ord) {
			auto it = upper_bound(all(vals[i]), prev);;
			if (it == vals[i].end()) {
				ok = 0;
				break;
			}
			int cur = *it;
			mn[i] = mx[i] = cur;
			prev = cur;
		}
		dfs(0);
		if (ok) {
			cout << "Yes\n";
			for (int i = 0; i < n; i++) {
				if (len(g[i])) {
					for (auto x : g[i]) {
						cout << x + 1 << ' ';
					}
					cout << '\n';
				} else {
					cout << mn[i] + 1 << '\n';
				}
			}
			exit(0);
		}
	} while (next_permutation(all(ord)));
	cout << "No\n";
}
