#include "bits/stdc++.h"

using namespace std;

#define fi first
#define se second




int main() {

    int k, n;
    cin >> k >> n;
    vector<vector<bool>> can;
    can.resize(k, vector<bool>(k, false));
    for(int i = 0; i < k; ++i) {
        for(int j = 0; j < k; ++j) {
            char x; cin >> x;
            if(x == '1')
                can[i][j] = true;
        }
    }
    string s; cin >> s;

    vector<unordered_set<int>> suf(n);
    suf[0].insert(0);

    for(int i = 1; i < n; ++i) {
        suf[i].max_load_factor(0.25);
        suf[i].reserve(n);
        suf[i].insert(0);
        for(int j = 0; j < i; ++j) {
            if(!can[s[j] - 'a'][s[i] - 'a']) continue;
            if(suf[i - 1].count(i - j - 1)) {
                //cout << "J: " << j << '\n';
                for(auto x: suf[j]) {
                    suf[i].insert(i - j + x);
                }
            }
        }
    }

    vector<string> dp(n, "");
    dp[n - 1] = s[n - 1];

    for(int i = n - 2; i >= 0; --i) {
        string ans = "";
        for(int j = i + 1; j < n; ++j) {
            if(suf[j - 1].count(j - i - 1) && dp[j] != "") {
                //cout << i << ' ' << j << '\n';
                if(ans == "") ans = s[i] + dp[j];
                else{
                    ans = min(ans, s[i] + dp[j]);
                }
            }
        }
        if(suf[n-1].count(n - i - 1)) {
            ans = s[i];
        }
        //cout << ans << '\n';
        dp[i] = ans;
    }

    cout << dp[0];

    return 0;
}
/*
3 7
010
001
100
abacaba

3 7
1 0 1
0 1 1
0 0 1
bbaaccb
*/