#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

// #define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif	

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#pragma GCC optimize("Ofast,O2")

const int A = 26;
const int N = 10010;
// const long long INF = 1e18;

int k, n;
int g[A][A];
int can[N];
string s;
string dp[N];
// int from[N], d[N];
// int used[N];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			char c;
			cin >> c;
			g[i][j] = c - '0';
		}
	}
	cin >> s;
	can[n - 1] = 0;
	for (int i = n - 2; i >= 0; i--) {
		for (int j = i + 1; j < n && j <= i + can[i] + 1; j++) {
			if (g[s[i] - 'a'][s[j] - 'a']) chkmax(can[i], j - i + can[j]);
		}
	}
	// for (int i = 0; i < n; i++) {
	// 	cout << can[i] << " ";
	// }
	// cout << "\n";
	// set<pii> q;
	// d[n] = 0;
	// for (int i = 0; i < n; i++) {
	// 	d[i] = INF;
	// }
	// q.insert({0, n});
	// while (!q.empty()) {
	// 	int ind = (*q.begin()).second;
	// 	q.erase(q.begin());
	// 	if (used[ind]) continue;
	// 	used[ind] = 1;
	// 	for (int i = 0; i < ind; i++) {
	// 		if (i + can[i] + 1 >= ind) {
	// 			if (chkmin(d[i], d[ind] + s[i] - 'a' + 1)) {
	// 				q.insert({d[i], i});
	// 				from[i] = ind;
	// 			}
	// 		}
	// 	}
	// }
	dp[n - 1].pb(s[n - 1]);
	for (int i = n - 2; i >= 0; i--) {
		dp[i] = s[i] + dp[i + 1];
		for (int j = i + 1; j < n && j <= i + can[i] + 1; j++) {
			chkmin(dp[i], s[i] + dp[j]);
		}
		if (can[i] == n - i - 1) {
			dp[i] = s[i];
		}
	}
	cout << dp[0] << "\n";
	// string ans;
	// int ind = 0;
	// // int cnt = 0;
	// while (ind < n) {
	// 	// cnt++;
	// 	// if (cnt > 10) break;
	// 	// dbg(ind);
	// 	ans.pb(s[ind]);
	// 	ind = from[ind];
	// }
	// cout << ans << "\n";
}
/*
3 7
010
001
100
abacaba
-> aac

3 5
010
001
100
bcacb
-> bacb

4 4 
0000
0000
1000
0110
dcab

*/