#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	string s;
	cin >> n >> m;
	cin >> s;

	vector < vector < char > > kek;
	kek.assign(n, vector < char >(m, '#'));

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int pos;
		char t;
		for (int j = 0; j < k; j++) {
			cin >> pos >> t;
			pos--;
			kek[i][pos] = t;
		}
	}

	vector < int > ans;
	vector < bool > taken(m, false);
	vector < bool > used(n, false);
	int freepos = m;
	while (freepos > 0) {
		bool take = false;
		for (int i = 0; i < n; i++) {
			if (used[i]) continue;
			bool ok = true;
			for (int j = 0; j < m; j++) {
				if (kek[i][j] == '#' || taken[j]) continue;
				if (s[j] != kek[i][j]) ok = false;
			}
			if (!ok) continue;
			take = true;
			used[i] = true;
			ans.push_back(i);
			for (int j = 0; j < m; j++) {
				if (kek[i][j] == '#') continue;
				taken[j] = true;
				freepos--;
			}
		}
		if (!take) {
			cout << "-1";
			return 0;
		}
	}

	for (int i = 0; i < n; i++)
		if (!used[i]) ans.push_back(i);

	for (auto e : ans) cout << e + 1 << " ";
}