/// Created by Arsenii Kirillov
 
#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#ifndef LOCAL
#  define cerr __get_ce
#endif
 
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
 
/*
using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;
//*/
 
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }
 
 
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> xx(n + 2), yy(n + 2);
	for (int i = 1; i <= n; i++) {
		cin >> xx[i] >> yy[i];
	}
	xx[0] = xx[1];
	xx[n + 1] = xx[n];
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		vector<int> used(n + 2, 1);
		int ans = 0;
		for (int qwe = 0; qwe < 15; qwe++) {
			int x = rand() % 2;
			if (x) {
				for (int i = l; i <= r; i++) {
					if (used[i]) {
						int j = i - 1;
						while (used[j] == 0 && xx[j] > xx[i] - yy[i])
							j--;
						if (xx[j] <= xx[i] - yy[i]) {
							ans++;
							used[i] = 0;
							continue;
						}
						j = i + 1;
						while (used[j] == 0 && xx[j] < xx[i] + yy[i])
							j++;
						if (xx[j] >= xx[i] + yy[i]) {
							ans++;
							used[i] = 0;
							continue;
						}
					}
				}
			} else {
				for (int i = r; i >= l; i--) {
					if (used[i]) {
						int j = i - 1;
						while (used[j] == 0 && xx[j] > xx[i] - yy[i])
							j--;
						if (xx[j] <= xx[i] - yy[i]) {
							ans++;
							used[i] = 0;
							continue;
						}
						j = i + 1;
						while (used[j] == 0 && xx[j] < xx[i] + yy[i])
							j++;
						if (xx[j] >= xx[i] + yy[i]) {
							ans++;
							used[i] = 0;
							continue;
						}
					}
				}
			}
		}
		cout << ans << "\n";
	}
}
 
 
int main() {
	srand(time(0));
#ifdef LOCAL
	clock_t start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
 
	int test_count = 1;
	//cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
 
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}