import java.io.*;
import java.util.*;

public class task4 {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int m = nextInt();
        int[] roads = new int[n - 1];
        int[] min = new int[n - 1];
        int[] min1 = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            min[i] = 1000000009;
            min1[i] = 1000000009;
        }
        for (int i = 0; i < m; i++) {
            int v = Math.min(nextInt(), nextInt()) - 1;
            int x = nextInt();
            if (x <= min[v]) {
                min1[v] = min[v];
                min[v] = x;
            }
            else if (x < min1[v]) {
                min1[v] = x;
            }
            roads[v] = Math.min(2, roads[v] + 1);
        }
        int fast = min[0];
        int slow = min[0];
        for (int i = 0; i < n - 1; i++) {
            fast = Math.min(fast, min[i]);
            slow = Math.max(slow, min[i]);
            int fast1 = fast;
            int slow1 = slow;
            int ans = fast + slow;
            for (int j = i + 1; j < n - 1; j++) {
                if (roads[j] > 1) {
                    fast1 = Math.min(fast1, Math.min(min[j], min1[j]));
                    slow1 = Math.max(slow1, Math.max(min[j], min1[j]));
                    ans = Math.min(ans, fast1 + slow1);
                }
                else {
                    break;
                }
            }
            out.println(ans);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static String nextToken() throws IOException{
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}