#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;


template <class T> bool ckmin(T &a,T b) { return b < a ? a=b, true : false;}
template <class T> bool ckmax(T &a,T b) { return a < b ? a=b, true : false;}

#define all(v) v.begin(),v.end()
#define sz(v) (int)v.size()
#define F first
#define S second
#define eb emplace_back


const int N = 3e5 + 500;
const int INF = INT_MAX >> 1;
const ll LINF = LLONG_MAX >> 1;

vector<pair<int,int>> g[N];
bool us[N];
int mn[N], mx[N];


void dfs(int v){
    us[v] = true;
    for(auto [b,t] : g[v]) if(!us[b]){
        ckmin(mn[b],min(mn[v],t)), ckmax(mx[b],max(mx[v],t));
        dfs(b);
    }
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0);
    int n,m; cin>>n>>m;
    for(int i=0;i<m;i++){
        int a,b,t; cin>>a>>b>>t;
        g[a].eb(b,t), g[b].eb(a,t);
    }
    for(int i=1;i<=n;i++) mn[i] = INF, mx[i] = 0;
    dfs(1);
    for(int i=2;i<=n;i++) cout<<mn[i] + mx[i]<<'\n';
    return 0;
}


/*

3 3
1 2 3
1 3 2
2 3 1



7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9

*/
