#include<bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()

const int N = 1e5 + 100;
const int sqrn = 200;

int n;
int h[N], x[N];

int q;

vector<pii> ask;
vector<int> srt;

bool cmp(int a, int b) {
	if (ask[a].first / sqrn == ask[b].first / sqrn) {
		return ask[a].second < ask[b].second;
	}
	return ask[a].first < ask[b].first;

	// return tie(ask[a].first / sqrn, ask[a].second) < tie(ask[b].first / sqrn, ask[b].second);
}

int ans[N];


deque<int> poss;
vector<pii> hist;


int l, r;

void add_r() {
	// cout << "Add_R " << r << '\n';
	// for (auto i : poss) cout << i << ' ';
	// cout << '\n';

	bool flag = 0;

	if (x[r] + h[r] <= x[r + 1]) {
		flag = 1;
	} else if (poss.empty()) {
		if (x[r] - h[r] >= x[l - 1]) flag = 1;
	} else {
		if (x[r] - h[r] >= x[poss.back()]) flag = 1;
	}
	if (flag) {
		while (!poss.empty() && x[poss.back()] + h[poss.back()] <= x[r + 1]) poss.pop_back();
	} else {
		poss.push_back(r);
	}
}

void add_l() {
	// cout << "Add_L " << l << " r = " << r << '\n';
	// for (auto i : poss) cout << i << ' ';
	// cout << '\n';

	bool flag = 0;

	if (x[l] - h[l] >= x[l - 1]) {
		flag = 1;
		// cout << "here1" << '\n';
	} else if (poss.empty()) {
		if (x[l] + h[l] <= x[r]) {
			flag = 1;
			// cout << "here2" << '\n';
		}
	} else {
		if (x[l] + h[l] <= x[poss.front()]) flag = 1;
		// cout << "here3" << '\n';
	}
	if (flag) {
		while (!poss.empty() && x[poss.front()] - h[poss.front()] >= x[l - 1]) {
			hist.push_back({-1, poss.front()});
			poss.pop_front();
		}
	} else {
		poss.push_front(l);
		hist.push_back({1, l});
	}
}

void rebuild() {
	if (hist.size() > 500) assert(0);

	while (!hist.empty()) {
		if (hist.back().first == 1) {
			poss.pop_front();
		} else {
			poss.push_front(hist.back().second);
		}
		hist.pop_back();
	}
}












int used[N];
int tol[N];
int tor[N];

void stupid(int u) {
	int l = ask[u].first;
	int r = ask[u].second;

	queue<int> burn;
	for (int i = l; i < r; i++) {
		tol[i] = i - 1;
		tor[i] = i + 1;
		if ((x[i] - h[i] >= x[tol[i]] || x[i] + h[i] <= x[tor[i]]) && !used[i]) {
			burn.push(i);
			used[i] = 1;
		}
	}

	int ansv = 0;
	while (!burn.empty()) {
		ansv++;
		int u = burn.front();
		burn.pop();
		if (tol[u] >= l) {
			tor[tol[u]] = tor[u];
			int i = tol[u];
			if ((x[i] - h[i] >= x[tol[i]] || x[i] + h[i] <= x[tor[i]]) && !used[i]) {
				burn.push(i);
				used[i] = 1;
			}
		}

		if (tor[u] < r) {
			tol[tor[u]] = tol[u];
			int i = tor[u];
			if ((x[i] - h[i] >= x[tol[i]] || x[i] + h[i] <= x[tor[i]]) && !used[i]) {
				burn.push(i);
				used[i] = 1;
			}
		}
	}
	for (int i = l; i < r; i++) {
		used[i] = 0;
	}
	ans[u] = ansv;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n;
	cin >> q;

	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = x[1];
	x[n + 1] = x[n];

	for (int j = 0; j < q; j++) {
		int l, r;
		cin >> l >> r;
		r++;
		ask.push_back({l, r});
	}
	for (int i = 0; i < q; i++) srt.push_back(i);
	sort(all(srt), cmp);


	int last = -1;

	for (auto i : srt) {
		pii p = ask[i];
		if (p.first / sqrn == p.second / sqrn) {
			stupid(i);
			continue;
		}

		// cout << "solve " << p.first << ' ' << p.second << '\n'; 

		if (p.first / sqrn > last) {
			l = (p.first / sqrn + 1) * sqrn;
			r = (p.first / sqrn + 1) * sqrn;
			poss.clear();
		}

		// cout << "start at l = " << l << " r = " << r << '\n';

		while (r < p.second) {
			add_r();
			r++;
		}
		// copy
		while (l > p.first) {
			l--;
			add_l();
		}

		ans[i] = r - l - poss.size();
		// cout << "ans = " << ans[i] << '\n';

		rebuild();

		l = (p.first / sqrn + 1) * sqrn;
		// cout << '\n';
	}

	for (int i = 0; i < q; i++) {
		cout << ans[i] << '\n';
	}

	return 0;
}
 