#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
const int Inf = 1e9 + 7;

vector <int> smart(int n, int q, vector <int> x, vector <int> h, vector <int> L, vector <int> R) {
    x.insert(x.begin(), x[0]);
    h.insert(h.begin(), Inf);
    x.push_back(x.back());
    h.push_back(Inf);
    vector <int> kill(n + 2);
    vector <int> stay(n + 2);
    vector <int> min_r(n + 2);
    vector <vector <int>> who(n + 2);

    vector <int> go_r(q);
    vector <int> go_l(q);
    vector <int> ans(q);

    function <void(int, int, vector <int>)> rec = [&] (int l, int r, vector <int> id) {
        if (id.empty()) return;
        //cout << l << ' ' << r << endl;
        int m = (l + r) / 2;
        vector <int> goL, goR;
        vector <int> gs;
        for (int idx : id) {
            if (R[idx] <= m - 1) {
                goL.push_back(idx);
            } else if (L[idx] >= m + 2) {
                goR.push_back(idx);
            } else {
                gs.push_back(idx);
            }
        }
        rec(l, m, goL);
        rec(m + 1, r, goR);

        //cout << m << endl;

        for (int i : gs) {
            who[L[i]].push_back(i);
        }

        vector <int> st;
        for (int i = m + 1; i <= r; ++i) {
            kill[i] = r + 1;
            stay[i] = 0;
        }
        for (int i = m + 1; i <= r; ++i) {
            int lst;
            if (st.empty()) {
                lst = x[m];
            } else {
                lst = x[st.back()];
            }
            int nxt = x[min(n + 1, i + 1)];
            int ok = 0;
            if (x[i] - h[i] >= lst) {
                kill[i] = i + 1;
                ok = 1;
            }
            if (x[i] + h[i] <= nxt) {
                kill[i] = i + 1;
                ok = 1;
            }
            if (ok) {
                stay[i] = 0;
                while (!st.empty() && x[st.back()] + h[st.back()] <= nxt) {
                    kill[st.back()] = i + 1;
                    st.pop_back();
                }
            } else {
                stay[i] = 1;
                st.push_back(i);
            }
        }
        /*vector <int> pl;
        for (int i = m + 1; i <= r; ++i) {
            if (stay[i]) pl.push_back(i);
        }*/
        st.clear();
        for (int i = m; i >= l; --i) {
            int nxt;
            if (st.empty()) {
                nxt = x[min(n + 1, m + 1)];
            } else {
                nxt = x[st.back()];
            }
            int lst = x[max(0, i - 1)];
            int pr = -1;
            if (!st.empty()) pr = st.back();
            if (pr == -1) {
                min_r[i] = m + 1;
            } else {
                int cur = min_r[pr];
 
                //cout << pr << ' ' << cur << endl;
                while (cur <= r && x[pr] + h[pr] > x[cur]) {
                    if (x[cur] - h[cur] >= x[pr]) cur = cur + 1;
                    else cur = kill[cur];
                }
                min_r[i] = cur;
            }
            for (int t : who[i + 1]) {
                //cout << l << ' ' << r << ' ' << m << endl;
                int cr = R[t];
                int last_l = L[t] - 1;
                //cout << last_l << endl;
                if (min_r[last_l] > cr + 1) {
                    assert(!st.empty());
                    for (int i = (int)st.size() - 1; i >= 0; --i) {
                        if (min_r[st[i]] <= cr + 1) {
                            last_l = st[i];
                            ans[t] += (int)st.size() - i;
                            break;
                        }
                    }
                    assert(min_r[last_l] <= cr + 1);
                }
                go_r[t] = min_r[last_l];
                go_l[t] = last_l;
                //cout << go_l[t] << ' ' << go_r[t] << endl;
            }

            if (x[i] + h[i] <= nxt || x[i] - h[i] >= lst) {
                while (!st.empty() && x[st.back()] - h[st.back()] >= lst) st.pop_back();
            } else {
                st.push_back(i);
            }
        }
        for (int i : gs) {
            who[L[i]].clear();
        }
        for (int i : gs) {
            who[R[i]].push_back(i);
        }
        st.clear();
        for (int i = m + 1; i <= r; ++i) {
            int lst;
            if (st.empty()) {
                lst = x[m];
            } else {
                lst = x[st.back()];
            }
            int nxt = x[min(n + 1, i + 1)];
            if (x[i] - h[i] >= lst || x[i] + h[i] <= nxt) {
                while (!st.empty() && x[st.back()] + h[st.back()] <= nxt) {
                    st.pop_back();
                }
            } else {
                st.push_back(i);
            }
            for (int t : who[i]) {
                int uk = 0;
                while (uk < (int)st.size() && x[st[uk]] - h[st[uk]] >= x[go_l[t]]) ++uk;
                ans[t] += (int)st.size() - uk;
            }
        }
        for (int i : gs) who[R[i]].clear();
    };
    vector <int> all(q);
    iota(all.begin(), all.end(), 0);
    rec(0, n + 1, all);
    for (int i = 0; i < q; ++i) {
        //cout << ans[i] << endl;
        ans[i] = R[i] - L[i] + 1 - ans[i];
    }
    return ans;
}

vector <int> stupid(int n, int q, vector <int> x, vector <int> h, vector <int> L, vector <int> R) {
    vector <vector <pair <int, int>>> qr(n);
    for (int i = 0; i < q; ++i) {
        int l = L[i], r = R[i];
        --l, --r;
        qr[l].push_back({r, i});
    }
    vector <int> ans(q);
    for (int l = 0; l < n; ++l) {
        sort(qr[l].begin(), qr[l].end());
        vector <pair <int, int>> st;
        int uk = 0;
        for (int r = l; r < n; ++r) {
            int lst;
            if (st.empty()) {
                lst = x[max(0, l - 1)];
            } else {
                lst = st.back().first;
            }
            int nxt = x[min(n - 1, r + 1)];
            if (x[r] - h[r] >= lst || x[r] + h[r] <= nxt) {
                while (!st.empty() && st.back().first + st.back().second <= nxt) st.pop_back();
            } else {
                st.push_back({x[r], h[r]});
            }
            while (uk < qr[l].size() && qr[l][uk].first == r) {
                ans[qr[l][uk].second] = r - l + 1 - (int)st.size();
                ++uk;
            }
        }
    }
    return ans;
}

mt19937 rnd(123);

void stress() {
    int tt = 100000;
    while (tt--) {
        int n = rnd() % 5 + 1;
        vector <int> x(n), h(n);
        for (int i = 0; i < n; ++i) {
            x[i] = (i == 0 ? 0 : x[i - 1]);
            x[i] += rnd() % 3 + 1;
        }
        for (int i = 0; i < n; ++i) h[i] = rnd() % 5 + 1;
        int q = 1;
        vector <int> L(q), R(q);
        for (int i = 0; i < q; ++i) {
            L[i] = rnd() % n + 1, R[i] = rnd() % n + 1;
            if (L[i] > R[i]) swap(L[i], R[i]);
        }
        if (stupid(n, q, x, h, L, R) != smart(n, q, x, h, L, R)) {
            cout << n << ' ' << q << '\n';
            for (int i = 0; i < n; ++i) {
                cout << x[i] << ' ' << h[i] << '\n';
            }
            for (int i = 0; i < q; ++i) {
                cout << L[i] << ' ' << R[i] << '\n';
            }
            exit(0);
        }
        if (tt % 10 == 0) {
            cout << tt << endl;
        }
    }
    exit(0);
}

void run() {
    int n, q;
    cin >> n >> q;
    vector <int> x(n), h(n);
    for (int i = 0; i < n; ++i) cin >> x[i] >> h[i];
    vector <int> L(q), R(q);
    for (int i = 0; i < q; ++i) {
        cin >> L[i] >> R[i];
    }
    for (auto v : smart(n, q, x, h, L, R)) {
        cout << v << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif
    //stress();
    run();
}