#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int MAXN = (int)5e5;

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];

	while (q--) {
		int l, r;
		cin >> l >> r;
		--l;

		vector<int> curx = x, curh = h;
		int curn = n;
		bool found = true;
		int ans = 0;
		while (found) {
			found = false;
			for (int i = l; i < r; ++i) {
				int prevx = i > 0 ? curx[i - 1] : x[0];
				int nextx = i + 1 < curn ? curx[i + 1] : x[n - 1];
				if (curx[i] + curh[i] <= nextx || curx[i] - curh[i] >= prevx) {
					++ans;
					--r;
					--curn;
					curx.erase(curx.begin() + i);
					curh.erase(curh.begin() + i);
					found = true;
					break;
				}
			}
		}

		cout << ans << '\n';
	}

	return 0;
}