#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <algorithm>
#include <cassert>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
using ll = long long;
const int N = 3e5 + 10;
vector<pair<int, int>> g[N];
int ans[N];
void dfs(int v, int mx, int mn, int p = -1) {
	ans[v] = mx + mn;
	for (auto e : g[v]) {
		int to = e.first, w = e.second;
		if (to != p)
			dfs(to, max(mx, w), min(mn, w), v);
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	while (m--) {
		int x, y, t;
		cin >> x >> y >> t;
		g[x].pb({ y, t });
		g[y].pb({ x, t });
	}
	dfs(1, 0, 1e9);
	for (int i = 2; i <= n; i++) cout << ans[i] << '\n';
	return 0;
}
/*
3 3
1 3
3 1
4 2
1 1
*/