#include <bits/stdc++.h>
using namespace std;

vector<vector<pair<int, int>>> g;
vector<pair<pair<int, int>, pair<int, int>>> ans;
vector<pair<int, int>> bad;
vector<bool> used;

pair<int, int> dfs(int u) {
    used[u] = true;
    pair<int, int> ret{0, 0};
    vector<pair<int, int>> r1, r2;
    for (auto to: g[u]) {
        if (!used[to.first]) {
            auto res = dfs(to.first);
            if (res.first == -1 || res.first > 1 || res.second > 1 || res.first == 1 && to.second == 1 || res.second == 1 && to.second == 0)
                return {-1, -1};
            if (to.second != 1) {
                if (res.first == 0) {
                    ++ret.first;
                    r1.emplace_back(u, to.first);
                }
                else
                    ans.push_back({{u, to.first}, bad[to.first]});
            }
            if (to.second != 0) {
                if (res.second == 0) {
                    ++ret.second;
                    r2.emplace_back(to.first, u);
                }
                else
                    ans.push_back({bad[to.first], {to.first, u}});
            }
        }
    }
    while (r1.size() > 0 && r2.size() > 0) {
        ans.emplace_back(r2.back(), r1.back());
        --ret.first;
        --ret.second;
        r1.pop_back();
        r2.pop_back();
    }
    if (ret.first > 0)
        bad[u] = r1[0];
    else if (ret.second > 0)
        bad[u] = r2[0];
    return ret;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.assign(n, false);
    bad.resize(n);
    set<pair<int, int>> mat;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        auto it = mat.find({v, u});
        if (it != mat.end()) {
            g[u].emplace_back(v, 2);
            g[v].emplace_back(u, 2);
            mat.erase(it);
        }
        else
            mat.insert({u, v});
    }
    for (auto p: mat) {
        g[p.first].emplace_back(p.second, 0);
        g[p.second].emplace_back(p.first, 0);
    }
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        auto res = dfs(i);
        if (res.first != 0 || res.second != 0) {
            cout << "No" << endl;
            return 0;
        }
    }
    cout << "Yes" << '\n';
    for (auto p: ans)
        cout << p.first.first + 1 << ' ' << p.first.second + 1 << ' ' << p.second.first + 1 << ' ' << p.second.second + 1 << '\n';
}
