#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int q;
    cin >> q;
    unordered_map <char, ll> cost;
    vector <ll> all = {1, 5, 10, 50, 100, 500, 1000, 5 * 1000, 10000, 5 * 10000,
                        100000, 5 * 100000, 1000000LL, 5 * 1000000LL, 10000000LL, 5 * 10000000LL,
                        100000000LL, 5 * 100000000LL, 1000000000LL, 5 * 1000000000LL, 10000000000LL, 5 * 10000000000LL,
                        100000000000LL, 5 * 100000000000LL, 1000000000000LL, 5 * 1000000000000LL};

    for (int i = 0; i < 26; i++)
        cost['A' + i] = all[i];
    while (q--)
    {
        int k = -1;
        string s; cin >> s;
        ll baseCost = 0LL;
        set <char> used;
        vector <bool> toInsert(s.size(), false);
        int n = s.size();
        for (int i = s.size() - 1; i >= 0; i--)
        {
            if (s[i] == '?') continue;
            if (used.upper_bound(s[i]) != used.end())
                baseCost -= cost[s[i]];
            else
            {
                baseCost += cost[s[i]];
                toInsert[i] = true;
            }
            used.insert(s[i]);
        }

        vector <int> pos;
        vector <int> cnt(26, 0);
        vector <vector <int> > prev;
        for (int i = 0; i < s.size(); i++)
            if (s[i] == '?')
            {
                pos.push_back(i);
                prev.push_back(cnt);
                cnt = vector <int>(26, 0);
            } else if (toInsert[i])
            {
                cnt[s[i] - 'A']++;
            }

        ll ans = baseCost;
        baseCost = -LONG_MAX;

        vector <int> perm;
        function <void ()> dfs = [&]()
        {
            if (perm.size() == prev.size())
            {
                ll temp = 0;
                for (int i = 0; i < perm.size(); i++)
                {
                    temp += cost['A' + perm[i]];
                    for (int j = 0; j < perm[i]; j++)
                        temp -= cost[j + 'A'] * prev[i][j] * 2;
                }
                if (baseCost < temp + ans)
                {
                    baseCost = temp + ans;
                    for (int i = 0; i < perm.size(); i++)
                        s[pos[i]] = char(perm[i] + 'A');
                }
            } else if (perm.size() < prev.size())
            {
                for (int i = 0; i < 26; i++)
                {
                    perm.push_back(i);
                    dfs();
                    perm.pop_back();
                }
            }
        };

        dfs();

        cout << baseCost << "\n" << s << "\n";
    }
}
