#include <iostream>
#include <vector>
#include <algorithm>
#include "numeric"
#include "set"
#include "map"
using namespace std;
#define all(x) (x).begin(), (x).end()
typedef long long ll;

void solve(vector<pair<int, int>> zpr, int lg, int rg) {
    int res = 0;
    vector<pair<int, int>> stk;
    for (auto [crd, h] : zpr) {
        while (!stk.empty()) {
            if (stk.back().first + stk.back().second <= crd) {
                res++;
                stk.pop_back();
            } else {
                break;
            }
        }
        if (stk.empty()) {
            if (crd - h >= lg) {
                res++;
            } else {
                stk.push_back({crd, h});
            }
        } else {
            if (crd - h >= stk.back().first) {
                res++;
            } else {
                stk.push_back({crd, h});
            }
        }
    }
    while (!stk.empty()) {
        if (stk.back().first + stk.back().second <= rg) {
            res++;
            stk.pop_back();
        } else {
            break;
        }
    }
    cout << res << '\n';
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<pair<int, int>> tree(n);
    for (auto & [l, r] : tree) {
        cin >> l >> r;
    }
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        vector<pair<int, int>> zpr;
        for (int j = l; j < r; ++j) {
            zpr.push_back(tree[j]);
        }
        solve(zpr, tree[max(0, l - 1)].first, tree[min(n-1, r)].first);
    }
}