#include <bits/stdc++.h>

using ll = long long;

const long long llinf = 2e18;
const int MAXM = 26;
ll nums[MAXM];

__int128 max(const __int128 &a, const __int128 &b) {
    return (a > b ? a : b);
}

int main() {
    nums[0] = 1, nums[1] = 5;
    for (int i = 2; i < MAXM; i++) nums[i] = nums[i - 2] * 10;

    int t;
    std::cin >> t;
    while (t--) {
        std::string s;
        std::cin >> s;

        int n = s.size();
        ll dp[n][MAXM];
        int pred[n][MAXM];
        char opt[n][MAXM];
        for (auto &i : dp) for (auto &j : i) j = -llinf;

        if (s.back() == '?') for (int i = 0; i < MAXM; i++) {
            dp[n - 1][i] = nums[i];
            opt[n - 1][i] = i + 'A';
            pred[n - 1][i] = -1;
        }
        else {
            dp[n - 1][s.back() - 'A'] = nums[s.back() - 'A'];
            opt[n - 1][s.back() - 'A'] = s.back();
            pred[n - 1][s.back() - 'A'] = -1;
        }

        for (int i = n - 2; i >= 0; i--) {
            for (int right = 0; right < MAXM; right++) {
                if (s[i] != '?') {
                    int si = s[i] - 'A';
                    if (right > si) {
                        if(dp[i + 1][right] - nums[si] > dp[i][right]) opt[i][right] = si + 'A', pred[i][right] = right;
                        dp[i][right] = max(dp[i][right], dp[i + 1][right] - nums[si]);
                    }
                    else {
                        if(dp[i + 1][right] + nums[si] > dp[i][si]) opt[i][si] = si + 'A', pred[i][si] = right;
                        dp[i][si] = max(dp[i][si], dp[i + 1][right] + nums[si]);
                    }
                    continue;
                }
                for (int si = 0; si < MAXM; si++) {
                    if (right > si) {
                        if(dp[i + 1][right] - nums[si] > dp[i][right]) opt[i][right] = si + 'A', pred[i][right] = right;
                        dp[i][right] = std::max(dp[i][right], dp[i + 1][right] - nums[si]);
                    }
                    else {
                        if(dp[i + 1][right] + nums[si] > dp[i][si]) opt[i][si] = si + 'A', pred[i][si] = right;
                        dp[i][si] = std::max(dp[i][si], dp[i + 1][right] + nums[si]);
                    }
                }
            }
        }

        long long ans = -(0x3f3f3f3f3f3f3f3f);
        for (int i = 0; i < MAXM; i++) if(dp[0][i] > ans) ans = dp[0][i];
        std::string res;
        int k = std::find(dp[0], dp[0] + MAXM, ans) - dp[0];
        for(int i = 0; i < n; i++) {
            res += opt[i][k];
            k = pred[i][k];
        }

        std::cout << ans << '\n' << res << '\n';
    }
}