#include <bits/stdc++.h>

const int inf = 0x3f3f3f3f;
using ll = long long;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
using pii = std::pair<int, int>;

const int MAXN = 20;
std::vector<pii> g[MAXN];

int mat[MAXN][MAXN];

int main() {
    int n, m;
    std::cin >> n >> m;

    std::map<pii, int> cntEdges;
    memset(mat, -1, sizeof(mat));

    std::pair<pii, int> order[m];
    for (int i = 0; i < m; i++) {
        int a, b, t;
        std::cin >> a >> b >> t;
        a--, b--;
        order[i] = std::make_pair(std::make_pair(a, b), t);
        cntEdges[std::make_pair(a, b)]++;
        cntEdges[std::make_pair(b, a)]++;
        g[a].emplace_back(b, t);
        g[b].emplace_back(a, t);

        mat[a][b] = mat[b][a] = t;
    }

    std::sort(order, order + m);

    int ans[n];
    for(auto &i : ans) i = 2e9 + 3;
    do {
        int mini = inf, maxi = -inf;

        int last = 0;
        if(order[0].first.first != 0 && order[0].first.second != 0) continue;
        for(int i = 0; i < n; i++) {
            if(i > 0 && order[i].first.first != last && order[i].first.second != last) {
                mini = maxi = inf;
                break;
            }
            int t = order[i].second;
            mini = std::min(mini, t);
            maxi = std::max(maxi, t);
            if(order[i].first.second == last) ans[order[i].first.first] = std::min(ans[order[i].first.first], mini + maxi);
            else ans[order[i].first.second] = std::min(ans[order[i].first.second], mini + maxi);
            if(order[i].first.second == last) last = order[i].first.first;
            else last = order[i].first.second;
        }
    } while(std::next_permutation(order, order + n));

    for(int i = 1; i < n; i++) std::cout << ans[i] << ' ';
}