#include <bits/stdc++.h>
 
#define ll long long
#define pb push_back
#define pii pair<int, int>
 
using namespace std;
 
struct reb {
    int to, a, b;
    reb() {}
    reb(int to_, int a_, int b_) {
        to = to_;
        a = a_;
        b = b_;
    }
};
 
int n, m;
vector<vector<reb>> g;
vector<int> used;
vector<pair<pii, pii>> ans;
set<pii> all;
vector<pii> reb_a, reb_b;
 
void no() {
    cout << "No\n";
    exit(0);
}
 
// int cnt = 0;
 
pii dfs(int v, int p) {
    // cnt++;
    // if (cnt < 10) cout << "in " << v << endl;
    used[v] = 1;
    vector<pii> a, b;
    for (auto e : g[v]) {
        if (e.to == p) continue;
        pii q = dfs(e.to, v);
        if (q.first) {
            if (e.a) {
                ans.pb({reb_a[e.to], {v, e.to}});
                e.a = 0;
            }
        }
        if (e.a) a.pb({v, e.to});
        if (q.second) {
            if (e.b) {
                ans.pb({reb_b[e.to], {e.to, v}});
                e.b = 0;
            }
        }
        if (e.b) b.pb({e.to, v});
    }
    while (a.size() > 0 && b.size() > 0) {
        ans.pb({a.back(), b.back()});
        a.pop_back();
        b.pop_back();
    }
    if (a.size() > 1 || b.size() > 1) no();
 
    if (a.size()) {
        reb_a[v] = a.back();
    }
 
    if (b.size()) {
        reb_b[v] = b.back();
    }
 
    return {a.size(), b.size()};
}
 
void solve() {
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        all.insert({a, b});
    }
    while (all.size() > 0) {
        pii t = *all.begin();
        int a = 1, b = 0;
        if (all.find({t.second, t.first}) != all.end()) b++;
        all.erase(t);
        all.erase({t.second, t.first});
        g[t.first].pb(reb(t.second, a, b));
        g[t.second].pb(reb(t.first, b, a));
    }
 
    used.assign(n, 0);
    reb_a.resize(n);
    reb_b.resize(n);
     
 
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            pii q = dfs(i, i);
            if (q.first != 0 || q.second != 0) {
                no();
            }
            // cout << "ok " << i << endl;
        }
    }
    cout << "Yes\n";
    for (auto e : ans) {
        cout << e.first.first + 1 << " " << e.first.second + 1 << " " << e.second.first + 1 << " " << e.second.second + 1 << "\n";
    }
}
 
signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
 
    return 0;
}
