#include <iostream>;
#include <vector>;

using namespace std;

long long min(long long a, long long b) {
	if (a < b) {
		return a;
	}
	return b;
}

long long max(long long a, long long b) {
	if (a > b) {
		return a;
	}
	return b;
}

void dfs(int v, long long mint, long long maxt, vector<long long> &c, vector<vector<vector<int>>> &r) {
	c[v] = mint + maxt;

	//vector<vector<vector<int>>> r;

	int len = r[v].size();
	for (int i = 0; i < len; i++) {
		int u = r[v][i][0];
		int t = r[v][i][1];
		if (c[u] == -1) {
			dfs(u, min(mint, t), max(maxt, t), c, r);
		}
	}
}



int main() {

	int n;
	int m;

	cin >> n >> m;

	vector<vector<vector<int>>> r;

	for (int i = 0; i < n; i++) {
		vector<vector<int>> temp;
		r.push_back(temp);
	}

	for (int i = 0; i < m; i++) {
		int u;
		int v;
		int t;
		cin >> u >> v >> t;

		/**if (u<1 || u>n || v<1 || v>n) {
			while (true) {
				int __ = 0;
			}
		}**/

		u--;
		v--;
		vector<int> temp = {};
		temp.push_back(v);
		temp.push_back(t);
		r[u].push_back(temp);
		vector<int> temp2 = {};
		temp2.push_back(u);
		temp2.push_back(t);
		r[v].push_back(temp2);

	}

	if (m == n - 1) {
		vector<long long> c;
		for (int i = 0; i < n; i++) {
			c.push_back(-1);
		}
		dfs(0, 1000000000, 0, c, r);
		for (int i = 1; i < n; i++) {
			cout << c[i] << endl;
		}
	}


}