#include <bits/stdc++.h>
using namespace std;

//#define int long long
#define FF first
#define SS second
#define ALL(a) a.begin(), a.end()
#define RALL(a) ar.begin(), a.rend()
#define mp make_pair
#define pb push_back
#define pf push_front

using ll = long long;
using ld = long double;

const int INFI = 1e9 + 228;
const ll INFL = 1e18 + 228;
const ld INFLD = 1e18 + 228;
const ld PI = acos(-1);
const int MAXN = 3e5 + 228;
vector<pair<int, int> > g[MAXN];
int d[MAXN];
int n, m;
bool used[MAXN];
void dfs(int v, int p) {
    if (v == 1) return;
    used[v] = true;
    for (auto u : g[v]) {
        if (u.FF == p) continue;
        if (!used[u.FF]) dfs(u.FF, v);
        d[v] = min(d[v], max(d[u.FF], u.SS));
    }
}
void dfs2(int v, int now_min, int now_max, int p) {
    d[v] = now_min + now_max;
    for (auto u : g[v]) {
        if (u.FF == p) continue;
        dfs2(u.FF, min(now_min, u.SS), max(now_max, u.SS), v);
    }
}
void solve1() {
    for (int i = 0; i < n; ++i) d[i] = INFI;
    set<pair<int, int> > q;
    q.insert({0, 0});
    while (!q.empty()) {
        int v = (*q.begin()).SS;
        int ras = (*q.begin()).FF;
        q.erase(q.begin());
        for (auto u : g[v]) {
            if (d[u.FF] > max(ras, u.SS)) {
                q.erase({d[u.FF], u.FF});
                d[u.FF] = max(ras, u.SS);
                q.insert({d[u.FF], u.FF});
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << d[i] << "\n";
    return;
}
void solve2() {
    for (int i = 0; i < n; ++i) d[i] = INFI;
    set<pair<int, int> > q;
    q.insert({INFI, 0});
    while (!q.empty()) {
        int v = (*q.begin()).SS;
        int ras = (*q.begin()).FF;
        q.erase(q.begin());
        for (auto u : g[v]) {
            if (d[u.FF] >= min(ras, u.SS)) {
                q.erase({d[u.FF], u.FF});
                d[u.FF] = min(ras, u.SS);
                q.insert({d[u.FF], u.FF});
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << d[i] + 1000000000 << "\n";
    return;
}
pair<int, int> dp[MAXN];
void solve3() {
    dp[0] = {INFI, INFI};
    for (int i = 1; i < n; ++i) {
        dp[i] = {INFI, INFI};
        for (auto u : g[i]) {
            if (u.FF == i - 1) {
                if (u.SS <= dp[i - 1].SS) {
                    if (u.SS < dp[i].FF) dp[i] = {min(u.SS, dp[i].FF), dp[i - 1].SS};
                } else {
                    if (u.SS < dp[i].SS) dp[i] = {dp[i - 1].FF, max(dp[i - 1].SS, u.SS)};
                }
            }
        }
    }
    for (int i = 1; i < n; ++i) cout << dp[i].FF + dp[i].SS << "\n";
}
void solve() {
    dfs2(0, INFI, -INFI, 0);
    for (int i = 1; i < n; ++i) cout << d[i] << "\n";
}
void run() {
    cin >> n >> m;
    bool check3 = true;
    for (int i = 0; i < m; ++i) {
        int u, v, t;
        cin >> u >> v >> t;
        --u;
        --v;
        if (abs(v - u) != 1) check3 = false;
        g[u].pb({v, t});
        g[v].pb({u, t});
    }
    bool check1 = true, check2 = true;
    for (auto u : g[0]) {
        if (u.SS != 0) check1 = false;
        if (u.SS != 1000000000) check2 = false;
    }
    if (check1) solve1();
    else if (check2) solve2();
    else if (check3) solve3();
    else solve();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    //cin >> t;
    t = 1;
    while (t--) run();
    return 0;
}
