#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
    cin >> t;
    range(i, t) {
        solve();
    }
}
ll zn[26];

void fZn() {
    ll ten = 1;
    range(i, 13) {
        zn[2*i] = ten;
        zn[2*i + 1] = ten * 5;
        ten *= 10;
    }
}

const ll minf = -1e18;

const int MAXN = 3e5 + 10;
ll dp[MAXN][26];

void solve() {
    fZn();
    string s; cin >> s;
    int n = s.size();
    range(j, 26) {
        dp[n][j] = 0;
    }
    rrange(i, n) {
        if (s[i] == '?') {
            range(j, 26) {
                if (dp[i + 1][j] == minf) {
                    dp[i][j] = minf;
                    continue;
                }
                dp[i][j] = dp[i + 1][j] + zn[j];
            }
        } else {
            int cc = s[i] - 'A';
            range(j, cc) dp[i][j] = minf;
            dp[i][cc] = dp[i + 1][cc] + zn[cc];
            for (int j = cc + 1; j < 26; ++j) {
                dp[i][j] = max(dp[i][j - 1], dp[i + 1][j] - zn[cc]);
            }
        }
    }
    ll sm = dp[0][25];
    cout << sm << endl;
    range(i, n) {
        if (s[i] == '?') {
            range(j, 26) {
                if (dp[i][j] >= sm) {
                    sm -= zn[j];
                    cout << (char) (j + 'A');
                    break;
                }
            }
        } else {
            cout << s[i];
            int cc = s[i] - 'A';
            if (dp[i][cc] >= sm) {
                sm -= zn[cc];
            } else {
                sm += zn[cc];
            }
        }
    }
    cout << '\n';
    if (sm != 0) {
        cout << "HUI";
    }
//    assert(sm == 0);
}



