#include <iostream>

#include <algorithm>

#include <vector>

using namespace std;

typedef long long ll;

struct p4{
	int a, b, c, d;
	p4() = default;

	p4(int a, int b, int c, int d) :a(a), b(b), c(c), d(d) {}
};

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, m; cin >> n >> m;
	vector<pair<int, int>> ce;
	for (int i = 0; i < m; i++) {
		int v, u; cin >> v >> u;
		v--; u--;

		ce.push_back({ v, u });
	}

	for (int q = 0; q < 1e6; q++) {
		vector<p4> ans;

		vector<pair<int, int>> e = ce;
		random_shuffle(e.begin(), e.end());
		while (true) {
			bool flag = true;
			int a = e[0].first, b = e[0].second;

			for (int j = 1; j < e.size(); j++) {
				int c = e[j].first, d = e[j].second;
				if (b == c || d == a) {
					flag = false;
					ans.push_back({ a,b,c,d });
					e.erase(e.begin() + j);
					e.erase(e.begin());
				}
			}

			if (flag || e.size() == 0)
				break;
		}

		if (e.size() == 0) {
			cout << "Yes\n";
			for (auto c : ans) {
				cout << c.a + 1 << ' ' << c.b + 1 << ' ' << c.c + 1 << ' ' << c.d + 1 << '\n';
			}
			return 0;
		}
	}

	cout << "No";

	return 0;
}