#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#define int long long
using namespace std;

const int INF = 1e18;

int n, m;
vector <vector <pair <int, int>>> g;
vector <int> ans;

signed main() {
	//ios::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v, t; cin >> u >> v >> t; u--, v--;
		g[u].push_back({ v, t });
		g[v].push_back({ u, t });
	}

	ans.resize(n, INF);
	vector <char> used(n, false);
	set <pair <int, int>> q;

	ans[0] = 0;
	q.insert({ 0, 0 });

	while (!q.empty()) {
		auto p = *q.begin(); q.erase(q.begin());
		int val = p.first, u = p.second;
		if (used[u])
			continue;
		used[u] = true;

		for (auto pp : g[u]) {
			int v = pp.first, w = pp.second;
			if (used[v] || w >= ans[v])
				continue;
			q.erase({ ans[v], v });
			ans[v] = w;
			q.insert({ ans[v], v });
		}
	}

	for (int i = 1; i < n; i++) {
		cout << ans[i] << ' ';
	}

	return 0;
}