#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#define _CRT_SECURE_NO_WARNINGS
#define endl '\n'

using namespace std;
using ll = long long;

const int N = 3e5 + 9;

pair<ll, ll> cor0[N];
set<pair<ll, ll>> cor;


bool ban(int l, int r)
{
	bool bol = false;
	vector < pair<ll, ll>> ncor;
	
	auto it = cor.lower_bound(cor0[l]);
	while ((*it) <= cor0[r])
	{
		auto a = *prev(it);
		auto b = *next(it);
		auto x = *it;
		auto nxt = next(it);
		if (x.first - x.second >= a.first)
		{
			cor.erase(it);
			bol = 1;
		}
		else if (x.first + x.second <= b.first)
		{
			cor.erase(it);
			bol = 1;
		}
		it = nxt;
	}
	return bol;
}

signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else 
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; i++)
	{
		cin >> cor0[i].first;
		cin >> cor0[i].second;
	}
	cor0[0].first = cor0[1].first;
	cor0[0].second = -1;
	
	cor0[n + 1].first = cor0[n].first;
	cor0[n + 1].second = 1e18;
	n += 2;
	
	for (int d = 0; d < q; d++)
	{
		int l, r;
		cin >> l >> r;
		for (int i = 0; i < n; i++)
			cor.insert(cor0[i]);

		while (ban(l, r)) {}
		cout << n - cor.size() << endl;
	}
}