#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

#define endl '\n'

const int Base = 3e5 + 10;
const long long inf = 1e18;

struct Edge
{
	int a, b;
	long long t;
	bool used = false;
};

int n, m;
Edge allE[Base];
vector<int> e[Base];
long long ans[Base];
long long step[Base];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	for (int i = 0; i <= n; i++)
	{
		ans[i] = 1e18;
		step[i] = 1e18;
	}

	for (int i = 0; i < m; i++)
	{
		long long a, b, t;
		cin >> a >> b >> t;
		if (a > b)
		{
			swap(a, b);
		}
		if (a + 1 == b)
		{
			step[a] = min(step[a], t);
		}
	}

	long long Min = step[1];
	long long Max = step[1];
	for (int i = 2; i <= n; i++)
	{
		cout << Min + Max << endl;
		Min = min(Min, step[i]);
		Max = max(Max, step[i]);
	}

}