#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 10;
const ll inf = 1e18;

vector <pair <ll, ll>> e[N];
bool used[N];
ll time[N], mintime[N];
ll ans[N];

ll t = 0, n, m;

ll dfs(ll x, ll mi) {
	ll cur = mi;
	used[x] = 1;
	time[x] = t;
	mintime[x] = t++;
	ans[x] = mi;
	for (ll i = 0; i < e[x].size(); i++) {
		ll v = e[x][i].first;
		if (used[v]) {
			mintime[x] = min(mintime[x], time[v]);
			continue;
		}
		ll k = dfs(v, min(mi, e[x][i].second));
		if (mintime[v] <= time[x]) {
			//  
			cur = min(cur, k);
		}
		mintime[x] = min(mintime[x], mintime[v]);
	}
	ans[x] = min(ans[x], cur);
	return cur;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--; b--;
		e[a].push_back(make_pair(b, c));
		e[b].push_back(make_pair(a, c));
	}
	dfs(0, inf);
	for (ll i = 1; i < n; i++) {
		cout << ans[i] + 1000000000 << '\n';
	}
}