#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()

using namespace std;

const int INF = (int) 5e18;

void sol() {
    string s;
    cin >> s;
    map<char, int> d;
    int num = 1;
    for (int i = 0; i < 26; i++) {
        d[i + 'A'] = num;
        if (i % 2 == 0) {
            num *= 5;
        } else {
            num *= 2;
        }
    }
    vector<int> sm(26);
    int n = s.size();
    vector<int> used(n);
    char mx = 'A';
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '?') {
            continue;
        }
        if (s[i] < mx) {
            used[i] = 1;
        }
        mx = max(mx, s[i]);
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans -= d[s[i]];
            continue;
        }
        if (s[i] != '?') {
            ans += d[s[i]];
            sm[s[i] - 'A'] += d[s[i]] * 2;
            continue;
        }
        pair<int, int> best = {-INF, i};
        int now = 0;
        for (int c = 0; c < 26; c++) {
            if (c > 0) {
                now += sm[c - 1];
            }
            best = max(best, {d[c + 'A'] - now, c});
        }
        int c = best.second;
        for (int j = 0; j < c; j++) {
            ans -= sm[j];
            sm[j] = 0;
        }
        ans += d[c + 'A'];
        s[i] = c + 'A';
    }
    cout << ans << '\n';
    cout << s << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        sol();
    }
}
