#include<bits/stdc++.h>

using namespace std;

#define pii pair<int, int>
#define fi first
#define se second
#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define pb push_back

const int N = 300000;
vector<int> g[N];
int vx[N], vy[N], t[N], ans[N], dist[N], T = 0, tin[N], up[N], used[N], ban[N], comp[N];

void dfs(int v) {
    used[v] = 1;
    tin[v] = up[v] = T++;
    for (auto i : g[v]) {
        int x = vx[i] ^ vy[i] ^ v;
        if (used[x]) {
            up[v] = max(up[v], tin[x]);
        }
        else {
            dfs(x);
            up[v] = max(up[v], up[x]);
            if (up[x] > up[v]) {
                ban[i] = 1;
            }
        }
    }
}

int Z;
vector<int> ts;

void dfs2(int v) {
    used[v] = 1;
    ts.pb(v);
    for (auto i : g[v]) {
        int x = vx[i] ^ vy[i] ^ v;
        if (ban[i]) continue;
        Z = min(Z, t[i]);
        if (!used[x]) dfs2(x);
    }
}

set<int> usd;

void dfs3(int v, int c) {
    ans[v] = min(ans[v], c);
    used[v] = 1;
    for (auto i : g[v]) {
        int x = vx[i] ^ vy[i] ^ v;
        if (used[x]) continue;
        if (ban[i]) {
            dfs3(x, min(c, ans[x]));
        }
        else {
            dfs3(x, c);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        cin >> vx[i] >> vy[i] >> t[i];
        vx[i]--, vy[i]--;
        g[vx[i]].pb(i);
        g[vy[i]].pb(i);
    }
    dfs(0);
    fill(ans, ans + n, 1e9);
    fill(used, used + n, 0);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            Z = 1e9;
            ts.clear();
            dfs2(i);
            for (auto v : ts) ans[v] = Z, comp[v] = cnt;
            cnt++;
        }
    }
    usd.insert(0);
    fill(used, used + n, 0);
    dfs3(0, ans[0]);
    for (int i = 1; i < n; i++) cout << ans[i] + (int) 1e9 << '\n';
}
