#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <random>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef vector<ll> vi;
typedef vector<vi> vvi;

const ll mx1 = 26, inff = 2e18;

#define ff first
#define ss second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define vec vector

void run() {
	ll tb[26] = { 0 };
	tb[0] = 1;
	for (ll i = 2; i < 26; i += 2) {
		tb[i] = tb[i - 2] * 10;
	}
	tb[1] = 5;
	for (ll i = 3; i < 26; i += 2) {
		tb[i] = tb[i - 2] * 10;
	}
	map<ll, char> mp1;
	for (ll i = 0; i < 26; ++i) {
		mp1[tb[i]] = char('A' + i);
		mp1[-tb[i]] = char('A' + i);
	}
	string s;
	cin >> s;
	ll n = s.size();
	vvi dp(n + 1, vi(26, -inff));
	vvi pp(n + 1, vi(26, -1));
	dp[n][0] = 0;
	vi pr(26), sf(26);
	for (ll i = n - 1, id, v; i >= 0; i--) {
		if (s[i] != '?') {
			v = s[i] - 'A';
			for (ll j = 0; j < 26; ++j) {
				if (j <= v && dp[i][v] < dp[i + 1][j] + tb[v]) {
					dp[i][v] = dp[i + 1][j] + tb[v];
					pp[i][v] = { j };
				}
				else if (j > v && dp[i][j] < dp[i + 1][j] - tb[v]) {
					dp[i][j] = dp[i + 1][j] - tb[v];
					pp[i][j] = { j };
				}
			}
		}
		else {
			id = 0;
			pr[0] = 0;
			for (ll j = 1; j < 26; ++j) {
				if (dp[i + 1][j] > dp[i + 1][pr[j - 1]])
					pr[j] = j;
				else
					pr[j] = pr[j - 1];
			}
			sf[25] = 25;
			for (ll j = 24; j >= 0; --j) {
				if (dp[i + 1][j] > dp[i + 1][sf[j + 1]])
					sf[j] = j;
				else
					sf[j] = sf[j + 1];
			}
			for (ll j = 0; j < 26; ++j) {
				if (j == 25 || dp[i + 1][pr[j]] + tb[j] > dp[i + 1][sf[j + 1]] - tb[j]) {
					dp[i][j] = dp[i + 1][pr[j]] + tb[j];
					pp[i][j] = { pr[j] };
				}
				else {
					dp[i][sf[j + 1]] = dp[i + 1][sf[j + 1]] - tb[j];
					pp[i][sf[j + 1]] = { sf[j + 1] };
				}
			}
		}
	}
	ll id = 0;
	for (ll j = 0; j < 26; ++j)
		if (dp[0][j] > dp[0][id])
			id = j;
	cout << dp[0][id] << '\n';
	for (ll i = 0, sum = dp[0][id]; i < n; ++i) {
		id = pp[i][id];
		cout << mp1[sum - dp[i + 1][id]];
		sum = dp[i + 1][id];
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll tkk = 1, kk = 0;
	cin >> tkk;
	while (kk++ < tkk) {
		run();
		//cout << '\n';
	}
	return 0;
}

/*
4
BBBC
????
A?B?C?D
YYYYY?
*/