#include <bits/stdc++.h>

#define ll long long
#define int ll
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
#define pb push_back
#define ff first
#define ss second
#define mp make_pair
#define rep(i, n) for(int i = 0; i < (n); ++i)
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)

using namespace std;

void run() {
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n);
    rep(i, n) {
        cin >> x[i] >> h[i];
    }
    vector<int> left(n, 0), right(n, 0);
    rep(i, n) {
        if (x[i] - h[i] < x[0]) left[i]++;
        rep(j, i) {
            int dist = abs(x[i] - x[j]);
            if (dist < h[i]) left[i]++;
        }

        if (x[i] + h[i] < x[n - 1]) right[i]++;
        for (int j = i + 1; j < n; ++j) {
            int dist = abs(x[i] - x[j]);
            if (dist < h[i]) right[i]++;
        }
    }
    rep(qq, q) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        vector<bool> used(n, 0);
        queue<int> q;
        for (int i = l; i <= r; ++i) {
            if (left[i] == 0 || right[i] == 0) {
                q.push(i);
            }
        }
        auto lll = left;
        auto rrr = right;
        int ans = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            if (used[v]) continue;
            used[v] = 1;
            ans++;
            for (int i = l; i <= r; ++i){
                if (used[i]) continue;
                if (i < v) {
                    int dist = abs(x[i] - x[v]);
                    if (dist < h[i]) rrr[i]--;
                } else {
                    int dist = abs(x[i] - x[v]);
                    if (dist < h[i]) lll[i]--;
                }
                if (lll[i] == 0 || rrr[i] == 0) q.push(i);
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
//    files("input.txt", "output.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        run();
    return 0;
}
