#include <iostream>
#include <vector>
using namespace std;

vector <pair<long long, long long>> g;
vector <bool> used;
vector <pair<long long, long long>> ans;

bool gen(long long ind1, long long ind2, long long count)
{
	used[ind1] = true;
	used[ind2] = true;
	count += 2;
	ans.push_back(make_pair(ind1, ind2));
	if (count == used.size())
		return true;
	for (int i = 0; i < g.size(); i++)
	{
		if (!(used[i]))
		{
			for (int j = 0; j < g.size(); j++)
			{
				if (i == j)
					continue;
				if (!(used[j]) && (g[i].first == g[j].second || g[i].second == g[j].first))
				{
					if (gen(i, j, count))
						return true;
				}
			}
		}
	}
	ans.pop_back();
	used[ind1] = false;
	used[ind2] = false;
	return false;
}

int main()
{
	long long n, m;
	cin >> n >> m;
	g.resize(m);
	used.resize(m, false);
	for (int i = 0; i < m; i++)
		cin >> g[i].first >> g[i].second;

	bool flag = true;
	for (int i = 0; i < g.size(); i++)
	{
		for (int j = 0; j < g.size(); j++)
		{
			if (i == j)
				continue;
			if ((g[i].first == g[j].second || g[i].second == g[j].first) && gen(i, j, 0))
			{
				cout << "Yes" << endl;
				for (auto elem : ans)
				{
					//cout << ans.size() << endl;
					cout << g[elem.first].first << ' ' << g[elem.first].second << ' ' << g[elem.second].first << ' ' << g[elem.second].second << endl;
					flag = false;
				}
				break;
			}
		}
		if (!(flag))
			break;
	}
	if (flag)
		cout << "No" << endl;
	return 0;
}