#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>

using namespace std;

#define ll long long
#define S second
#define F first
#define all(x) x.begin(), x.end()

ll a, b, c, d, e;
vector <ll> ar;
vector <vector <pair <ll, ll> > > arr;
vector <ll> vis;
vector <ll> ans, cnm;

void dfs(ll v, ll mn, ll mx)
{
    ans[v] = mn + mx;
    vis[v] = 1;
    for (auto v1 : arr[v])
        if (!vis[v1.F])
            dfs(v1.F, min(mn, v1.S), max(mx, v1.S));
    return;
}

bool comp(pair <pair <ll, ll>, ll> p, pair <pair <ll, ll>, ll> p1)
{
    return p.S > p1.S;
}

ll get_root(ll v)
{
    if (cnm[v] == v)
        return v;
    ll v1 = get_root(cnm[v]);
    cnm[v] = v1;
    return v1;
}

void un(ll v, ll v1)
{
    ll rt = get_root(v);
    ll rt1 = get_root(v1);
    cnm[rt] = rt1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> b;
    vis.resize(a);
    cnm.resize(a);
    for (ll i = 0; i < a; ++i)
        cnm[i] = i;
    ans.resize(a, -1);
    ans[0] = 0;
    arr.resize(a);
    vector <pair <pair <ll, ll>, ll > > edges;
    for (ll i = 0; i < b; ++i)
    {
         ll p, p1, w;
         cin >> p >> p1 >> w;
         --p, --p1;
         edges.push_back({{p, p1}, w});
    }
    sort(all(edges), comp);
    for (ll i = 0; i < edges.size(); ++i)
    {
        if (get_root(edges[i].F.F) == get_root(edges[i].F.S))
            continue;
        un(edges[i].F.F, edges[i].F.S);
        arr[edges[i].F.F].push_back({edges[i].F.S, edges[i].S});
        arr[edges[i].F.S].push_back({edges[i].F.F, edges[i].S});
    }
    dfs(0, 1e9, 0);
    for (ll i = 1; i < a; ++i)
        cout << ans[i] << '\n';
}
