#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/stack:2000000000")
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <set>
#include <numeric>

using namespace std;

const long long INFL = 1000000000000000009ll;
const int SIZE = 150010;

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int n, q;
	cin >> n >> q;
	vector <int> x(n);
	vector <int> h(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> x[i] >> h[i];
	}

	while (q--)
	{
		int l, r;
		cin >> l >> r;
		l--;
		vector <int> last(n);
		iota(last.begin(), last.end(), -1);
		int ans = 0;
		for (int i = l; i < r; ++i)
		{
			bool changed = true;
			while (changed && last[i] >= l)
			{
				changed = false;
				//cout << last[i] << '\n';
				if (x[n - 1] - x[last[i]] >= h[last[i]])
				{
					if (h[last[i]] <= x[i] - x[last[i]])
					{
						changed = true;
						ans++;
						last[i] = last[last[i]];
					}
				}
			}
			bool dead = false;
			if (x[i] - x[0] >= h[i])
			{
				if (i != 0)
				{
					if (last[i] < 0 || h[i] <= x[i] - x[last[i]])
					{
						dead = true;
					}
				}
			}
			if (x[n - 1] - x[i] >= h[i])
			{
				if (i + 1 >= n || h[i] <= x[i + 1] - x[i])
				{
					dead = true;
				}
			}
			if (dead)
			{
				ans++;
				int la = last[i];
				if (i + 1 < n)
				{
					last[i + 1] = la;
				}
			}
			/*
			for (int j = 0; j < n; ++j)
			{
				cout << last[j] << ' ';
			}
			cout << '\n';*/
			changed = true;
			while (changed && last[i] >= l)
			{
				changed = false;
				//cout << last[i] << '\n';
				if (x[n - 1] - x[last[i]] >= h[last[i]])
				{
					if (i + 1 >= n || h[last[i]] <= x[i + 1] - x[last[i]])
					{
						changed = true;
						ans++;
						if (i + 1 < n)
						{
							last[i + 1] = last[last[i]];
						}
						last[i] = last[last[i]];
					}
				}
			}
		}
		cout << ans << '\n';
	}

	return 0;
}