#include <iostream>
#include <vector>

using namespace std;

#define int long long

int cost(char x) {
    int id = x - 'A';
    if (id == 0) {
        return 1;
    } else {
        int gg = 1;
        for (int i = 0; i < (id - 1) / 2; ++i) {
            gg *= 10;
        }
        if (id % 2 == 1) {
            return 5 * gg;
        }
        return 10 * gg;
    }
}

void solve() {
    string s;
    cin >> s;
    const int n = s.size();
    int dp[n + 1][27];
    pair<int, int> pr[n + 1][27];
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= 26; ++j) {
            dp[i][j] = -1e18;
            pr[i][j] = { -1, -1 };
        }
    }
    dp[n][0] = 0;
    for (int i = n; i > 0; --i) {
        for (int j = 0; j <= 26; ++j) {
            char x = s[i - 1];
            if (x != '?') {
                int curr = x - 'A' + 1;
                int fine = 0;
                if (curr < j) {
                    fine -= cost(x);
                } else {
                    fine += cost(x);
                }
                dp[i - 1][max(j, curr)] = max(dp[i - 1][max(j, curr)], dp[i][j] + fine);
                if (dp[i - 1][max(j, curr)] == dp[i][j] + fine) {
                    pr[i - 1][max(j, curr)] = { curr, j };
                }
            } else {
                for (int c = 0; c < 26; ++c) {
                    int curr = c + 1;
                    char x = char('A' + c);
                    int fine = 0;
                    if (curr < j) {
                        fine -= cost(x);
                    } else {
                        fine += cost(x);
                    }
                    dp[i - 1][max(j, curr)] = max(dp[i - 1][max(j, curr)], dp[i][j] + fine);
                    if (dp[i - 1][max(j, curr)] == dp[i][j] + fine) {
                        pr[i - 1][max(j, curr)] = { curr, j };
                    }
                }
            }
        }
    }
    int res = -1e18;
    int ptr1 = -1;
    for (int i = 0; i <= 26; ++i) {
        res = max(res, dp[0][i]);
        if (res == dp[0][i]) {
            ptr1 = i;
        }
    }
    cout << res << '\n';
    string res1;
    int ptr = 0;
    while (ptr < n) {
        res1 += char('A' + pr[ptr][ptr1].first - 1);
        ptr1 = pr[ptr][ptr1].second;
        ++ptr;
    }
    cout << res1 << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
   int t;
   cin >> t;
   while (t--) {
       solve();
   }
    return 0;
}
