#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define int long long
const int MAX = 400000;
const int INF = 1e18;
int n, m;
int a, b, vol;
int used[MAX], dep[MAX], down[MAX], mst[MAX], elem[MAX];
int used2[MAX], mi[MAX], co[MAX], ans[MAX], real_ans[MAX], pred[MAX];
vector<pair<int, int>> all_edges;
vector<pair<pair<int, int>, pair<int, int>>> sort_edges;
vector<pair<int, int>> edges[MAX], edges2[MAX];
bool in[MAX];
void dfs(int v, int pred, int ma) {
	ans[v] = ma;
	for (auto i : edges[v]) {
		if (i.first != pred) {
			dfs(i.first, v, max(ma, i.second));
		}
	}
}
int root(int v) {
	if (pred[v] == v) {
		return v;
	}
	pred[v] = root(pred[v]);
	return pred[v];
}
signed main() {
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		cin >> a >> b >> vol;
		a--;
		b--;
		sort_edges.push_back({ {vol, i}, {a, b} });
		all_edges.push_back({ a, b });
		in[i] = false;
		pred[a] = a;
		pred[b] = b;
	}
	sort(sort_edges.begin(), sort_edges.end());
	for (auto i2 : sort_edges) {
		if (root(i2.second.first) != root(i2.second.second)) {
			edges[i2.second.first].push_back({ i2.second.second, i2.first.first });
			edges[i2.second.second].push_back({ i2.second.first, i2.first.first });
			pred[i2.second.second] = i2.second.first;
		}
	}
	dfs(0, -1, 0);
	for (int i = 1; i < n; i++) {
		cout << ans[i] << endl;
	}
	return 0;
}