#define ll long long

#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

vector<pair<pair<ll, ll>, pair<ll,ll>>> ans;
map<pair<ll, ll>, bool> mp;
bool flg = 1;

void rec(vector<vector<ll>> &gr, vector<ll> &balance, vector<vector<ll>> &down,
		 vector<vector<ll>> &up, vector<bool> &used, ll v, ll pred) {
	used[v] = 1;
	for (int i = 0; i < gr[v].size(); i++) {
		if (!used[gr[v][i]]) {
			auto u = gr[v][i];
			rec(gr, balance, down, up, used, gr[v][i], v);
			if (flg == 0) {
				return;
			}
			ll p = 0;
			if (mp.find({ u, v }) != mp.end()) {
				p++;
			}
			if (mp.find({ v, u }) != mp.end()) {
				p--;
			}
			if (balance[u] == 0) {
				if (p == 0) {
					ans.push_back({ {v, u}, {u, v} });
				}
				if (p == -1) {
					down[v].push_back(u);
				}
				if (p == 1) {
					up[v].push_back(u);
				}
			}
			else if (balance[u] == 1) {
				if (p == 0) {
					ll z = up[u].back();
					up[u].pop_back();
					ans.push_back({ {z, u}, {u, v} });
					balance[v]--;
					down[v].push_back(u);
				}
				if (p == -1) {
					flg = 0;
					return;
				}
				if (p == 1) {
					ll z = up[u].back();
					up[u].pop_back();
					ans.push_back({ {z, u}, {u, v} });
				}
			}
			else {
				if (p == 0) {
					ll z = down[u].back();
					down[u].pop_back();
					ans.push_back({ {v, u}, {u, z} });
					balance[v]++;
					up[v].push_back(u);
				}
				if (p == -1) {
					ll z = down[u].back();
					down[u].pop_back();
					ans.push_back({ {v, u}, {u, z} });
				}
				if (p == 1) {
					flg = 0;
					break;
				}
			}
		}
	}
	while (up[v].size() && down[v].size()) {
		ll d = down[v].back();
		ll u = up[v].back();
		down[v].pop_back();
		up[v].pop_back();
		ans.push_back({ {u, v}, {v, d} });
	}
	if (abs(int((int)up[v].size() - (int)down[v].size())) > 1) {
		flg = 0;
		return;
	}
	balance[v] = (int)up[v].size() - (int)down[v].size();
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, m;
	cin >> n >> m;
	vector<ll> tin(n, 0);
	vector<ll> tout(n, 0);
	vector<vector<ll>> gr(n);
	vector<ll> d(n);

	for (int i = 0; i < m; i++) {
		ll l, r;
		cin >> l >> r;
		l--; r--;
		mp[{ l, r }] = 1;
		if (mp.find({ r, l }) == mp.end()) {
			gr[l].push_back(r);
			gr[r].push_back(l);
		}
	}
	vector<ll> balance(n, 0);
	vector<vector<ll>> up(n), down(n);
	vector<bool> used(n, 0);
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			rec(gr, balance, down, up, used, i, -1);
			if (balance[i] != 0) {
				flg = 0;
				break;
			}
		}
	}
	if (!flg) {
		cout << "No";
	}
	else {
		cout << "Yes\n";
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i].first.first + 1 << " " << ans[i].first.second + 1 << " "
				<< ans[i].second.first + 1 << " " << ans[i].second.second + 1 << "\n";
		}
	}
}

/*
8 10
1 2
2 3
3 4
4 3
5 2
5 6
6 5
1 7
7 1
7 8
*/