#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

template<typename A, typename B>
inline bool setmax(A &a, B b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const ll INF = 4e18;

vec<ll> c;

inline void solve() {
	string s;
	cin >> s;
	int n = len(s);
	vec<vec<ll>> dp(n, vec<ll>(26, -INF));
	vec<vec<int>> par(n, vec<int>(26, -1));
	if (s.back() == '?') {
		for (int i = 0; i < 26; i++) {
			dp.back()[i] = c[i];
		}
	} else {
		dp.back()[s.back() - 'A'] = c[s.back() - 'A'];
	}
	vec<pair<ll, int>> pref_max(27);
	for (int i = n - 2; i >= 0; i--) {
		pref_max[0].first = -INF;
		for (int j = 0; j < 26; j++) {
			pref_max[j + 1] = max(pref_max[j], pair<ll, int>{dp[i + 1][j], j});
		}
		if (s[i] == '?') {
			for (int cur = 0; cur < 26; cur++) {
				if (pref_max[cur + 1].first != -INF && setmax(dp[i][cur], pref_max[cur + 1].first + c[cur])) {
					par[i][cur] = pref_max[cur + 1].second;
				}
			}
		} else {
			for (int prev = 0; prev < 26; prev++) {
				if (dp[i + 1][prev] == -INF) {
					continue;
				}
				if (prev > s[i] - 'A') {
					if (setmax(dp[i][prev], dp[i + 1][prev] - c[s[i] - 'A'])) {
						par[i][prev] = prev;
					}
				} else {
					if (setmax(dp[i][s[i] - 'A'], dp[i + 1][prev] + c[s[i] - 'A'])) {
						par[i][s[i] - 'A'] = prev;
					}
				}
			}
		}
	}
	int where_max = max_element(all(dp[0])) - dp[0].begin();
	cout << dp[0][where_max] << '\n';
	for (int cur = where_max, i = 0; i < n; i++) {
		if (s[i] == '?') {
			cout << char('A' + cur);
		} else {
			cout << s[i];
		}
		cur = par[i][cur];
	}
	cout << '\n';
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	c.push_back(1);
	for (int i = 1; i < 26; i++) {
		if (i % 2) {
			c.push_back(c.back() * 5);
		} else {
			c.push_back(c.back() * 2);
		}
	}
	int t;
	cin >> t;
	while (t--) {
		solve();
	}	
}
