#include <bits/stdc++.h>

#define eb emplace_back
#define x first
#define y second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair<int, int> pt;

const int MAXN = 300103;
const int INF = 1e9 + 54;
int n, m;
int t[MAXN];
vector<pt> g[MAXN];

void read(){
    cin >> n >> m;
    for (int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b >> t[i];
        a--, b--;
        g[a].eb(b, i);
        g[b].eb(a, i);
    }
}

int mx[MAXN];
int mn[MAXN];
void dfs2(int v, int p){
    for (auto j : g[v]){
        int i = j.x;
        if (i == p) continue;
        mx[i] = max(mx[v], t[j.y]);
        mn[i] = min(mn[v], t[j.y]);
        dfs2(i, v);
    }
}

int test(int x, int pos){
    return (x >> pos) & 1;
}
int ans[MAXN];
int msk = 0;
int used[MAXN];

void dfs(int v, int p){
    used[v] = 1;
    for (auto j : g[v]){
        if (!test(msk, j.y)) continue;
        int i = j.x;
        if (i == p || used[i]) continue;
        mx[i] = max(mx[v], t[j.y]);
        mn[i] = min(mn[v], t[j.y]);
        dfs(i, v);
    }
}

void solve(){
    read();
    for (int i = 0; i < n; i++) ans[i] = INF;
    for (; msk < (1 << m); msk++){
        for (int i = 0; i < n; i++){
            mx[i] = -INF;
            mn[i] = INF;
        }
        memset(used, 0, sizeof used);
        dfs(0, -1);
        for (int i = 1; i < n; i++){
            if (mx[i] < 0) mx[i] = INF;
            ans[i] = min(ans[i], mx[i] + mn[i]);
        }
    }

    for (int i = 1; i < n; i++){
        cout << ans[i] << '\n';
    }
}

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
 */

