#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> values = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000,
                      50000000, 100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000,
                      500000000000, 1000000000000, 5000000000000};

int compute(const vector<int> &a) {
    int mx = -1;
    int res = 0;
    int n = a.size();
    for (int i = n - 1; i >= 0; --i) {
        mx = max(mx, a[i]);
        if (mx > a[i]) {
            res -= values[a[i]];
        } else {
            res += values[a[i]];
        }
    }

    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    assert(values.size() == (int) ('Z' - 'A' + 1));


    int tests;
    cin >> tests;


    for (int test = 0; test < tests; ++test) {
        string s;
        cin >> s;
        vector<int> a;
        int lst_q = -1;
        int n = s.size();

        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                a.push_back(-1);
                lst_q = i;
            } else {
                a.push_back(s[i] - 'A');
            }
        }
        vector<int> res;
        int res_value = INT64_MIN;
        if (lst_q == -1) {
            res = a;
            res_value = compute(res);
        } else {
            for (int lst_n = 0; lst_n < values.size(); ++lst_n) {
                vector<int> b = a;
                b[lst_q] = lst_n;
                int mx = -1;
                for (int i = n - 1; i >= 0; --i) {
                    if (b[i] != -1) {
                        mx = max(mx, b[i]);
                    } else {
                        b[i] = mx;
                    }
                }

                int b_value = compute(b);
                if (b_value > res_value) {
                    res_value = b_value;
                    res = b;
                }
            }
        }

        cout << res_value << '\n';
        for (auto e : res) {
            assert(e >= 0);
            cout << (char) ('A' + e);
        }
        cout << '\n';

    }
}
