#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> values = {1, 5, 10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 500000, 1000000, 5000000, 10000000,
                      50000000, 100000000, 500000000, 1000000000, 5000000000, 10000000000, 50000000000, 100000000000,
                      500000000000, 1000000000000, 5000000000000};

int compute(const vector<int> &a) {
    int mx = -1;
    int res = 0;
    int n = a.size();
    for (int i = n - 1; i >= 0; --i) {
        mx = max(mx, a[i]);
        if (mx > a[i]) {
            res -= values[a[i]];
        } else {
            res += values[a[i]];
        }
    }

    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();

    assert(values.size() == (int) ('Z' - 'A' + 1));


    int tests;
    cin >> tests;


    for (int test = 0; test < tests; ++test) {
        string s;
        cin >> s;
        vector<int> a;
        int lst_q = -1;
        int frst_q = -1;
        int n = s.size();
        vector<int> qs;;

        for (int i = 0; i < n; ++i) {
            if (s[i] == '?') {
                a.push_back(-1);
                if (frst_q == -1) {
                    frst_q = i;
                }
                lst_q = i;
                qs.push_back(i);
            } else {
                a.push_back(s[i] - 'A');
            }
        }
        vector<int> res;
        int res_value = INT64_MIN;
        if (lst_q == -1) {
            res = a;
            res_value = compute(res);
        } else {
            int mx = 0;
            vector<int> mxes(n);

            for (int i = n - 1; i >= 0; --i) {
                if (a[i] != -1) {
                    mx = max(mx, a[i]);
                }
                mxes[i] = mx;
            }

            int dp[n][26];
            int nxt[n][26];
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < 26; ++j) {
                    dp[i][j] = INT64_MIN;
                    nxt[i][j] = -1;
                }
            }

            for (int i = n - 1; i >= 0; --i) {
                for (int j = 0; j < mxes[i]; ++j) {
                    nxt[i][j] = -1;
                }

                if (a[i] != -1) {
                    if (i == n - 1) {
                        for (int num = mxes[i + 1]; num < 26; ++num) {
                            nxt[i][num] = -1;
                        }
                        nxt[i][a[i]] = -2;
                        dp[i][a[i]] = values[a[i]];
                    } else {
                        for (int j = 0; j < 26; ++j) {
                            if (nxt[i + 1][j] == -1) {
                                nxt[i][j] = -1;
                                continue;
                            }
                            dp[i][j] = INT64_MIN;
                            nxt[i][j] = -1;
                            if (a[i] >= j) {
                                if (a[i] > j) {
                                    nxt[i][j] = -1;
                                }
                                if (nxt[i + 1][j] != -1 && dp[i][a[i]] < dp[i + 1][j] + values[a[i]]) {
                                    dp[i][a[i]] = dp[i + 1][j] + values[a[i]];
                                    nxt[i][a[i]] = j;
                                }
                            }
                            if (a[i] < j) {
                                if (dp[i][j] < dp[i + 1][j] - values[a[i]]) {
                                    dp[i][j] = dp[i + 1][j] - values[a[i]];
                                    nxt[i][j] = j;
                                }
                            }
                        }
                    }
                    continue;
                }
//                cerr << mxes[i] << endl;

                for (int j = mxes[i]; j < 26; ++j) {
                    if (i == n - 1) {
                        dp[i][j] = values[j];
                        nxt[i][j] = -2;
                    } else {
                        for (int k = 0; k <= j; ++k) {
//                            if (nxt[i + 1][k] != -1) {
//                                cerr << i << ' ' << j << ' ' << k << ' ' << dp[i + 1][k] + values[j] << endl;
//                            }
                            if (nxt[i + 1][k] != -1 && dp[i + 1][k] + values[j] > dp[i][j]) {
                                dp[i][j] = values[j] + dp[i + 1][k];
                                nxt[i][j] = k;
                            }
//                            cerr << nxt[i][j] << endl;
                        }
                    }
                }
            }
//            for (int i = 0; i < 26; ++i) {
//                cerr << dp[n - 1][i] << ' ' << nxt[n - 1][i] << endl;
//            }

            int pos_x = 0;
            int pos_y = 25;
            for (int i = 0; i < 26; ++i) {
                if (nxt[0][i] != -1 && dp[0][i] > dp[0][pos_y]) {
                    pos_y = i;
                }
            }

            for (int i = 0; i < n; ++i) {
                if (a[i] == -1) {
                    a[i] = pos_y;
                }
                pos_y = nxt[i][pos_y];
//                cerr << pos_y << endl;

                assert(pos_y != -1);
            }
            assert(pos_y == -2);

            res = a;
            res_value = compute(res);
        }


        cout << res_value << '\n';
        for (auto e : res) {
            assert(e >= 0);
            assert(e + 'A' <= 'Z');
            cout << (char) ('A' + e);
        }
        cout << '\n';

    }
}