#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const ll INF = 1e18;
const int N = 3e5 + 5;

ll value[26];
int suff[N][26];

ll get_cost(string s) {
    for (int i = 0; i < 26; ++i) suff[sz(s) - 1][i] = 0;
    for (int i = sz(s) - 1; ~i; --i) {
        if (i < sz(s) - 1) {
            for (int j = 0; j < 26; ++j) suff[i][j] = suff[i + 1][j];
        }
        if (s[i] != '?') suff[i][s[i] - 'A']++;
    }
    ll ans = 0;
    for (int i = 0; i < sz(s); ++i) if (s[i] != '?') {
        bool have_greater = false;
        for (int j = s[i] - 'A' + 1; j < 26; ++j) {
            have_greater |= (suff[i][j] > 0);
        }
        if (have_greater) ans -= value[s[i] - 'A'];
        else ans += value[s[i] - 'A'];
    }
    return ans;
}

int pref[N][26];

int get(int L, int R, int x) {
    if (L == 0) return pref[R][x];
    return pref[R][x] - pref[L - 1][x];
}

ll dp[N][26];
int from[N][26];

void solve() {
    string s;
    cin >> s;
    int n = sz(s);
    for (int i = 0; i < 26; ++i) suff[n - 1][i] = 0;
    for (int i = n - 1; ~i; --i) {
        if (i < n - 1) for (int j = 0; j < 26; ++j) suff[i][j] = suff[i + 1][j];
        if (s[i] != '?') suff[i][s[i] - 'A']++;
    }
    for (int i = 0; i < 26; ++i) pref[0][i] = 0;
    for (int i = 0; i < sz(s); ++i) {
        if (i) for (int j = 0; j < 26; ++j) pref[i][j] = pref[i - 1][j];
        if (s[i] != '?') {
            bool have_greater = false;
            for (int j = s[i] - 'A' + 1; j < 26; ++j) {
                have_greater |= (suff[i][j] > 0);
            }
            if (!have_greater) pref[i][s[i] - 'A']++;
        }
    }
    vector<int> ques;
    for (int i = 0; i < sz(s); ++i) if (s[i] == '?') {
        ques.eb(i);
    }
    int k = sz(ques);
    if (!k) {
        cout << get_cost(s) << "\n" << s << "\n";
        return;
    }
    for (int i = 1; i < k; ++i) for (int j = 0; j < 26; ++j) dp[i][j] = -INF;
    dp[0][0] = 0;
    for (int i = 1; i < 26; ++i) {
        dp[0][i] = 0;
        for (int x = 0; x < i; ++x) {
            dp[0][i] -= 1ll * pref[ques[0]][x] * value[x];
        }
        bool have_greater = false;
        for (int x = i + 1; x < 26; ++x) {
            have_greater |= (suff[ques[0]][x] > 0);
        }
        if (have_greater) dp[0][i] -= value[i];
        else dp[0][i] += value[i];
    }
    for (int i = 0; i < k - 1; ++i) {
        int pr = ques[i], pos = ques[i + 1];
        for (int j = 0; j < 26; ++j) {
            for (int x = 0; x <= j; ++x) {
                bool have_greater = false;
                for (int y = x + 1; y < 26; ++y) {
                    have_greater |= (suff[pos][y] > 0);
                }
                ll curr = 0;
                if (have_greater) curr -= value[x];
                else curr += value[x];
                for (int y = 0; y < x; ++y) {
                    curr -= 1ll * get(pr, pos, y) * value[y];
                }
                dp[i + 1][x] = max(dp[i + 1][x], dp[i][j] + curr);
                if (dp[i + 1][x] == dp[i][j] + curr) {
                    from[i + 1][x] = j;
                }
            }
        }
    }
    pair<ll, int> mx = mp(-INF, -1);
    for (int x = 0; x < 26; ++x) mx = max(mx, mp(dp[k - 1][x], x));
    int x = mx.se;
    for (int i = k - 1; ~i; --i) {
        s[ques[i]] = char('A' + x);
        x = from[i][x];
    }
    cout << get_cost(s) << "\n" << s << "\n";
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    value[0] = 1;
    for (int i = 1; i < 26; ++i) {
        if (i & 1) value[i] = value[i - 1] * 5;
        else value[i] = value[i - 1] * 2;
    }
    int T;
    cin >> T;
    while (T--) solve();
    return 0;
}
