#include <vector>
#include <algorithm>
#include <iostream>
#include <set>

using namespace  std;

#define int long long
const int INF = 1e12;
vector<vector<pair<int, int>>> g, lst;
vector<int> ans;
int n, m;
int mn = 0;

void djk(int a, int b){
    vector<int> d1(n, INF);
    d1[a] = 0;
    set<pair<int, int>> q;
    q.insert({0, a});
    while (!q.empty()){
        pair<int, int> x= *q.begin();
        q.erase(q.begin());
        int v =x.second, ln = x.first;
        for (pair<int, int> to : lst[v]){
            if (d1[to.first] > max(ln, to.second)){
                if (d1[to.first] != INF){
                    q.erase({d1[to.first], to.first});
                }
                d1[to.first] = max(ln, to.second);
                q.insert({d1[to.first], to.first});
            }
        }
    }
    vector<int> d2(n, INF);
    d2[b] = 0;
    q.insert({0, b});
    while (!q.empty()){
        pair<int, int> x= *q.begin();
        q.erase(q.begin());
        int v =x.second, ln = x.first;
        for (pair<int, int> to : lst[v]){
            if (d2[to.first] > max(ln, to.second)){
                if (d2[to.first] != INF){
                    q.erase({d2[to.first], to.first});
                }
                d2[to.first] = max(ln, to.second);
                q.insert({d2[to.first], to.first});
            }
        }
    }
    for (int i = 1; i < n; i++){
        ans[i] = min(ans[i], mn + max(mn, min(max(d1[0], d2[i]), max(d1[i], d2[0]))));
    }
//    cerr << mn << '\n';
//    for (int i =0; i < n; i++){
//        cerr << d1[i] << " ";
//    }
//    cerr << '\n';
//    for (int i =0; i < n; i++){
//        cerr << d2[i] << " ";
//    }
//    cerr << '\n';
//    for (int i =0; i < n; i++){
//        cerr << ans[i] << " ";
//    }
//    cerr << '\n';

}
signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    g.assign(n, {});
    lst.assign(n, {});
    vector<pair<int, pair<int ,int>>> edg;
    for (int i = 0; i < m; i++){
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        edg.push_back({c, {a, b}});
    }
    sort(edg.begin(), edg.end());
    reverse(edg.begin(), edg.end());
    ans.assign(n, INF);
    for (int i =0; i < edg.size(); i++){
        mn = edg[i].first;
        int a = edg[i].second.second, b =edg[i].second.first;
        lst[a].push_back({b, INF});
        lst[b].push_back({a, INF});
        djk(a, b);
        lst[a].back().second = mn;
        lst[b].back().second = mn;
    }
    for (int i = 1; i < n ;i++){
        cout << ans[i] << '\n';
    }
}
/*
7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
 */