#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

#define int long long

vector<int> nums(26);

void solve() {
	string s;
	cin >> s;
	reverse(all(s));
	int n = s.length();
	vector<vector<int>> dp(n + 1, vector<int>(27, -1e18));
	vector<vector<pair<char, short>>> p(n + 1, vector<pair<char, short>>(27, mp(-1, -1)));
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < 27; ++j)
			if (s[i] == '?')
				for (int u = 0; u < 26; ++u)
					if (u < j) {
						if (dp[i + 1][j] < dp[i][j] - nums[u]) {
							dp[i + 1][j] = dp[i][j] - nums[u];
							p[i + 1][j] = mp(u, j);
						}
					}
					else {
						if (dp[i + 1][u] < dp[i][j] + nums[u]) {
							dp[i + 1][u] = dp[i][j] + nums[u];
							p[i + 1][u] = mp(u, j);
						}
					}
			else
				if (s[i] - 'A' < j) {
					if (dp[i + 1][j] < dp[i][j] - nums[s[i] - 'A']) {
						dp[i + 1][j] = dp[i][j] - nums[s[i] - 'A'];
						p[i + 1][j] = mp(s[i] - 'A', j);
					}
				}
				else {
					if (dp[i + 1][s[i] - 'A'] < dp[i][j] + nums[s[i] - 'A']) {
						dp[i + 1][s[i] - 'A'] = dp[i][j] + nums[s[i] - 'A'];
						p[i + 1][s[i] - 'A'] = mp(s[i] - 'A', j);
					}
				}
	int ans = -1e18;
	string ans1;
	int j = -1;
	for (int i = 0; i < 27; i++)
		if (ans < dp[n][i]) {
			ans = dp[n][i];
			j = i;
		}
	for (int i = 0; i < n; i++) {
		ans1.push_back(p[n - i][j].ft + 'A');
		j = p[n - i][j].sd;
	}
	cout << ans << '\n' << ans1 << '\n';
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);

	int cur = 1;
	for (char i = 0; i <= 'Z' - 'A'; i++) {
		nums[i] = cur;
		if (i % 2)
			cur *= 2;
		else
			cur *= 5;
	}

	int t = 1;
    cin >> t;
	while (t--)
		solve();
}