#include <bits/stdc++.h>

#define F first
#define S second
#define vec vector
#define pb push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
#define all(m) m.begin(), m.end()
#define init(m, x) memset(m, x, sizeof(m))
#define fast cin.tie(0);cout.tie(0);cin.sync_with_stdio(0);cout.sync_with_stdio(0);
using namespace std;
typedef string str;
typedef long long ll;

struct edge{
    int to, c, isb = 0;

    edge(){}

    edge(int b, int C, int d){
        to = b, c = C, isb = d;
    }
};

const int G = 3e5+5;  //!!!!!!!!!!
int a, k;
vec<edge> l[G];
int GANS[G];
set<pii> s;

void gfs(int v, int p, int mn, int mx){
    GANS[v] = mn+mx;
    for(edge h : l[v]){
        if(h.to!=p) gfs(h.to, v, min(mn, h.c), max(mx, h.c));
    }
}
void govno(){
    gfs(0, -1, 1<<30, -(1<<30));
    for(int q=1; q<a; q++) cout<<GANS[q]<<"\n";
    exit(0);
}

int tin[G], fup[G], us[G], T = 0;
int cl[G], sz = 0;
vec<pii> g[G];
int mxe[G];
void dfs(int v, int p){
    us[v] = 1;
    tin[v] = fup[v] = T++;
    int cntp = 0;
    for(edge h : l[v]){
        if(h.to==p) {
            cntp++;
            if(cntp==1) continue;
        }
        if(!us[h.to]){
            dfs(h.to, v);
            fup[v] = min(fup[v], fup[h.to]);
            if(fup[h.to]>tin[v]){
                s.insert({v, h.to});
                s.insert({h.to, v});
            }
        }
        else fup[v] = min(fup[v], tin[h.to]);
    }
}

void cfs(int v, int c){
    cl[v] = c;
    for(edge h : l[v]){
        if(cl[h.to]==c || h.isb) continue;
        cfs(h.to, c);
    }
}

void gofs(int v, int p, int mx){
    mx = max(mx, mxe[v]);
    GANS[v] = mx;
    for(pii h : g[v]){
        if(h.F==p) continue;
        gofs(h.F, v, max(mx, h.S));
    }
}

void g2(){
    int fl = 1;
    for(edge h : l[0]) fl &= h.c==0;
    if(!fl) return;
    init(us, 0);
    dfs(0, -1);
    for(int q=0; q<a; q++){
        for(edge &h : l[q]){
            if(s.count({q, h.to})) h.isb = 1;
        }
    }
    init(cl, -1);
    for(int q=0; q<a; q++){
        if(cl[q]!=-1) continue;
        cfs(q, sz++);
    }
    init(mxe, 0);
    for(int q=0; q<a; q++){
        for(edge h : l[q]){
            if(!h.isb){
                mxe[cl[q]] = max(mxe[cl[q]], h.c);
            }
            else g[cl[q]].pb({cl[h.to], h.c});
        }
    }
    for(int q=0; q<sz; q++){
        sort(all(g[q]));
        vec<pii> nw;
        for(; g[q].size();){
            nw.pb(g[q].back());
            int v = g[q].back().F, rem = 0;
            for(; g[q].size() && g[q].back().F==v;) {
                g[q].pop_back();
                rem++;
            }
            assert(rem==1);
        }
        g[q] = nw;
    }
    gofs(cl[0], -1, 0);
    for(int q=1; q<a; q++) cout<<GANS[cl[q]]<<"\n";
}

int main() {
    fast;
    cin>>a>>k;
    for(int q=0; q<k; q++){
        int x, y, c; cin>>x>>y>>c; x--, y--;
        l[x].pb({y, c, 0});
        l[y].pb({x, c, 0});
    }
    //if(k==a-1) govno();
    g2();
    assert(0);
}
