#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
using namespace  std;

set<int> g[150 * 1001];
set<int> gr[150 * 1001];
set<int> grr[150 * 1001];

int bad[150 * 1001];
int parent[1500 * 1001];

int cntt = 0;
void dfs(int v, int p) {
    cntt++;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
}

bool del(int v, int u) {
    if (g[v].find(u) == g[v].end()) {
        return false;
    }
    g[v].erase(u);
    return true;
}


bool good(int j) {
    if (grr[j].size() == 1 && gr[j].size() == 1 && *grr[j].begin() == *gr[j].begin()) {
        return true;
    }
    if (grr[j].size() == 1 && gr[j].size() == 0) {
        return true;
    }
    if (gr[j].size() == 1 && grr[j].size() == 0) {
        return true;
    }
    return false;
}

int main() {
   int n, m;
   cin >> n >> m;
   vector<pair<pair<int, int>, pair<int, int>>> ans;
   for (int i = 0; i < m; i++) {
       int a, b;
       cin >> a >> b;
       g[a].insert(b);
       g[b].insert(a);
       gr[a].insert(b);
       grr[b].insert(a);
   }
   dfs(1, -1);
   if (cntt != n && n > 20) {
       return 1303;
   }
   set<int> god;
   for (int i = 1; i <= n; i++) {
       if (good(i)) {
           god.insert(i);
       }
   }
   for (int i = 0; i < m / 2; i++) {
       if (god.size() == 0) {
           if (ans.size() == m / 2) {
               break;
           }
           else {
               return 1303;
           }
       }
       int j = *god.begin();
       if (grr[j].size() == 1 && gr[j].size() == 1 && *grr[j].begin() == *gr[j].begin()) {
           int par = *grr[j].begin();
           grr[par].erase(j);
           grr[j].erase(par);
           gr[par].erase(j);
           gr[j].erase(par);
           god.erase(j);
           god.erase(par);
           if (good(par)) {
               god.insert(par);
           }
           ans.push_back({{j, par}, {par, j}});
       }
       else if (grr[j].size() == 1 && gr[j].size() == 0) {
           int par = *grr[j].begin();
           gr[par].erase(j);
           grr[j].erase(par);
           god.erase(j);
           god.erase(par);
           if (grr[par].size() != 0) {
               int to = *grr[par].begin();
               god.erase(to);
               ans.push_back({{par, j}, {to, par}});
               grr[par].erase(to);
               gr[to].erase(par);
               if (good(par)) {
                   god.insert(par);
               }
               if (good(to)) {
                   god.insert(to);
               }
           }
           else {
               cout << "No";
               return 0;
           }
       }
       else if (gr[j].size() == 1 && grr[j].size() == 0) {
           int par = *gr[j].begin();
           grr[par].erase(j);
           gr[j].erase(par);
           god.erase(par);
           god.erase(j);
           if (gr[par].size() != 0) {
               int to = *gr[par].begin();
               god.erase(to);
               gr[par].erase(to);
               grr[to].erase(par);
               ans.push_back({{j, par}, {par, to}});
               if (good(par)) {
                   god.insert(par);
               }
               if (good(to)) {
                   god.insert(to);
               }
           }
           else {
               cout << "No";

               return 0;
           }
       }
   }
   cout << "Yes" << endl;
   for (auto i : ans) {
       cout << i.first.first << ' ' << i.first.second << ' '<< i.second.first << ' ' << i.second.second << endl;
   }
}