#include <iostream>
#include <vector>
//#include <algorithm>

using namespace std;

#define FOR(i, a, b) for(__typeof(b) i = (a); i < (b); ++i)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

//#define int long long

typedef long long ll;
typedef long double ld;
typedef int32_t i32;
typedef pair<int, int> pii;
typedef vector<int> vi;

int l, r, n, xl, xr;
vector<pii> a;
vector<vi> g_l, g_r;
vi vis;

//bool dfs(int i){
//    int res_l = sz(g_l[i]), res_r = sz(g_r[i]);
//    vis[i] = 1;
//    auto [xi, hi] = a[i];
//    if(xi - hi < xl){
//        res_l = INT32_MAX;
//    }
//    if(xi + hi > xr){
//        res_r = INT32_MAX;
//    }
//    for(int j : g_l[i]){
//        if(j < l || j >= r){
//            break;
//        }
//        if(vis[j] == 0){
//            bool res = dfs(j);
//            if(!res){
//                break;
//            }
//            res_l -= 1;
//        }else if(vis[j] == 2){
//            res_l -= 1;
//        }else{
//            break;
//        }
//    }
//    for(int j : g_r[i]){
//        if(j < l || j >= r){
//            break;
//        }
//        if(vis[j] == 0){
//            bool res = dfs(j);
//            if(!res){
//                break;
//            }
//            res_r -= 1;
//        }else if(vis[j] == 2){
//            res_r -= 1;
//        }else{
//            break;
//        }
//    }
//    if(res_l == 0 || res_r == 0){
//        vis[i] = 2;
//        return true;
//    }
//    return false;
//}

void solve(){
    int q; cin >> n >> q;
    g_l.resize(n);
    g_r.resize(n);
    a.resize(n);
    for(auto &[x, h] : a){
        cin >> x >> h;
    }
    xl = a[0].first, xr = a.back().first;
//    cerr << xl << ' ' << xr << endl;
    FOR(i, 0, n){
        auto [xi, hi] = a[i];
        FOR(j, 0, i){
            auto [xj, hj] = a[j];
            if(xi < xj + hj){
                g_r[j].push_back(i);
            }
            if(xi - hi < xj){
                g_l[i].push_back(j);
            }
        }
    }
    FOR(qq, 0, q){
        cin >> l >> r;
        l--;
        vis.assign(n, 0);
        int res = 0;
        vi res_l(n), res_r(n);
        vector<vi> b_l(n), b_r(n);
        vi qu;
        FOR(i, l, r){
            auto [xi, hi] = a[i];
            if(xi - hi < xl){
                res_l[i] = INT32_MAX;
            }else{
                res_l[i] = sz(g_l[i]);
                for(int j : g_l[i]){
                    b_l[j].push_back(i);
                }
                if(res_l[i] == 0 && vis[i] == 0){
                    qu.push_back(i);
                    vis[i] = 1;
                }
            }
            if(xi + hi > xr){
                res_r[i] = INT32_MAX;
            }else{
                res_r[i] = sz(g_r[i]);
                for(int j : g_r[i]){
                    b_r[j].push_back(i);
                }
                if(res_r[i] == 0 && vis[i] == 0){
                    qu.push_back(i);
                    vis[i] = 1;
                }
            }
        }
        while(!qu.empty()){
            int i = qu.back(); qu.pop_back();
            res++;
            for(int j : b_l[i]){
                res_l[j]--;
                if(res_l[j] == 0 && vis[j] == 0){
                    qu.push_back(j);
                    vis[j] = 1;
                }
            }
            for(int j : b_r[i]){
                res_r[j]--;
                if(res_r[j] == 0 && vis[j] == 0){
                    qu.push_back(j);
                    vis[j] = 1;
                }
            }
        }
        cout << res << '\n';
    }
}

i32 main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
//    int t; cin >> t; while(t--) solve();
}