#include <bits/stdc++.h>
using namespace std;
struct superlong{
    vector<int> v;
    bool digit;
    superlong():digit(0){};
    superlong(string s)
    {
        digit = 0;
        reverse(s.begin(), s.end());
        if(s.back() == '-')
        {
            digit = 1;
            s.pop_back();
        }
        for(auto i : s)
            v.push_back(i - '0');
    }
    superlong operator +(superlong s)
    {
        superlong ans("0");
        ans.v.resize(max(s.v.size(), v.size()));
        for(int i = 0; i < ans.v.size(); i++)
        {
            if(v.size() > i)
                ans.v[i] += v[i];
            if(s.v.size() > i)
                ans.v[i] += s.v[i];
            if(ans.v[i] > 9)
            {
                if(ans.v.size() <= i + 1)
                    ans.v.push_back(0);
                ans.v[i + 1] += ans.v[i] / 10;
                ans.v[i] %= 10;
            }
        }
        return ans;
    }
    superlong operator -(superlong s)
    {
        superlong ans("0");
        ans.v.resize(max(s.v.size(), v.size()));
        for(int i = 0; i < ans.v.size(); i++)
        {
            if(v.size() > i)
                ans.v[i] += v[i];
            if(s.v.size() > i)
                ans.v[i] -= s.v[i];
            if(ans.v[i] < 0)
            {
                ans.v[i + 1]--;
                ans.v[i] += 10;
            }
        }
        while(ans.v.size() > 1 && ans.v.back() == 0)
            ans.v.pop_back();
        return ans;
    }
    bool operator <(superlong s)
    {
        if(s.v.size() > v.size())
            return 1;
        if(s.v.size() < v.size())
            return 0;
        for(int i = s.v.size() - 1; i > -1; i--)
        {
            if(v[i] < s.v[i])
                return 1;
            if(v[i] > s.v[i])
                return 0;
        }
        return 0;
    }
};
signed main()
{
    string a;
    string b;
    cin>>a>>b;
    superlong aa(a), bb(b);
    if(aa.digit && bb.digit)
    {
        superlong res = aa + bb;
        cout<<"-";
        reverse(res.v.begin(), res.v.end());
        for(auto i : res.v)
            cout<<i;
        cout<<endl;
        return 0;
    }
    if(!aa.digit && !bb.digit)
    {
        superlong res = aa + bb;
        reverse(res.v.begin(), res.v.end());
        for(auto i : res.v)
            cout<<i;
        cout<<endl;
        return 0;
    }
    if(!aa.digit && bb.digit)
    {
        if(aa < bb)
        {
            superlong res = bb - aa;
            cout<<'-';
            reverse(res.v.begin(), res.v.end());
            for(auto i : res.v)
                cout<<i;
            cout<<endl;
            return 0;
        }
        superlong res = aa - bb;
        reverse(res.v.begin(), res.v.end());
        for(auto i : res.v)
            cout<<i;
        cout<<endl;
        return 0;
    }
    swap(aa, bb);
    if(aa < bb)
    {
        superlong res = bb - aa;
        cout<<'-';
        reverse(res.v.begin(), res.v.end());
        for(auto i : res.v)
            cout<<i;
        cout<<endl;
        return 0;
    }
    superlong res = aa - bb;
    reverse(res.v.begin(), res.v.end());
    for(auto i : res.v)
        cout<<i;
    cout<<endl;
}