#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <chrono>
#include <random>
#include <unordered_map>
#include <unordered_set>

#include <ctime>
using namespace std;
#define sp system("pause")
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define fastio() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define vout(v,c) for(auto i:v)cout<<i<<c;
typedef long long ll;
mt19937 rnd(time(0) + 'm' + 'a' + 's' + 'h' + 'a');
const int MAXN = 871;
int d[MAXN][MAXN];
int fs = 20;
int t[4 * MAXN];
int add[4 * MAXN];
void push(int v, int l, int r)
{
	if (l != r - 1)
	{
		add[2 * v + 1] += add[v];
		add[2 * v + 2] += add[v];
	}
	t[v] += (r - l) * add[v];
	add[v] = 0;
}
int get(int v, int l, int r, int ql, int qr)
{
	
	if (l >= qr || ql >= r) return 0;
	push(v, l, r);
	if (l >= ql && r <= qr)
	{
		return t[v];
	}
	int g1 = get(2 * v + 1, l, (l + r) / 2, ql, qr);
	int g2 = get(2 * v + 2, (l + r) / 2, r, ql, qr);
	return g1 + g2;
}
void upd(int v, int l, int r, int ql, int qr, int x)
{
	
	if (l >= qr || ql >= r) return;
	push(v, l, r);
	if (l >= ql && r <= qr)
	{
		add[v] += x;
		push(v, l, r);
		return;
	}
	upd(2 * v + 1, l, (l + r) / 2, ql, qr, x);
	upd(2 * v + 2, (l + r) / 2, r, ql, qr, x);
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}
int n;
vector<int> stupid(vector<pair<pair<int, int>, int>> queries)
{
	vector<int> ans(n);
	for (int i = 0; i < queries.size(); ++i)
	{
		for (int j = queries[i].first.first - 1; j < queries[i].first.second; ++j) ans[j] += queries[i].second;
	}
	return ans;
}
vector<int> smart(vector<pair<pair<int, int>, int>> queries)
{
	fill(t, t + 4 * MAXN, 0);
	fill(add, add + 4 * MAXN, 0);
	for (int i = 0; i < queries.size(); ++i)
	{
		upd(0, 0, n, queries[i].first.first-1, queries[i].first.second, queries[i].second);
	}
	vector<int> ans(n);
	for (int i = 0; i < n; ++i)
	{
		ans[i] = get(0, 0, n, i, i + 1);
	}
	return ans;
}
signed main()
{
	fastio();
	/*for (int tst = 0;; ++tst)
	{
		n = rnd() % MAXN + 1;
		vector<pair<pair<int, int>, int>> queries;
		int m = rnd() % 800 + 1;
		for (int i = 0; i < m; ++i)
		{
			pair<pair<int, int>, int> keker;
			keker.first.first = rnd() % n + 1;
			keker.first.second = rnd() % (n - keker.first.first + 1) + keker.first.first;
			keker.second = rnd() % 2000 - 1000;
		}
		auto fs = stupid(queries);
		auto ss = smart(queries);
		if (fs != ss)
		{
			cout << n << ' ' << m << endl;
			for (auto i : queries)
			{
				cout << i.first.first << ' ' << i.first.second << ' ' << i.second << endl;
			}
			vout(fs, ' ');
			cout << endl;
			vout(ss, ' ');
			cout << endl;
			sp;
		}
		else
		{
			if (tst % 10000 == 0)
			{
				cout << "OK " << tst << endl;
			}
		}
	}
	int x;
	cin >> x;
	if (x == 1)
	{
		string s;
		cin >> s;
		int m = (s.size() == 10 ? 30 : 100017);
		cout << string(fs, '0') + s + string(m - (int)s.size() - fs, '0') << endl;
	}
	else
	{
		string s;
		cin >> s;
		int n = (s.size() == 30 ? 10 : 100000);
		cout << s.substr(fs, n) << endl;
		return 0;
	}*/
	int x;
	cin >> x;
	if (x == 1)
	{
		int n;
		cin >> n;
		for (int i = 1; i <= n; ++i)
		{
			cout << i << endl;
			int x;
			cin >> x;
		}
	}
	else
	{
		int n;
		cin >> n;
		for (int i = 1; i <= n; ++i)
		{
			int x;
			cin >> x;
			if (x == 0)
			{
				cout << i << endl;
				return 0;
			}
		}
	}
	/*
	for (int i = 0; i < MAXN; ++i) for (int j = 0; j < MAXN; ++j) d[i][j] = rnd();
	for (int i = 0; i < MAXN; ++i) d[i][i] = 0;
	for (int k = 0; k < MAXN; ++k)
	{
		for (int i = 0; i < MAXN; ++i)
		{
			for (int j = 0; j < MAXN; ++j)
			{
				d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
			}
		}
	}
	int n;
	cin >> n;
	if (n == 1)
	{
		cout << 1 << endl;
		int x;
		cin >> x;
		return 0;
	}
	int l = 0, r = n + 1;
	while (r - l > 1)
	{
		int m = (l + r) / 2;
		cout << m << endl;
		int x;
		cin >> x;
		if (x == 0)
		{
			return 0;
		}
		if (x == 1) l = m;
		else r = m;
	}*/
//	sp;
}